Fri Mar  8 14:45:00 2002  Owen Taylor  <otaylor@redhat.com>

	* ======== Released GTK+-2.0 ========

Fri Mar  8 20:41:51 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreestore.c (gtk_tree_store_drag_data_received): handle
	gtk-tree-model-drop-append like the ListStore, includes some
	tweaks to work right with trees

Fri Mar  8 14:22:43 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (gtk_file_selection_init): Some packing
	tweaks.

	* configure.in: Include GLIB_LIBS when checking
	for bind_textdomain_codeset, to catch the case where
	it is in -lintl.

Thu Mar  7 16:46:58 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (validate_visible_area): get rid of really
	bad focus loop.
	(gtk_tree_view_clamp_node_visible): only clamp the node when
	realized.  Need to replace this with scroll_to_cell sometime.
	(gtk_tree_view_header_focus): clickable or reorderable columns are
	focusable, #73656

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_get_widget): fix
	docs to reflect behaviour change, #73682

Fri Mar  8 11:12:32 2002  Owen Taylor  <otaylor@redhat.com>

	* NEWS: Fix version numbers. (Johan Dahlin.)

	* INSTALL.in: Update, just refer to gtk-building.html
	rather than duplicating information.

	* README.in: Add release specific notes.

	* Makefile.am (EXTRA_DIST): Remove TODO and TODO.xml
	from the distribution.

Thu Mar  7 23:29:35 2002  Owen Taylor  <otaylor@redhat.com>

	* NEWS: Final updates for 2.0.0

	* README.in: Updates.

2002-03-08  Tor Lillqvist  <tml@iki.fi>

	* gdk/Makefile.am (LDFLAGS): Add missing .la suffix for	libgdk_pixbuf.

Thu Mar  7 21:32:01 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreestore.c (gtk_tree_store_sort_iter_changed): increase
	value of new_location by one if cmp_a > 0 and we hit the end of
	the list.

Thu Mar  7 10:31:57 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_timer): Fix problem where
	there were two copies of the "do an arrow step" code, 
	one correct for rotated notebooks, one not. (#73855,
	Thomas Leonard.)

Wed Mar  6 23:20:51 2002  Jonathan Blandford  <jrb@redhat.com>
and			  Kristian Rietveld  <kris@gtk.org>

	Finishing touch for 2.0.0 release, fixes #70782, #72729, the
	'stealth' bug and other last-minute minor issues.

	* gtk/gtktreeview.c (gtk_tree_view_bin_expose): set dnd dest line
	drawing right. We can't draw the line at the position of the next
	row, because that one still has to be drawn. So draw everthing at
	a -1 offset.
	(validate_visible_area): add check for invalid descendants and
	NULL scroll_to_path path, get scrolling right.  Also, fix the
	area_above value.  Pretty amazing I got it wrong.
	(get_logical_dest_row): add gtk-tree-model-drop-append magic, so
	dragging a row to the end of the model works right.
	(gtk_tree_view_get_dest_row_at_pos): minor floating point fix
	(gtk_tree_view_start_editing): add call to validate_row
	(gtk_tree_view_tree_to_widget_coords): Never subtract
	HEADER_HEIGHT from y values anymore!!!
	(gtk_tree_view_widget_coords_to_tree): ditto.
	(gtk_tree_view_scroll_to_point): allow -1 as values for the
	scroll_to coords
	(gtk_tree_view_move_cursor_page_up_down): Don't need scroll_to_y
	as clamp_node_visible will make it work.

	* gtk/gtktreestore.c (gtk_tree_store_drag_data_received): also check
	path depth, as we can't get iters from empty paths

	* gtk/gtkliststore.c (gtk_list_store_drag_data_received): handle
	gtk-tree-model-drop-append

	* gtk/gtktreednd.c (gtk_tree_set_row_drag_data): free path_str

	* tests/testtreeflow.c (main): select path where we are scrolling to

2002-03-06  Darin Adler  <darin@bentspoon.com>

	* gtk/gtktreemodelsort.c: (gtk_tree_model_sort_insert_value):
	Update offsets before finding where to insert the new value.

	* gtk/gtktreeview.c: (validate_visible_area): Make sure we redraw when
	we scroll, instead of just updating the scroll position variables.

2002-03-06  Manish Singh  <yosh@gimp.org>

	* gdk/Makefile.am
	* gtk/Makefile.am: rework so that only things that really need to be
	done post install are in the hook

2002-03-06  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkiconfactory.c (get_default_icons): Register 16x16 version
	of properties stock icon.

	* gtk/stock-icons/Makefile.am: Add stock_properties_16.png

Wed Mar  6 00:38:29 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_real_insert_text): Fix various problems
	when truncating the inserted text to fit into the GtkEntry
	size limit of 65kb. (#73119)

Wed Mar  6 00:20:59 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeviewcolumn.c
	(gtk_tree_view_column_cell_process_action): move event handling to
	the process_action function so we can have the event go to
	individual cells.

Tue Mar  5 22:16:58 2002  Owen Taylor  <otaylor@redhat.com>

	* GTK+-2.0.0 rc1

	* docs/tutorial,faq/Makefile.am: Deal with the html directory
	already being there.

	* docs/faq/Makefile.am (EXTRA_DIST): Add gtk-faq.sgml to EXTRA_DIST.

2002-03-05  Manish Singh  <yosh@gimp.org>

	* gdk/Makefile.am
	* gtk/Makefile.am: use install-foo-hook instead of install-foo-local,
        since foo-local is run before the their respective builtin targets
	in automake 1.5

2002-03-05  jacob berkman  <jacob@ximian.com>

	* configure.in: change an == to =

2002-03-06  Tor Lillqvist  <tml@iki.fi>

	* gdk-pixbuf/gdk_pixbuf.rc.in
	* gdk/win32/rc/gdk.rc.in
	* gtk/gtk-win32.rc.in: Use GTK_API_VERSION.

2002-03-05  Manish Singh  <yosh@gimp.org>

	* configure.in: Fix up the freetype checking logic. Suppress
	suprious "no" with --disable-modules.

2002-03-06  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkevents-win32.c (gdk_pointer_grab,
	gdk_pointer_ungrab): Bypass calls to the grab/ungrab functions in
	gdkinput-win32.c, as they don't effectively do anything anyway.
	(build_key_event_state): Set MOD2 bit if key is in AltGr group.
	(gdk_event_translate): Call _gdk_windowing_window_get_offsets()
	each time the offsets are used, on the window they refer to,
	instead of once in the beginning. The window in question might
	change due to event propagation.
	(gdk_event_translate): Set key event group to 0 for non-AltGr
	keys. Do set the SHIFT bit in the key event state also for
	ISO_Left_Tab. Now backtabbing finally works again.

	* gdk/win32/gdkunput-win32.c: Minor debugging output change.

	* gdk/win32/gdkkeys-win32.c (update_keymap): Set VK_TAB mapping to
	Gdk_Tab and GDK_ISO_Left_Tab, like on X11.
	(gdk_keymap_translate_keyboard_state): Add similar code as in the
	non-XKB case on X11 to generate a more correct
	consumed_modifiers. Add debugging output.
	(gdk_keyval_name): Use the U+xxxx format for UCS characters
	encoded as keyvals. Never return NULL, but hex number
	representation if keyval not in table.

	* gdk/win32/gdkwindow-win32.c (gdk_window_focus): Call
	SetFocus(). Doesn't seem to have any harmful effect, and probably
	is close to what this function is supposed to do. But it didn't
	fix GtkCombo as I had hoped.
	(gdk_window_set_type_hint): Don't intern the _NET_WM_* atoms that
	weren't used and wouldn't have any meaning on Win32 anyway.

Tue Mar  5 19:19:19 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_set_focus): When setting
	the focus to NULL, clear the existing focus chain so
	that when we focus into the window again, we start
	at the beginning. (Pointed out by Tim Janik.)

2002-03-06  James Henstridge  <james@daa.com.au>

	* configure.in: libpango is now called libpango-1.0

Tue Mar  5 18:17:31 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_set_fixed_width):
	remove sizing == AUTOSIZE check.  Update docs.

Tue Mar  5 17:43:43 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c (gtk_font_selection_init): Don't
	create ->font_entry, ->font_style_entry at all rather
	than just not showing them to avoid the problem of
	them popping up if gtk_widget_show_all() is done
	on the dialog. (#72913, Charles Kerr.)

Tue Mar  5 18:06:49 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_set_resizable):
	doc fix proposed by tvv@sparc.spb.su (Vitaly Tishkov), #73567.

2002-03-05  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktreemodel.c (gtk_tree_row_reference_deleted): Fix docs.

	* gtk/gtkwindow.c (gtk_window_remove_mnemonic): 
	(gtk_window_add_mnemonic): 
	(gtk_window_mnemonic_activate): Add docs.

	* gtk/gtktreeview.c (gtk_tree_view_get_search_equal_func): Fix
	typo in docs.

Tue Mar  5 17:02:59 2002  Owen Taylor  <otaylor@redhat.com>

	* docs/tutorial/gtk-tut.sgml: s/menu_new/menu_item_new/.
	(#69199, Akira Tagoh.)

Tue Mar  5 16:53:05 2002  Owen Taylor  <otaylor@redhat.com>

	* docs/faq/Makefile.am: Build the docbook version, not
	the old linuxdoc version.

Tue Mar  5 15:47:54 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in test/makefile.msc **.pc.in **/*.am:
	Update version to 2.0.0

	* gtk/Makefile.am (MAINTAINERCLEANFILES): Add stamp
	files.

	* configure.in (GDK_PIXBUF_VERSION): Require GLib 2.0.0,
	Pango, Atk, 1.0.0.

	* m4macros/gtk-2.0.m4: Default to 2.0.0 as the minimum
	version.

2002-03-05  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_size_allocate): don't assign
	yoffset here, just let it get updated in response to the
	value_changed. Fixes #72479

Tue Mar  5 10:29:09 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktreeview.c (do_presize_handler)
	gtk/gtktreeview.c (do_validate_rows): Don't use this 
	same functions as idle callbacks and directly, to avoid
	threading deadlocks. (#72392, Scott Guilbeaux)

	* gtk/gtktable.c (gtk_table_size_request_init): Fix 
	row/column confusion from recent patch. (#73505,
	Vitaly Tishkov.)

2002-03-04  Matthias Clasen  <maclas@gmx.de>

	* docs/tutorial/gtk-tut.sgml: Make color selection and selection 
	examples work.

	* tests/testselection.c (selection_toggled, selection_clear):
	Use selection_widget as selection owner - otherwise clearing the
	selection doesn't work.

Mon Mar  4 12:43:48 2002  Owen Taylor  <otaylor@redhat.com>

        Fixes for non XKB operation. (#73103)

	* gdk/x11/gdkkeys-x11.c (gdk_keymap_translate_keyboard_state):
	Fix problem where GDK_Tab was converted to GDK_ISO_Left_Tab
	always, not just if Shift was pressed.
	
	* gdk/x11/gdkkeys-x11.c gdk/x11/gdkprivate-x11.c 
	gdk/x11/gdkevents-x11.c: Move determination of group
	to _gdk_x11_get_group_for_state(), fix to handle non-XKB.

	* gdk/x11/gdkkeys-x11.c (gdk_keymap_translate_keyboard_state): Only
	add in SHIFT_MASK | LOCK_MASK to consumed_modifiers if the shifted
	and unshifted keysyms are different. Only add in group_switch_mask
	if the group-switched and non-group-switched keysyms are diferent.

	* gdk/x11/gdkkeys-x11.c (gdk_keymap_translate_keyboard_state): 
	When calling XKeycodeToKeysym, use group * keysyms_per_keycode / 2
	not group * keysyms_per_keycode. (Tor Lillqvist)

	* gdk/x11/gdkkeys-x11.c (gdk_keymap_translate_keyboard_state):
	Remove the hack to fudge the return value for GDK_Tab + Shift
	since that didn't work -- it didn't affect the reverse mapping.
	Instead fudge the non-XKB keymap instead.

Mon Mar  4 11:02:18 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (gtk_file_selection_get_selections): Fix
	memory leak. (#73370, Paolo Maggi).

Mon Mar  4 10:35:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_set_current_page): Fix docs
	in terms of what out of range @page_num does. (#73371,
	Vitaly Tishkov.)

2002-03-02  Havoc Pennington  <hp@pobox.com>

	* demos/gtk-demo/editable_cells.c (cell_edited): const fix

Sun Mar  3 18:47:13 2002  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtkwindow.c (gtk_window_parse_geometry): Fix
	to properly take the default window into account by
	setting a flag and in gtk_window_compute_configure_request_size ()
	multiplying by the increments and adding in the base
	size. (#72393)

	* tests/testgtk.c (create_gridded_geometry): Add a
	test for gridded geometry and for gtk_window_parse_geometry().

2002-03-04  Hans Breuer  <hans@breuer.org>

	* gtk/makefile.msc.in : don't build gtk.defs anymore

2002-03-04  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkrc.h: Remove obsolete Win32-only declaration of
	gtk_win32_get_installation_directory().

Sun Mar  3 17:03:30 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.c gtk/gtkmenubar.[ch]: Back out
	changes to propagate keys to parent menu shells, since
	that broke stuff; rather implement ::cycle-focus as
	a key binding on GtkMenuShell rather than on GtkMenuBar.

	* gtk/gtkmenushell.c (gtk_menu_shell_class_init): Add
	add bindings for ::cycle-focus. (In gtkmenubar.c, were 
	mistakently bound to ::move-focus.)

2002-03-03  Tor Lillqvist  <tml@iki.fi>

	* README.win32: Minor edits.

	* config.h.win32.in: Update to match a recent configure-generated
	config.h

Sun Mar  3 15:16:07 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktable.c: When increasing the row or column
	requisitions to make them sufficient for spanning widgets,
	favor rows or columns with expandable children in them.
	(#1261, Jonathan Blandford.)

Sun Mar  3 14:26:33 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.[ch] (_gtk_get_insertion_cursor_gc):
	Centralize lookup and caching of cursor GC's here.

	* gtk/gtkentry.[ch] gtk/gtktextview.[ch] gtk/gtktextdisplay.c
	gtk/gtklabel.c: Move to using _gtk_get_insertion_cursor_gc().

	* gtk/gtkentry.c (gtk_entry_expose): Draw cursors
	under the text, not over the text.

	* gtk/gtkwidget.c (gtk_widget_class_init): add
	a secondary-cursor-color property.

	* gtk/gtkwidget.c (gtk_widget_class_init): Decrease
	the default aspect ratio to 1/25 (0.04).
	
	* tests/testgtkrc (bell_duration): Comment out
	cursor color setting.
	
Sun Mar  3 20:48:12 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenu.c (gtk_menu_set_submenu_navigation_region): change
	offset of cursor corner of navigation region from (-2, 2) to 
	(-2, 0).

2002-03-03  jacob berkman  <jacob@ximian.com>

	* Makefile.am (EXTRA_DIST): add sanitize-la.sh

2002-03-03  Anders Carlsson  <andersca@gnu.org>

	* gdk/x11/gdkwindow-x11.c (gdk_window_move_resize): Fix tyop
	in docs.

Sat Mar  2 03:49:31 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_button_press): move edit
	ifs above _set_cursor code, don't collapse/expand row on double
	click, only activate (#63269)
	(validate_visible_area): add two missing lines (#73161, #73162)

Sun Mar  3 12:13:56 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Fix typo where pangoxft was being
	required instead of pangox. (Reported by Miles
	Lane)

Sun Mar  3 11:12:16 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextlayout.c (add_cursor): When in split cursor
	mode, always add the cursor as both strong and weak
	so that it is drawn with the correct non-split color.

Sun Mar  3 11:05:13 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/Makefile.am (moduledir): Fix
	install location.

Sun Mar  3 10:28:32 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am: add missing dependency of objects on
	gtkmarshalers.h.

	* gtk/Makefile.am gtk/gtk-boxed.defs: Remove completely
	out of date and unused gtk-boxed.defs and the accompanying
	Makefile rule to generate the complete gtk.defs.

2002-03-03  Hans Breuer  <hans@breuer.org>

	* gtk/gtkmain.c : make rewrite_event_for_window() static
	* gtk/gtkrc.c : gtk_rc_clear_realized_style() static

	* gtk/makefile.msc.in : adapt to makeenums build changes

	* gtk.def : sorted alphabetical again

2002-03-03  Sven Neumann  <sven@gimp.org>

	* m4macros/gtk-2.0.m4: lowercase configure --help output.

Sun Mar  3 06:39:19 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkfilesel.c: added compile time switch to put the tree views
	into a hpaned for owen to play with.

	* gtk/gtktreedatalist.c (_gtk_tree_data_list_header_free): 
	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_set_cell_data_func),
	(gtk_tree_view_column_finalize): 
	* gtk/gtktreestore.c (gtk_tree_store_set_default_sort_func),
	(gtk_tree_store_set_sort_func), (gtk_tree_store_finalize): 
	* gtk/gtktreeselection.c (gtk_tree_selection_finalize): 
	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_reset_default_sort_func),
	(gtk_tree_model_sort_set_default_sort_func),
	(gtk_tree_model_sort_set_sort_func):
	* gtk/gtkliststore.c (gtk_list_store_set_default_sort_func),
	(gtk_list_store_set_default_sort_func),
	(gtk_list_store_set_sort_func), (gtk_list_store_finalize): 
	add reentrancy protection around destroy() function invocation.

	* gtk/gtktreeselection.c (gtk_tree_selection_set_select_function): fix
	destroy function invocation (which was missing).

Sat Mar  2 23:08:23 2002  Owen Taylor  <otaylor@redhat.com>

	Fixes for uninstalled operation with module suffixes
	other than .so and in general for platforms like AIX where
	the module suffix isn't predictable. (#72185, problems
	reported by Miroslaw Dobrzanski-Neumann)

	* modules/input/Makefile.am (gtk.immodules): Query .la
	files rather than shared objects in .libs when creating the
	uninstalled gtk.immodules file.

	* gtk/gtkmain.c (_gtk_find_module): Look for .la files
	after looking for the normal soname extension to handle
	cases where the soname extension isn't predictable,
	like AIX.

	* gtk/gtkthemes.c (gtk_theme_engine_load): Don't
	call g_module_build_path... leave that to 
	gtk_rc_find_module_in_path.

	* demos/gtk-demo/main.c (main) demos/pixbuf-init.c (pixbuf_init):
	tests/testgtk.c (test_init): tests/testtext.c (test_init)
	tests/testdnd.c (test_init): Point gdk-pixbuf to .la
	files rather than poking in .libs for .so files.

	* gtk/stock-icons/Makefile.am (gtkstockpixbufs.h): Remove
	.libs from GDK_PIXBUF_MODULEDIR.

Sat Mar  2 20:58:30 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_reparent): Handle NO_WINDOW
	widgets with windows that are children of widget->window.
	(#50279)

	* tests/testgtk.c: Add eventboxes to the example so that
	we are reparenting between different GdkWindows.

Sat Mar  2 20:39:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimagemenuitem.c (gtk_image_menu_item_new_from_stock): 
	Add a note to the docs about how to use this in the 
	context of changeable accelerators. (#72382, Mark Patton)

Sat Mar  2 19:48:10 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Fix missing -lX11 into x_libs with pangoxft.

Fri Mar  1 00:46:49 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Add a --enable-explicit-deps option to control
	whether dependency libraries are written into .la files and .pc
	files.  Default is auto: if static libraries are off and shlib
	dependencies are found, don't write deps.

	* gdk/Makefile.am gtk/Makefile.am sanitize-la.sh: Shell script
	used to strip dependencies out of .la files.

	* Makefile.am: Add a slightly modified distcheck rule that passes
	--enable-gtk-doc to the configure inside.
	(So that 'make dist' succeeds inside.)

	* configure.in: If pango was compiled with
	--disable-explicit-deps, then repeat the checks for X and
	freetype ourselves so we don't depend on linking to libraries
	that pango doesn't reveal in the link line. Add some more paranoia
	for whether what we detect ourselves matches what Pango backends
	we found.
	
2002-03-03  Tor Lillqvist  <tml@iki.fi>

	* configure.in: Output gdk-pixbuf/gdk_pixbuf.rc.

	* gdk/gdk.def
	* gdk/win32/gdkevents-win32.c: Add and (trivially) implement
	gdk_pointer_grab_info_libgtk_only() and
	gdk_keyboard_grab_info_libgtk_only().

2002-03-02  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkevents-win32.c (build_keypress_event): Reorder
	code, keyval should get a value in all cases now.
	(build_keyrelease_event): Set GDK_CONTROL_MASK here, too, if it
	was a control character produced with Alt+keypad digits.
	(gdk_event_translate): Minor cleanups to keyboard input
	handling. Still need more major work.
	
Sat Mar  2 16:12:03 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkradiobutton.c (gtk_radio_button_focus): Don't
	do special focus handling if draw_indicator is not set.
	(#64723, Damon Chaplin.)

Sat Mar  2 15:48:04 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_new_with_max_length,
	gtk_entry_set_max_length): Clamp @max parameter passed in to 
	[0, MAX_SIZE], improve docs. Fix default and range 
	for ::max-length property, range for ::ncursor_position,
	::selection_bound properties. (#55916, Vitaly Tishkov)

	* gtk/gtkmain.c (rewrite_event_for_grabs): Fix typo

Fri Mar  1 18:39:44 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/{gdkevents-x11.c,gdkmain-x11.c,gdkprivate-x11.h,
	gdkwindow-x11.c}: Robustify tracking of pointer grab window.

	* gdk/x11/gdkmain-x11.c: Keep track of current keyboard
	grab window.

	* gdk/x11/gdkmain-x11.c (gdk_pointer_grab_info_libgtk_only,
	gdk_keyboard_grab_info_libgtk_only): Private libgtk => libgtk
	API for finding out current grab information.
	
	* gtk/gtkmain.c (rewrite_event_for_grabs): Rewrite events
	so that the effective behavior of owner_events = TRUE is changed
	to "deliver events to same window group normally" instead
	of "deliver events to same application normally. #69934

	* gtk/gtkrange.c: Use an explicit gtk_grab_add() so that
	it works within the GtkList combo, where there is a 
	owner_events = FALSE gdk_pointer_grab() already in effect.
	(#65006, reported by Damon Chaplin)

Sat Mar  2 14:32:50 2002  Owen Taylor  <otaylor@redhat.com>

        * configure.in: Default to --disable-gtk-doc (avoid Jade
	breakage) and --disable-static (static linking causes
	problems with Xft changes.)

	* autogen.sh: Add --enable-gtk-doc by default.

	* Makefile.am: Add a 'mydistcheck' rule that passes
	--enable-gtk-doc to the configure since that is needed
	for 'make dist'.

	* docs/tutorial/Makefile.am (dist-hook): Don't distribute
	the PDF file. (Rule doesn't work on my system, plus it's
	big.)

	* gtk/Makefile.am: 'make dist' fixes.

Sat Mar  2 13:26:58 2002  Owen Taylor  <otaylor@redhat.com>

        * gtk/Makefile.am: Switch style of stamp file usage.

	* gtk/Makefile.am gtk/typeutils.[ch]: Switch all the exported
	enumeration/fags TYPE variables over to macros for get_type() functions,
	for lazy definition and to get rid of expensive relocations.

	* gtk/gtkiconfactory.[ch] gtk/gtkselection.[ch] gtk/gtkstyle.[ch]
	gtk/gtktextiter.[ch] gtk/gtktexttag.[ch] gtk/gtktreemodel.[ch]
	gtk/gtktypeutils.[ch] gtk/gtkwidget.[ch]: Switch boxed type
	definitions over manually coded get_type() functions.

	* gtk/gtk.def: Updates for above

	* gtk/{genmarshal.pl,makeenums.awk,makeenums.h,maketypes.awk}:
	Remove from CVS, no longer used.

	* configure.in: Remove checks for awk.
	
Sat Mar  2 04:44:10 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkaccelgroup.c (gtk_accel_group_connect_by_path): fix typo.

Fri Mar  1 23:59:35 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_cell_get_size): set
	first_cell to FALSE after first iteration

	* gtk/gtktreeview.c (validate_visible_area): reduce usage of
	GTK_RBNODE_GET_HEIGHT, check for node != NULL,
	(gtk_tree_view_top_row_to_dy): remove call to gtk_adjustment_changed
	(gtk_tree_view_search_iter): select iter after scrolling

2002-03-02  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkitemfactory.c: Remove unneeded Win32 stuff inside #ifdef
	G_OS_WIN32. (Leftover from when gtkitemfactory.c handled files.)

2002-03-01  Tor Lillqvist  <tml@iki.fi>

	* gdk/gdkkeys.c (gdk_keyval_convert_case)
	* gdk/x11/gdkkeys-x11.c (gdk_keyval_convert_case): If the keyval
	to be converted is one of those that consist of a Unicode
	character plus our special flag bit, use the
	g_unichar_to{lower,upper} functions (Bug#73112).

	* gdk/gdkkeys.c (gdk_keyval_convert_case): Drop the #ifdefs for
	the GDK keysym symbols. As we include gdkkeysyms.h, we know they
	are there. And if GDK keysyms some day are added/removed, this
	function needs changes, too, anyway.

Fri Mar  1 17:00:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkpolyreg-generic.c: Fix some reported (but not significant)
	UMR's from purify. (#73160, Morten Welinder)

Fri Mar  1 16:48:19 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkscrolledwindow.c: Initialize the scrollbar spacing
	variable in the class to -1, and then take that to mean
	"default" (3) rather than putting 3 in the class directly.
	This gives us some wiggle room to make it a per-instance
	rather than a per-class property later.

2002-03-01  jacob berkman  <jacob@ximian.com>

	* Makefile.am (install-data-hook): 
	(dist-hook): replace uses of test -e with more portable test -f

Fri Mar  1 14:49:35 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_commit_text): Don't delete
	forward across line boundaries when in overwrite mode.
	(#73145, reported by Ettore Perazzoli)

Fri Mar  1 14:47:39 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_commit_text): Don't
	join up lines.

Fri Mar  1 10:31:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_reorder_child):
	Fix signed-unsigned error that was accidentally causing
	negative values to append, do it intentionally. Fix docs 
	to say that negative values append. (Alexey A. Malyshev,
	#73108) 

2002-03-01 Alexey Malyshev <maa@sparc.spb.su>
	
        * gtk+/gtk/gtkitemfactory.c
	fixed a little type in docs for gtk_notebook_set_show_border()
	
Fri Mar  1 09:05:19 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkitemfactory.c (gtk_item_factory_delete_entries):
	Really make it work for paths with underline accelerators. (#69247)

2002-02-28  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (gtk_text_view_finalize): free the tab array
	for custom tabs, reported by Paolo Maggi #72980
	
Thu Feb 28 19:55:01 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkkeys.c: include gdkkeysysms.h if
	compiling gdk_keyval_convert_case.

	* gtk/gtkmenubar.c (gtk_menu_bar_cycle_focus): Implement
	<Control>Tab <Control><Shift>Tab to cycle between
	all menu bars in a toplevel once one is up.

	* tests/testgtk.c: Add a second menubar, this
	example is already full of crack anyways.

	* gtk/gtkmenushell.c (gtk_menu_shell_key_press): Padd
	unhandled events up to the parent menu shell.

	* gtk/gtkmenuitem.c (gtk_menu_item_select_timeout): Only
	pop up the menu if the parent menu shell is still active.

	* gtk/gtkcontainer.[ch] (_gtk_container_focus_sort): Add a
	old_focus argument, export privately.

2002-02-28  Darin Adler  <darin@bentspoon.com>

	* gtk/gtkfilesel.c: (open_new_dir): Add missing NULL check.

2002-03-01  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkwindow-win32.h (struct _GdkWindowImplWin32): Remove
	the event_mask, it is now in GdkWindowObject.

	* gdk/win32/gdkwindow-win32.c: Change accordingly. Set the
	GDK_STRUCTURE_MASK in gdk_window_set_events(), as it is always set
	in gdk_window_new(), too. (Bug#72921)

	* gdk/win32/gdkevents-win32.c: Change accordingly here, too.
	(vk_from_char): New function, calculates the virtual keycode
	corresponding to the char in a WM_CHAR message.
	(build_keypress_event, build_keyrelease_event): Use it.
	(build_keypress_event): Call ImmReleaseContext() after using the
	input context. This might plug a memory or resource leak.
	(build_key_event_state): Remove #if 0 code.
	(gdk_event_translate): Actually, it would be preferrable to always
	handle just the WM_KEYDOWN and WM_KEYUP messages, not WM_CHAR at
	all, and thus drop the contorted logic with ignore_wm_char etc.

	* gdk/win32/gdkkeys-win32.c: (gdk_keymap_get_entries_for_keyval):
	Debugging output.
	(gdk_keymap_translate_keyboard_state): Return correct value. (But
	_gtk_key_hash_lookup() doesn't check the return value...)

Thu Feb 28 14:49:08 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (gdk_window_foreign_new): Initialize
	private->event_mask from attributes we retrieved for
	the window.

2002-02-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextbuffer.c (save_range): change gravity of start/end
	marks so that text added at either end of the range doesn't end up
	inside the range.
	(gtk_text_buffer_real_insert_range): fix to handle pasting a range
	into itself.

2002-02-28  Sven Neumann  <sven@gimp.org>

	* configure.in: beautified configure --help output.

2002-02-28  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/Makefile.am: Move bdfcursor.c from
	libgdk_win32_la_SOURCES to EXTRA_DIST.

	* gdk/win32/gdkgc-win32.c (gdk_win32_colormap_color_pack): In the
	bitmap case, use just the LSB of the pixel value. Does this match
	X11 semantics? Or should it be pixel!=0?

Wed Feb 27 19:16:50 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (gdk_window_new): 
	* gdk/x11/gdkwindow-x11.c (gdk_window_get_events): 
	* gdk/x11/gdkwindow-x11.c (gdk_window_set_events): 
	* gdk/win32/gdkwindow-win32.c (gdk_window_set_events): 
	* gdk/win32/gdkwindow-win32.c (gdk_window_new): 
	* gdk/gdkwindow.h (struct _GdkWindowObject): 
	* gdk/linux-fb/gdkwindow-fb.c (gdk_window_set_events):
	Save the window's event mask in window->event_mask.

	* gdk/gdkwindow.c (gdk_window_process_updates_internal): Only
	generate expose events if GDK_EXPOSE_MASK is included
	window->event_mask. (#54506)

Wed Feb 27 18:50:29 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_event): Allow focus-change
	events to be sent to unrealized widgets; they aren't
	really normal events in that they have anything to
	do with widget->window. (#72914, Andreas J. Guelzow)

Wed Feb 27 18:39:25 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/stock-icons/Makefile.am: Split big VARIABLES variable
	that was causing overlong lines into 6 variables with 20
	in each one.

Wed Feb 27 18:01:03 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccellabel.c (gtk_accelerator_name) po/POTFILES.in: 
	Mark Ctrl, Shift, Alt for translation.
	(#60590)

	* gtk/gtkfontsel.c: Mark PREVIEW_TEXT for translation.
	(Vlad Harchev, #53223)

Wed Feb 27 17:32:09 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c (gtk_range_get_props): if CAN_FOCUS
	reserve focus_line_width + focus_line_pad extra
	space and draw the focus in that space. #72027.

Wed Feb 27 23:02:55 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkhandlebox.c (gtk_handle_box_realize): minor code cleanup

Wed Feb 27 14:58:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenubar.c (gtk_menu_bar_size_request/allocate): 
	Don't reserve space for border when the shadow type
	for the menubar is "none". (#61843)

	* gtk/gtkmenubar.c (gtk_menu_bar_size_allocate): Fix
	offset for right-justified menu items.

Wed Feb 27 14:45:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktoolbar.c (gtk_toolbar_size_allocate): Go
	back to old style of drawing children over the bevel.
	(#58615)

Wed Feb 27 14:08:26 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/imxim.c: Add ko and zh to the locales
	where this is the default.

Wed Feb 27 12:34:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkiconfactory.c: Register all stock icons
	"unscaled" so that we don't have icons only available
	at some sizes. (#68896)

Wed Feb 27 11:59:05 2002  Owen Taylor  <otaylor@redhat.com>

	Some ASCII vs. locale fixes from Darin Adler (#55837)

	* gtk/gtkcombo.c (gtk_combo_find): Implement real
	case-insensitive comparison using g_utf8_casefold().

	* gtk/gtkaccellabel.c (gtk_accel_label_refetch): Fix
	assignment of gunichar to char by replacing g_unichar_totitle
	with g_ascii_toupper ... the contents would only be ascii
	here anyways.

	* gdk/x11/gdkim-x11.c (_gdk_x11_initialize_locale) 
	* gtk/gtkfontsel.c (gtk_font_selection_show_available_fonts): 
	Replace a calls to g_strcasecmp() with g_ascii_strcasecmp().

2002-02-27  Hans Breuer  <hans@breuer.org>

	* demos/gtk-demo/makefile.msc.in : new file

	* gdk-pixbuf/gtk-pixbuf.rc.in : new file to include
	  version resource
	* gdk-pixbuf/makefile.msc : create and use gdk-pixbuf.res

	* gdk/win32/gdkkeys-win32.c : handle undefined LANG_URDU,
	(gdk_keyval_name) : fix endless looping

	* gtk/gtkfilesel.c : translate_win32_path() static
	* gtk/queryimmodules : print_escaped(), query_module() static

	* gtk/makefile.msc.in : added gtkkeyhash, build gtk-win32.res

	* gtk/stock-icons/makefile.msc : regenerated from directory
	listing (almost all filenames changed)

Wed Feb 27 10:34:46 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c (gtk_range_set_range): After computing
	the clamped value, actually set it. (#62639, Sergey Kuzminov)

Tue Feb 26 22:22:37 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkbox.c (gtk_box_reorder_child): Clean up
	the code so < 0 == end wasn't just a side effect,
	remove most of the manual linked list manipulation
	code in favor of g_list_* functions.

Tue Feb 26 21:44:01 2002  Owen Taylor  <otaylor@redhat.com>

	* config.status config.guess: Remove these files
	from CVS so we more-or-less current versions from
	automake --add-missing. (Reported by Finlay Dobbie,
	#60342)

	* gdk/gdkkeyuni.c: Shouldn't map KP_Enter to '\n',
	or KP_Tab to \t' since we don't map the corresponding
	main keyboard characters in that way. (#61561,
	Padraig O'Briain)

Tue Feb 26 19:45:29 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcombo.c (gtk_combo_set_popdown_strings):
	Call gtk_combo_set_popdown_strings() in case
	the combo is up currently. (#63535, Skip Montaro)

Tue Feb 26 19:38:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_class_init):
	Switch control-home/end and home/end with
	the idea that scrolled windows more typically contain
	vertical sets of controls and to correspond to the bindings
	in GtkTreeView.

Tue Feb 26 19:32:42 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtk[hv]vscale.c (gtk_[hv]scale_expose): Chain
	up before drawing the scale values so that the number
	is drawn in the right place instead of one step 
	back. (#61743, patch from Satyajit Kanungo)

Tue Feb 26 19:16:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/win32/gdkkeys-win32.c (gdk_keyval_name): 
	* gdk/x11/gdkkeys-x11.c (gdk_keyval_name): 
	Make sure Page_Up, Page_Down get those names, not Prior,
	Next.

Tue Feb 26 18:58:49 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccelgroup.c (gtk_accelerator_set_default_mod_mask):
	OR in the three default modifiers to any value passed
	in by the caller, so that the caller won't break the
	the default bindings. (#70142, Jody Goldberg, though he
	wasn't in favor of this particular way of solving it.)

Tue Feb 26 18:47:44 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_add_mnemonic): Append
	mnemonics rather than prepending them so that the 
	order is typically forward rather than typically
	backward. (Partial fix for #52395)

Wed Feb 27 00:45:39 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkarrow.c, gtk/gtkmenuitem.c, gtk/gtkrange.c
	gtk/gtkspinbutton.c gtk/gtkstyle.c: Draw arrows better (without
	extra baseline)

Tue Feb 26 18:38:17 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccellabel.c (gtk_accel_label_refetch): 
	Display any "g_unicode_isgraph()" char literally,
	not just latin1. (#65679)

Tue Feb 26 18:01:10 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_grab_focus): Don't
	focus insensitive widgets. (#68203)
	
	* gtk/gtkentry.c (gtk_entry_state_changed): Clear any
	current selection if we become insensitive. (#68203)

	* gtk/gtkentry.c (gtk_entry_grab_focus): Don't
	select the text if the entry isn't editable. (#67203)

	* gtk/gtkentry.c: Activate keybindings when not editable,
	but supress keybindings that change the text. (#65848, #68203)

	* gtk/gtkentry.c (gtk_entry_set_property): Reset the
	IM context for the entry when it is made not editable.

Tue Feb 26 17:04:44 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c (update_color): Emit ::color_changed
	every time we notify current_color. (Brute force 
	fix for #72470, Matthias Clasen). Some fixes to improve
	reentrancy.

Tue Feb 26 15:04:33 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_enter_text): use
	the cursor position _after_ deleting the text
	as the position to insert at. (#72717, Jan Mynarik)

2002-02-26 Vitaly Tishkov <tvv@sparc.spb.su>

        * gtk/gtktreemodel.c
	misprints in documentation for gtk_tree_row_reference_inserted() 
        and gtk_tree_path_new () are fixed

Tue Feb 26 19:47:16 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (validate_visible_area): take into account
	that a path from a rowref can be NULL. (#72623 and #72650)

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_cell_render_or_focus):
	let focus_rectangle be the same as cell_area for empty cells (#69900)

Tue Feb 26 11:51:56 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkkeyhash.c (_gtk_key_hash_remove_entry): Fix
	double free.

Tue Feb 26 10:38:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkkeyhash.c (_gtk_key_hash_lookup_keyval): Handle
	a keyval of 0, by returning an empty list. (#72617,
	Kevin Breit)

2002-02-26  Richard Hult  <rhult@codefactory.se>

	* gtk/gtktreeview.c (gtk_tree_view_expand_all): Fix
	#72586. Silently accept empty tree.
	(gtk_tree_view_collapse_all): Likewise.

2002-02-26  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtk.def: A couple of name changes.

Mon Feb 25 22:10:47 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_class_init): Fix
	double set of bindings for page-up/down. (#72605, Tor Lillqvist)

	* gtk/gtkmenu.c (gtk_menu_key_press): Remove consumed modiifers
	when setting up accelerator to make accelerators look prettier.
	(#65416, Guillermo S. Romero)

2002-02-26  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkkeys-win32.c: Implement the functions that until
	now just were non-functional stubs. For "hardware keycodes", we
	use Windows virtual keycodes. Not scancodes, although that at
	first might seem more low-level and a better match to X11
	keycodes. 

	The Windows API is really mixed up and confused with respect to
	scancodes and virtual keycodes. (Surprised?) Some scancodes are
	generated by two keys on the keyboard (!), and although the
	keyboard messages do have a flag to indicate which key the user
	pressed, other API that take a scan code as input don't let you
	specify which actual key you mean.

	(update_keymap): Function to build a X11-like representation of
	the keyboard. Each key has four keysyms: two levels (nonshifted
	and shifted) and two groups (normal and with AltGr).

	(gdk_keymap_get_direction): Use the codepage corresponding to the
	thread's input locale, not the system codepage.

	* gdk/win32/gdkglobals.h
	* gdk/win32/gdkmain-win32.c
	* gdk/win32/gdkprivate-win32.h
	* gdk/win32/gdkwindow-win32.h
	* gdk/win32/gdkwindow-win32.c: Remove the input_locale and
	charset_info fields from GdkWindowImplWin32. Input locale is
	per-thread in Windows, and as GDK on Windows really only works
	when the GDI interaction all happens in just one thread anyway,
	this state can be global. Use globals _gdk_input_locale and
	_gdk_input_codepage instead. Set these based on the thread's input
	locale (keyboard layout, or which IME is active).

	* gdk/win32/gdkevents-win32.c: Set the group and hardware_keycode
	fields in GDK key events. On input locale change messages, set
	the global state variables, and inform update_keymap() that it
	has to rebuild the keymap.
	
2002-02-25  Matthias Clasen  <maclas@gmx.de>

	* docs/tutorial/gtk-tut.sgml: Fix typos in pkg-config 
	invokations.  (#72476) 

Mon Feb 25 18:59:27 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.c (start_keyboard_mode): Set the keyboard-mode
	flag before popping up the tooltip so that pop it up
	in the right place. (#71917, Narayani Pattipati)

Mon Feb 25 22:11:34 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_set_visible): call
	_gtk_tree_view_column_cell_set_dirty when visible, so this column
	gets some space allocated. (#70996)

	* gtk/gtkliststore.c (gtk_list_store_get_path): add simple
	optimization for the tail case
	(gtk_list_store_real_set_value): remove unneeded _get_path calls

Mon Feb 25 12:47:25 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkkeys-x11.c (gdk_keymap_translate_keyboard_state): 
	Fix precendence problem. (Sven Neumann)

Sun Feb 24 23:23:28 2002  Owen Taylor  <otaylor@redhat.com>

	* tests/testselection.c (main): Convert over to using
	an GtkInvisible - selections don't work properly
	with now NO_WINDOW GtkToggleButton. (Example really
	should be using GtkClipboard.)

	* gdk/x11/gdkselection-x11.c (gdk_selection_property_get):
	Fix  problems if sizeof(GdkAtom) != sizeof(Atom). (Unlikely)

	* gdk/x11/gdkproperty-x11.c (gdk_property_get): Set 
	actual_length when converting atoms as well.
	(Gregory Merchan, #72074)

2002-02-24  Havoc Pennington  <hp@pobox.com>
	
	* gtk/gtktextview.c (gtk_text_view_value_changed): add dx/dy to
	child allocation, don't subtract them. Also, copy code from CList
	to recursively adjust the child allocation, instead of just 
	adjusting immediate children. #69115

2002-02-24  Havoc Pennington  <hp@pobox.com>

	* gtk/gtkstyle.c (_gtk_draw_insertion_cursor): change to pass in
	the cursor direction always, not just when we need an arrow, so we
	can flip the cursor around its axis for RTL. Resolves #72372

	* gtk/gtkentry.c (gtk_entry_draw_cursor): update for
	draw_insertion_cursor change
	
	* gtk/gtklabel.c (gtk_label_draw_cursor): ditto

	* gtk/gtktextdisplay.c (gtk_text_layout_draw): ditto
	
2002-02-24  Alexander Larsson  <alla@lysator.liu.se>

	* gdk/x11/gdkwindow-x11.c (gdk_window_set_background):
	Always NULL out bg_pixmap, even when it used to be None
	or parent relative.

2002-02-24  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextbuffer.c (parent_class): parent_class variable was
	GtkObjectClass instead of GObjectClass

	* gtk/gtktextview.c (widget_to_buffer): fix this the way 
	buffer_to_widget was fixed, to avoid duplicating 
	the code that computes text_window->allocation.x/y

Sun Feb 24 21:18:20 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.c (gtk_socket_end_embedding): Fix
	off-by-one error. (Pointed out by Anders Carlsson)

2002-02-25  Matthias Clasen  <maclas@gmx.de>

	* docs/tutorial/gtk-tut.sgml, docs/tutorial/images/*, examples/*: More
	 GTK+ 2.0 updates.

	* docs/tutorial/Makefile.am: build and dist the new tutorial, not
	the old Linuxdoc one.

Mon Feb 25 01:14:26 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktextlayout.c (find_display_line_above): free iter before
	going to done

	* gtk/gtktreeview.c (validate_visible_area): free above_path,
	(set_destination_row): free path before returning,
	(gtk_tree_view_set_drag_dest_row): free current_dest

Sun Feb 24 14:15:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextview.c (widget_to_buffer): Take border
	width into account.

	* gtk/gtklabel.c (get_label_wrap_width): Don't use GdkFont
	to compute wrap width ... GdkFont will pull in X11 core
	fonts.

Sun Feb 24 00:06:58 2002  Owen Taylor  <otaylor@redhat.com>

	* Released 1.3.15.

	* configure.in: Version 1.3.15, binary, interface age 0.

	* NEWS: Updates

	* configure.in: Update version requirements.

Sat Feb 23 22:37:23 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c (gtk_style_init): Sanity check default
	font family name and size.

	* gtk/gtkwindow.c (gtk_window_set_default_size): Remove
	incorrect comment about the geometry widget.

	* gtk/gtkwindow.c (gtk_window_move_resize): Unset the
	gtk_window_resize)() information once we've set the size
	once, to avoid it coming back next time we queue a resize.
	(#72359)

	* gtk/gtkwindow.c (gtk_window_move_resize): Remove
	sething of ->need_default_position from here, Havoc
	says that it should correspond more or less exactly
	to GTK_WIDGET_MAPPED (window).

Sat Feb 23 23:00:48 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodel.h: add () to function macros as per owen's
	request.

	* gtk/gtkfontsel.c: (gtk_font_selection_select_best_style),
	(gtk_font_selection_show_available_sizes),
	(gtk_font_selection_set_font_name):
	* gtk/gtktreemodel.c: (gtk_tree_model_get_iter_first),
	(gtk_tree_model_foreach):
	* gtk/gtktreemodelsort.c: (gtk_tree_model_sort_sort_level),
	(gtk_tree_model_sort_build_level):
	* gtk/gtktreeselection.c: (gtk_tree_selection_selected_foreach):
	* gtk/gtktreeview.c: (validate_visible_area),
	(gtk_tree_view_focus_to_cursor), (gtk_tree_view_set_model),
	(gtk_tree_view_map_expanded_rows), (gtk_tree_view_search_move),
	(gtk_tree_view_search_init):
	* tests/testtreeview.c: (run_automated_tests): change iter_root
	to iter_first

Sat Feb 23 22:10:52 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodel.c (gtk_tree_path_new_first): change new_root to
	new_first to avoid confusion.
	(gtk_tree_model_get_iter_first): ditto.

Sat Feb 23 20:59:05 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c gtk/gtkrc.[ch]: gtk/gtksettings.c gtk/gtkstyle.c:
	Patch from Richard Hestilow to add a gtk-font-name GtkSetting.

	* gdk/x11/gdkevents-x11.c: Add Gtk/FontName XSETTING.

2002-02-24  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkfilesel.c: Move inclusion of <windows.h> before inclusion
	of <winsock.h>, to actually get STRICT prototypes for Win32
	API. Include glib.h early to get G_OS_WIN32 and G_WITH_CYGWIN.
	Don't declare static functions that aren't defined if !HAVE_PWD_H
	or if G_OS_WIN32.
	(win32_gtk_add_drives_to_dir_list): Remove #if 0 code, reindent.
	(gtk_file_selection_get_selections): Don't crash if nothing has
	been selected.

Sat Feb 23 20:33:29 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkplug.[ch] gtk/gtksocket.[ch] gtk/xembed.h: Implement 
	accelerator propagation using a custom XEMBED_GTK_KEY_GRAB
	XEMBED_GTK_KEY_UNGRAB pair of messages.

	* gtk/gtkwindow.[ch]: private export _gtk_window_keys_foreach().

	* gtk/gtkplug.c (gtk_plug_set_is_child): Clear focus and default
	widgets.

2002-02-23  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextbuffer.c (save_range): change gravity of start/end
	marks so that text added at either end of the range doesn't end up
	inside the range.
	(gtk_text_buffer_real_insert_range): fix to handle pasting a range
	into itself. #71412
	
Sat Feb 23 19:05:34 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (validate_visible_area): Didn't refind node
	when it was NULL.  Bug found by Tor Lillqvist.

2002-02-24  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkevents-win32.c (build_keypress_event,
	build_keyrelease_event, gdk_event_translate): Set also group in
	the key press/release events, always to zero for now.

2002-02-24  Anders Carlsson  <andersca@gnu.org>

	* gtk/stock-icons/stock_dialog_error_48.png: 
	* gtk/stock-icons/stock_sort_ascending_16.png:
	* gtk/stock-icons/stock_undelete_24.png: 
	* gtk/stock-icons/stock_sort_descending_16.png: 
	Alpha-pad icons so they get the correct size.
	
Sat Feb 23 16:52:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c: Patch from Matthias Clasen to remove some
	excessive ::changed signals for GtkEntry. (#53130)

2002-02-23  Tor Lillqvist  <tml@iki.fi>

	* gtk-zip.sh.in: Include the gtkrc files for themes.

2002-02-23  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkiconfactory.c (get_default_icons): Register 16x16 
	versions of most icons.

	* gtk/stock-icons: Add 16x16 versions
	of most icons.

Wed Feb 20 16:44:05 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_scroll_to_cell): delay
	scrolling until we try to draw the window.

	* gtk/gtktreeview.c (validate_visible_area): Implement
	scroll_to_cell.

2002-02-23  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtk.def: Add missing gtk_file_selection_get_select_multiple.
	Remove gtk_tree_view_column_cell_* entry points that were made
	private.

Sat Feb 23 15:43:46 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktogglebutton.c: Make button draw depressed whenever
	the user clicks / activates it, whether it's off/on/inconsistent.

Sat Feb 23 11:54:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/*.h gdk/*.h: Massive padding addition to class structures.

	* gtk/gtktextmark.h: Fix a FIXME about G_CONST_RETURN.

Fri Feb 22 20:28:18 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c: Applied patch from Thomas Leonard to make
	stepper click to scroll take effect immediately, rather than after
	a delay (#67649).

	* gtk/gtkrange.c: Remove right-click == step in trough since it
	isn't a useful binding and it's a large area to hit accidentally.
	(Leave it on the steppers since its more useful there and less
	likely to do accidentally.)

2002-02-23  Pablo Saratxaga  <pablo@mandrakesoft.com>

	* configure.in (ALL_LINGUAS): Add "cy" to the language list.

2002-02-23  Jody Goldberg <jody@gnome.org>

	* gtk/gtkaccelgroup.c (gtk_accel_group_connect) : lower case the
	  key_val.
	(gtk_accel_group_connect_by_path) : ditto.
	(gtk_accel_group_disconnect_key) : ditto.

	* gtk/gtkwidget.c (gtk_widget_real_key_release_event) : simplify.
	(gtk_widget_real_key_press_event) : ditto.

Sat Feb 23 00:28:47 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeviecolumn.c: Documented undocumented functions.

	* gtk/gtktreemodel.c: Documented undocumented functions.

Sat Feb 23 03:10:20 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_key_press): honor min_width and
	max_width while resizing columns (pointed out by Jorn Baayen)

Fri Feb 22 19:17:46 2002  Owen Taylor  <otaylor@redhat.com>

	Patch from Matthias Clasen (#54488)

	* gtk/gtkwindow.c: Set/unset HAS_FOCUS flags here,
	and do ::has-focus notifications.

	* gtk/gtkclist.c gtk/gtkentry.c gtk/gtksocket.c
	gtk/gtktext.c gtk/gtktextview.c gtk/gtkwidget.c:
	Remove unecessary focus_in/out handles and unecessary
	flag setting.

	* gtk/gtkwidget.c: Adda missing notification on ::parent.

Fri Feb 22 18:36:45 2002  Owen Taylor  <otaylor@redhat.com>

	Fixes for AIX compilation from Miroslaw Dobrzanski-Neumann,
	#72182.

	* demos/gtk-demo/main.c gtk/gtktreeview.c gtk/gtktoolbar.c
	gtk/gtkpaned.c gtk/gtkobject.c gtk/gtkcontainer.c 
	gtk/gtkcolorsel.c gtk/gtkcellrender.c gdk/x11/xsettings-client.h:
	Squash trailing commas on enumerations.

	* gdk/gdktypes.h: Drop GDK_RELEASE_MASK to 1 << 30 instead
	of 1 << 31 to work around AIX compiler problem. (C standard
	seems to imply that compiler is required to use an unsigned
	type for the enum value in this case.)

	* gdk/gdkpixbuf-drawable.c: Fix lvalue casts.

	* gtk/gtkwindow.h: Fix use of enum types for bitfields ... 
	compilers may choose to use a signed type for bitfields.

Sat Feb 23 00:34:01 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (validate_rows_handler): leave threads before
	returning (#72045)

2002-02-22  Anders Carlsson  <andersca@gnu.org>

	* gtk/stock-icons/*: Rename icons.
	
	* gtk/stock-icons/Makefile.am: Update for new icon names.

	* gtk/gtkiconfactory.c (init_icon_sizes): Set the 
	GTK_ICON_SIZE_BUTTON size to be 20x20.
	(get_default_icons): Change stock names.

Fri Feb 22 22:39:59 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeprivate.h: add last_single_clicked and
	last_single_clicked_2 rowrefs and add disable_popdown to the
	bitfield

	* gtk/gtktreeview.c (gtk_tree_view_destroy): add destroy stuff
	for two new rowrefs
	(gtk_tree_view_button_press): add some 'advanced' button handling,	
	so double click is being handled right (double click madness was
	discovered by Anders Carlsson)

	* gtk/gtktreeview.c (gtk_tree_view_set_property): add missing
	break
	(gtk_tree_view_class_init): default value of headers_visible
	should be TRUE (both pointed out by Damon Chaplin, #71986)

	* gtk/gtktreeview.c (gtk_tree_view_real_start_interactive_search):
	connect to populate_popup,
	(gtk_tree_view_search_disable_popdown): new function,
	(gtk_tree_view_real_search_enable_popdown): ditto,
	(gtk_tree_view_search_enable_popdown): ditto,
	(gtk_tree_view_search_dialog_destroy): check for
	gtk-tree-view-popdown-disabled (#71868)

	* gtk/gtktreeview.c (gtk_tree_view_set_reorderable): move
	->priv->reorderable assignment to bottom. (#72122)

2002-02-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtkstyle.c (_gtk_draw_insertion_cursor): subtract 1 from
	line endpoint, to avoid cursor dirt in the text widget.
	zero-width lines appear to draw the endpoint always. #67999

2002-02-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (buffer_to_widget): implement more cleanly by
	using text_window->allocation.x/y instead of recomputing it. 
	Fixes a bug caused by leaving out the border width here.

2002-02-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (changed_handler): call
	gtk_size_group_queue_resize to avoid invalidating the widget every
	time its requisition changes. Instead we use the btree invalid
	lines to know what to redraw. Fixes #71429

Fri Feb 22 14:08:38 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkradiobutton.c, gtk/gtkcheckbutton.c, gtkbutton.h,
	gtktogglebutton.c: feedback when check and radio buttons are
	depressed.	

2002-02-22  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktreeview.c (gtk_tree_view_set_reorderable):
	s/columns/rows/ in docs.  (#70199)

	* gtk/gtktreestore.c (gtk_tree_store_insert): s/before/after/ in 
	docs. (#71852, #68405)

	* gtk/gtkcalendar.c (gtk_calendar_select_day): Correct a comment.

Thu Feb 21 23:02:29 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.[ch]: add keynav handling for unselect all,
	focus column header, change focus with arrow keys in column headers,
	column reordering, column resizing, small try to fix page up/down
	(this fixes #70889, and fixes a great deal of #53580)

Thu Feb 21 16:51:17 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccelgroup.c (gtk_accelerator_valid): Add
	GDK_ISO_Next_Group/Prev_Group/Level3_Shift/
	First_Group/Last_Group to list of invalid accelerators.
	(A lot more that should be added, but probably would
	want a range mechanism. These are the ones found in
	the standard XFree86 config files.)

	* gtk/gtkbindings.c (gtk_bindings_activate): Fix problem
	that broke bindings for menus.

	* gtk/gtkwindow.[ch]: Export _gtk_window_activate_key()
	privately.

	* gtk/gtkmenushell.c (gtk_menu_shell_key_press): Use
	_gtk_window_activate_key(), gtk_bindings_activate_event().

Thu Feb 21 12:24:22 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkctree.c (gtk_ctree_class_init): Remove some workarounds
	for +/= and shift key handling.

Wed Feb 20 14:26:47 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkkeyhash.[ch]: Implement "fuzzy" key binding lookups;
	allow matches on key and level but not group. Also, implement 
	ignoring "consumed modifiers correctly."

	* gtk/gtkaccelgroup.c gtk/gtkbindings.c: Convert to using
	GtkKeyHash.
	
	* gtk/gtkdebug.h gtk/gtkmain.c: Support GTK_DEBUG=keybindings

	* gdk/x11/gdkevents-x11.c (gdk_event_translate): Fill in
	the group for key release events as well as key press events.

	* gdk/gdkkeys.h gdk/x11/gdkkeys-x11.c (gdk_keymap_translate_keyboard_state): 
	Rename unused_modifiers to consumed_modifiers, make the docs and
	non-Xkb implementation match the Xkb implementation.

	* gdk/linux-fb/gdkkeyboard-fb.c gdk/win32/gdkkeys-win32.c: Propagate
	doc and parameter name changes.

	* gdk/x11/gdkkeys-x11.c (gdk_keymap_translate_keyboard_state):
	XkbTranslateKeyCode doesn't handle LockMask, we need to handle
	it ourselves.

	* gdk/x11/gdkkeys-x11.c (gdk_keymap_translate_keyboard_state): Force
	<Shift>Tab to give GDK_ISO_Left_Tab, since we need consistency
	to allow dealing with ISO_Left_Tab.
	
	* gtk/gtkwindow.c gtk/gtktextview.c gtk/gtkscrolledwindow.c
	gtk/gtkpaned.c gtk/gtkcombo.c  gtk/gtknotebook.c:
	Remove inappropriate uses of GDK_ISO_Left_Tab. (GDK_ISO_Left_Tab
	or <Shift>Tab both are equivalent as a binding specifier.)

	* gtk/gtkbutton.c (gtk_button_class_init): Make ::activate
	GTK_RUN_ACTION, so you can bind an accelerator to it.

	* gtk/gtklabel.c (gtk_label_set_uline_text_internal): Call 
	gdk_unicode_to_keyval on the mnemonic character.

	* tests/testgtk.c: Add a test for the new fuzzy key binding matching.

2002-02-21  jacob berkman  <jacob@ximian.com>

	* gtk/theme-bits/Makefile.am (EXTRA_DIST): inconsitent files are
	.pngs too

Wed Feb 20 21:52:13 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkselection.c (gtk_selection_request): Set the property
	as type ATOM_PAIR, not ATOM. (#72074, Gregory Merchan.)

	* gdk/x11/gdk{property,selecton}-x11.c: Auto-convert properties
	of type ATOM_PAIR as well as properties of type ATOM.

2002-02-21  Matthias Clasen  <maclas@gmx.de>

	* docs/tutorial/images/*.png: screenshots of examples.
	
	* docs/tutorial/gtk-tut.sgml: remove deprecated widgets, add
	screenshots, fix chapters 1-4 for GTK+ 2.0. 

	* demos/gtk-demo/Makefile.am (INCLUDES): add -DGDK_PIXBUF_DISABLE_DEPRECATED.

Thu Feb 21 00:31:41 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkspinbutton.c: Many cleanups and fixes. Draw exclusively
	in expose handler. Feedback when buttons are depressed.

	* gtk/gtkstyle.c: update for changes in gtkspinbutton.c. Fix
	spinbuttons for RTL langauges.

Wed Feb 20 23:00:08 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkstyle.c: new radio buttons. handle inconsistent state for
	check- and radiobuttons.

	* gtk/theme-bits/check-13-inconsistent.png,
	gtk/theme-bits/radio-13-inconsistent.png: new files

	* gtk/theme-bits/radio-13.png: new radio buttons

	* gtk/theme-bits/Makefile.am (EXTRA_DIST): add new
	-inconsistent.png files

Wed Feb 20 16:19:49 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c: Add a XSETTING mapping for
	gtk-can-change-accels. (#70218, Thomas Leonard.)

2002-02-20  Sven Neumann  <sven@gimp.org>

	* gtk/gtkcolorsel.c (gtk_color_selection_finalize): check
	handler_id before disconnecting the signal handler since it might
	have never been connected if the GtkColorSelection is destroyed
	before it was realized.

2002-02-20  Matthias Clasen  <maclas@gmx.de>

	* docs/tutorial/gtk-tut.sgml: Fold back Svens g_signal fixes from
	the examples.  

	* docs/tutorial/gtk-tut.sgml, examples/progressbar/progressbar.c,
	examples/progressbar/Makefile: Make the progressbar example 
	deprecation-clean.

Tue Feb 19 22:10:59 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_mnemonic_activate): new
	function
	(gtk_tree_view_column_create_button): use g_signal_* instead of
	gtk_signal_*, hook up _mnemonic_activate callback
	(gtk_tree_view_column_update_button): use
	gtk_label_set_text_width_mnemonic instead of gtk_label_set_text
	(#69095)

	* gtk/gtktreeview.c (gtk_tree_view_class_init): remove key bindings
	for C-f and C-b, let treeview search use C-f (instead of C-s)
	(#61866)

	* gtk/gtkrc.key.emacs: add some GtkTreeView bindings

Tue Feb 19 20:56:32 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/theme-bits/decompose-bits.c (do_part): fix bug (skipping all
	black pixels).

2002-02-19  Sven Neumann  <sven@gimp.org>

	* examples/*/*.c: finish conversion to g_signal_* functions by
	using G_OBJECT and G_CALLBACK and other assorted changes.

Tue Feb 19 17:36:31 2002  Kristian Rietveld  <kris@gtk.org>

	* gtktreeprivate.h, gtktreeviewcolumn.[ch], gtktreeview.c: change
	gtk_tree_view_column_cell_render,
	gtk_tree_view_column_cell_focus,
	gtk_tree_view_column_cell_draw_focus and
	gtk_tree_view_column_cell_set_dirty to be private functions.

	* gtktreeviewcolumn.[ch]: add install_handler argument to
	_cell_set_dirty to control if _mark_rows_col_dirty (which calls
	install_presize_handler) gets called, set widths correctly so
	autosizing works (#71870)

	* gtktreeview.c (gtk_tree_view_column_autosize): new function,
	(gtk_tree_view_button_press): make double click on column
	separator resize the row (#71870)
	(gtk_tree_view_get_dest_row_at_pos): change DnD threshold to 33%
	(#71869, suggestion by Anders Carlsson)

Mon Feb 18 23:16:16 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.[ch]: Add routines _gtk_find_module(),
	_gtk_get_module_path() to look up a module of an arbitrary type in
	a standard fashion. (#68474)

	* gtk/gtkrc.c: Make module_path keyword warn and do
	nothing. Remove the im_module_path keyword.

	* gtk/gtkrc.c (gtk_rc_get_im_module_path): Fix
	to return the standard path instead of one determined
	from im_module_path and GTK_IM_MODULE_PATH.
	
	* gtk+-2.0.pc.in: Add gtk_host to go along with gtk_binary_version.

2002-02-19  Matthias Clasen  <maclas@gmx.de>

	* docs/tutorial/gtk-tut.sgml, docs/examples/*: Trivial formatting
	fixes to all examples, simple functional fixes to rangewidgets example.

Mon Feb 18 18:27:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c (gtk_font_selection_set_font_name): Select
	the right item in the family list. (Reported by Mark Patton,
	Patch from Satajyit Kanungo, #64240)

	* gtk/gtkfontsel.c (gtk_font_selection_set_font_name): Update
	the size and face entry lists as well, fix memory leak.
	(Also #64240)

	* gtk/gtkfontsel.c (gtk_font_selection_show_available_sizes): 
	Allow fractional sizes, unselect the selected row if none
	matches.

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_focus): Fix
	a bug where the scrolled window would always get focus
	when focusing out of the child.

2002-02-18  Hans Breuer  <hans@breuer.org>

	* gdk/win32/gdkevents-win32.c : process WM_PAINT messages
	for bg_pixmap == GDK_NO_BG, fixes The GIMP's canvas
	rendering glitches on win32

	* gdk/win32/gdkinput-win32.c : use g_object_new to create
	GdkDevice instead of g_new
 
	* gtk/gtkpaned.c : make LAST_SIGNAL the last in enum. 
	This avoids to smash totally unrelated static data and
	resulting random crashes. (as reported on gtk-devel-list, 
	2002-02-10 : testgtk crashes)

	* gtk/gtk.def : add new file selection entry points

Mon Feb 18 17:34:43 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c gtk/gtktextview.c: Remove support for
	the poorly defined text/plain type for now. (#55117)

Mon Feb 18 16:44:00 2002  Owen Taylor  <otaylor@redhat.com>

	* docs/widget_system.txt: Add some docs for GTK_NEED_REQUEST
	GTK_NEED_ALLOCATION.

	* gtk/gtkmenu.c (gtk_menu_popup): Scroll the menu
	to the right place before showing the menu to
	avoid spurious enter events.

	* gtk/gtkmenu.c (gtk_menu_realize): Only scroll
	if there is an active menu item.

	* gtk/gtkwidget.c (gtk_widget_init): Set RESIZE_NEEDED
	ALLOC_NEEDED initially.

2002-02-18  Matthias Clasen  <maclas@gmx.de>

	* NEWS: fix version number.

2002-02-18  Manish Singh  <yosh@gimp.org>

	* Makefile.am: don't comment out the lines to dist the packer
	example, just simply remove it. (the continuation line confused
	make even though it was in the comment, barf)

Mon Feb 18 14:40:22 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcombo.c (gtk_combo_popdown_list): Fix problems
	with stuck grab (#60132, reported by Nicolas Setton) and
	stuck prelighting. Combine duplicated code in three
	places for popping down the list.

Mon Feb 18 14:17:59 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (adjust_adjustments) 
	* gtk/gtklayout.c (gtk_layout_size_allocate)
	* gtk/gtktextview.c (gtk_text_view_size_allocate) 
	* gtk/gtktreeview.c (gtk_tree_view_size_allocate) 
	* gtk/gtkviewport.c (gtk_viewport_size_allocate):
	Standardize on a page increment of page minus 1 line
	rather than half a page (#51027, Eric Fischer)

	* gtk/gtkviewport.c (gtk_viewport_size_allocate): 
	Change step increment to be 0.1 * page_size height rather than
	a fixed 10 pixels.

Mon Feb 18 12:31:52 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimcontextsimple.c (gtk_im_context_simple_filter_keypress): 
	Don't commit unless we got at least one hex digit. (#70619)

Sun Feb 17 21:30:49 2002  Owen Taylor  <otaylor@redhat.com>

	* Released 1.3.14

	* configure.in: Version 1.3.14, interface, binary age 0.

	* gdk/gdkregion-generic.c (miSubtractO): Fix out-of-bounds
	read. (#71619, reported by Morten Welinder)

	* gtk/gtkmenu.c (gtk_menu_class_init): Fix setting default.

	* gtk/gtkfilesel.c (gtk_file_selection_class_init): Add
	a select_multiple property to go along with thenew 
	get/set_select_multiple.

	* gdk/gdkwindow.c: Patch from Soeren Sandmann to improve
	update debugging code. (#71703)

2002-02-17  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkcolor-win32.c (free_colors): Don't set the
	PC_EXPLICIT flag for unused palette entries, that might have
	undesired side effects. Just set them to black. Black is always
	present in a palette, so having superfluous black entries won't
	cause any extra allocations from the system palette either when
	realized.

	* gdk/win32/gdkevents-win32.c
	(gdk_event_translate:WM_QUERYNEWPALETTE): Don't do anything if the
	system visual is static color, i.e. the user has told GDK to use
	just the 16 static colors. In that case no need to redraw
	anything, as the colors are static and by definition always
	correctly mapped in the system palette.
	(WM_PALETTECHANGED): Ditto, no need to call UpdateColors() either.
	
	* gtk/gtk.def: Add new gtkfilesel entry points.

2002-02-17  Matthias Clasen  <maclas@gmx.de>

	* docs/tutorial/gtk-tut.sgml, examples/paned/paned.c, 
	examples/paned/Makefile: Make the paned example deprecation-clean.

2002-02-17  jacob berkman  <jacob@ximian.com>

	* Makefile.am: remove the packer example files as they don't exist
	in CVS.

2002-02-16  Manish Singh  <yosh@gimp.org>

	* tests/testgtk.c: hm, check buttons look better for below.

2002-02-16  Manish Singh  <yosh@gimp.org>

	* tests/testgtk.c: redid the filesel test. Added a way to set select
	multiple as a toggle button, and made show/hide fileops toggle
	buttons as well. get_selections() is called on OK and all the
	filenames selected are printed.

2002-02-17  Tor Lillqvist  <tml@iki.fi>

	* README.win32: Remove comment about the gtk-1-3-win32-production
	branch having more functionality.

	* gdk/win32/*.c: Massive changes. Too many to list here, but I'll
	try a summary:

	1) Unify GdkPixmap and GdkImage implementation: For each
	GdkPixmap, allocate a GdkImage, and vice versa.
	GdkPixmapImplWin32Data has a pointer to the GdkImage.
	GdkImage::windowing_data is a pointer to the GdkPixmap.

	This simplifies many pixmap and image related functions a lot, and
	reduces duplicated code. For instance, there is only one
	place in gdk/win32 where CreateDIBSection() is called, in the
	function _gdk_win32_new_pixmap(). Converting a bitmap (GdkPixmap)
	to a Windows region is almost trivial, with the bitmap bits being
	readily accessible in the associated GdkImage.

	All blitting between GdkPixmaps, GdkWindows and GdkImages goes
	through handled the _gdk_win32_blit() function, which calls
	different functions to handle the cases of blitting from pixmaps,
	inside windows (scrolling), or from windows, which all require
	somewhat different handling.

	2) Support 256-color mode. This has long been very broken, now it
	works more or less OK. Keep the logical palette for each colormap
	as small as possible while allocating and freeing colors. Select
	and realize the logical palette associated with a GdkColormap into
	a DC before drawing or blitting.

	When the display is in 256-color mode, make it possible for the
	user to override the size of the palette(s) used with either the
	GDK_WIN32_MAX_COLORS environment variable, or a -max-colors
	command line option. It is possible to reduce the palette size all
	the way down to using just the 16 static colors (which causes the
	system visual to be of type GDK_VISUAL_STATIC_COLOR. This could
	possibly be useful if one desperately wants to avoid color
	flashing. (Note that in order for this to work properly, an as of
	yet not commited fix to gdkrgb.c is needed.)

	Handle the palette messages. On WM_PALETTECHANGED, call
	UpdateColors() for the given window hierarchy. Do this only if a
	window in some other top-level window hierarchy caused the palette
	change (realized a palette). Do this max five times in a row (an
	arbitrarily chosen limit), though, otherwise redraw by generating
	expose events. On WM_QUERYNEWPALETTE, cause a redraw of the whole
	window hierarchy by generating GDK_EXPOSE events.

	3) Code cleanup in general. For instance, remove the "emulated"
	X11 structs ColormapStruct, Visual and XStandardColormap. Use the
	new GDK_DEBUG_* flags for debugging output in the relevant source
	files. Remove the unused colormap hash table in gdkcolor-win32.c

	4) Plug some resource leaks.

2002-02-14  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkdnd-win32.c (gdk_dropfiles_filter): Use
	g_filename_to_uri() to actually create legal URIs in the
	text/uri-list data.

2002-02-16  Manish Singh  <yosh@gimp.org>

	* gtk/gtkfilesel.[ch]: Added multiple selection API

2002-02-16  Manish Singh  <yosh@gimp.org>

	* gdk/linux-fb/miarc.c: use fabs() on a double instead of abs()

2002-02-17  Matthias Clasen  <maclas@gmx.de>

	More work on #71430.

	* examples/*/Makefile (CFLAGS): add deprecation guards.
	
	* docs/tutorial/gtk-tut.sgml, examples/*/*.c: make most examples
	deprecation-clean; the major offenders right now are the examples
	that make heavy use of completely deprecated or broken widgets:
	list, tree, text, pixmap, paned and progressbar. These will have
	to be redone from scratch.

Sun Feb 17 00:13:06 2002  Kristian Rietveld  <kris@gtk.org>

	This commit lands the 'dy patch'.

	* gtk/gtktreeview.c (validate_rows_handler): update top_row or dy,
	(gtk_tree_view_top_row_to_dy): new function,
	(gtk_tree_view_row_changed): update top_row or dy,
	(gtk_tree_view_rows_reordered): update top_row

2002-02-16  Matthias Clasen  <maclas@gmx.de>

	* demos/Makefile.am (INCLUDES): add -DGDK_PIXBUF_DISABLE_DEPRECATED.

2002-02-16  Matthias Clasen  <maclas@gmx.de>

	* examples/extract.awk: rearrange rules to not emit the example 
	start and end markers.

	* docs/tutorial/gtk-tut.sgml: turn the start and end markers into
	SGML comments, so they don't clutter the formatted tutorial.

2002-02-16  Havoc Pennington  <hp@pobox.com>

	* gtk/gtkwindow.c (gtk_window_parse_geometry): take
	GDK_HINT_RESIZE_INC into account, and handle negative coordinates
	correctly. (Can't email Owen - hope this is OK.)

Fri Feb 15 20:09:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkscrolledwindow.[ch] gtk/gtkmarshallers.list:
	Add key bindings on GtkScrolledWindow for arrow keys,
	PageUp/PageDown Home/End to scroll the window. 
	Bind Control-[Shift]-Tab to focus out of the scrolled
	window entirely. Allow the scrolled window to be
	focused if no child can be focused. (#63480)

	* gtk/gtkwidget.c (gtk_widget_hide): Remove the REALIZED()
	check - if we have visible but not mapped widgets 
	(inside a unshown notebook tab, for instance), we need
	to track their size. (#65087, reported by Damon Chaplin.)

	* gtk/gtkcolorsel.c (palette_change_color): Shut up
	a warning.

2002-02-16  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/rc/Makefile.am (gdk-win32res.lo): Depend on gtk.ico.

	* gdk/win32/rc/gtk.ico: Use the real GTK logo. Thanks to Jernej
	Simoncic for providing the nice multi-resolution .ico file.

2002-02-15 Alexey Malyshev <maa@sparc.spb.su>
	
        * gtk/tmpl/gtkimage.sgml
	removed wrong sentence from gtk_image_new() docs

Fri Feb 15 19:38:00 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreestore.c (gtk_tree_store_clear_traverse): new function
	(gtk_tree_store_clear): traverse the tree, so we emit row_deleted
	for every node. This way we don't have confused row refs crashing the
	application. (#70631)

2002-02-14  Richard Hult  <rhult@codefactory.se>

	* gtk/gtkpaned.c (gtk_paned_enter): Only queue a draw on the
	handle, not the whole widget. #71530.
	(gtk_paned_leave): Likewise.

2002-02-14  Jody Goldberg <jody@gnome.org>

	* gtk/gtkrange.c (gtk_range_class_init) : add new signal
	  'adjust_bounds' to potentialy change the bounds before assigning the
	  new value and camping it to the existing bounds.
	(gtk_range_internal_set_value) : used here. #68800.
	* gtk/gtkmarshalers.list : add VOID:DOUBLE

Thu Feb 14 21:08:49 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkglobals.c: Remove GDKVAR from C file, see
	if anyone complains. (#71317, Morten Welinder.)

2002-02-14  Matthias Clasen  <maclas@gmx.de>

	The following changes are the beginning of the work on #71430.
	
	* examples/extract.sh, examples/extract.awk: Make extraction work.
	
	* examples/Makefile (SUBDIRS): Remove packer.

	* examples/packer/pack.c, examples/packer/Makefile: Removed.

	* docs/tutorial/gtk-tut.sgml: Fix the included examples far
	enough to make them compile and (mostly) work, remove the packer
	example.

Thu Feb 14 16:46:48 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c gtk/gtktextdisplay.c gtk/gtklabel.c
	gtk/gtkstyle.[ch] gtk/gtkwidget.c: Patch from Bill
	Haneman and Padraig O'Briain to add cursor_aspect_ratio
	style property to GtkWidget to allow theming the aspect
	ratio of the cursor.

	* gtk/gtkentry.c gtk/gtktextview.c gtk/gtklabel.c
	gtk/gtkwidget.c tests/testgtkrc: Move cursor-color style property
	to GtkWidget.

Thu Feb 14 11:13:22 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimmulticontext.c (gtk_im_multicontext_get_surrounding): 
	Fix bug where we called get_surrounding on the context,.
	not the slave.

Thu Feb 14 00:10:09 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.c (gtk_tooltips_event_handler): Only
	pop the tooltip down on a select set of events, not
	on any unknown event. (#71157, Jody Goldberg)

	* gtk/gtktooltips.c (gtk_tooltips_event_handler):
	Fix some warnings.

Thu Feb 14 00:02:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcalendar.c (gtk_calendar_size_request): A bunch of
	small allocation/drawing fixes.

	* gtk/gtkcalendar.c: Replace DAY_XPAD, DAY_YPAD with
	GtkWidget::focus-padding

Wed Feb 13 23:01:20 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcalendar.c: Patch from Bill Haneman to draw
	to focus using gtk_paint_focus() with the focus width
	GtkWidget::focus-width. (#63075)

	* gtk/gtkcalendar.c (gtk_calendar_size_request): Initialize
	label_char_ascent/descent to 0. (#56925, reported by
	(Jean-Noel Guiheneuf)

2002-02-13  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_flush_scroll): validate a
	larger area, proportional to widget size, to fix
	#71427 reported by Dennis Bjorklund

2002-02-13  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_paint): just go ahead and flush 
	all the first validate stuff if it hasn't been done, presumably
	someone called process_updates at a weird time.

	* tests/testtext.c (do_apply_colors): terminate on >= end, not >
	end, avoids infinite loop when end is at the end of the buffer.

	* gtk/gtktextbtree.c (_gtk_text_btree_delete): when creating a
	line data, we were adding it to the wrong line ("line" instead of
	"start_line")

2002-02-13  Joe Shaw  <joe@ximian.com>

	* gtk/gtktreeitem.c (gtk_tree_item_expose): Don't chain up to the
	container's expose event.  Instead call
	gtk_tree_item_expose_child() on each child.  Avoids a failed
	g_assert() in gtk_container_propagate_expose().
	(gtk_tree_item_expose_child): Added.  Synthesize an expose event
	for our children.  Basically gtk_container_propagate_expose()
	minus the g_assert().  (#71396)

2002-02-13  Tor Lillqvist  <tml@iki.fi>

	* gdk/gdkinternals.h: Add some more GdkDebugFlags, for more
	fine-grained debugging output (mainly used in the Win32 backend).

	* gdk/gdk.c: Corresponding additions to the gdk_debug_keys table.

Wed Feb 13 15:42:42 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.[ch] gtkwidget.c: Implement Control-F1
	as toggle-tooltips-mode.

	* gtk/gtktooltips.c: Remove parsing of tooltips style
	string from here ... now in gtkrc.c.

Wed Feb 13 12:41:44 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_init_check): g_warning() if setting
	the local fails, like gdk_set_locale() did.

	* gdk/x11/gdkselection-x11.c (gdk_text_property_to_utf8_list): 
	Don't free local_list if local_count == 0. (#71241, reported
	by Kevin Vandersloot.)

	* gdk/x11/gdkselection-x11.c (gdk_text_property_to_text_list): 
	Clean up list == NULL handling and failure.

Wed Feb 13 11:27:31 2002  Owen Taylor  <otaylor@redhat.com>

	* tests/testtreeview.c (typesystem_recurse): Cast GType
	to long and use %ld to fix warning. (#71318, Morten Welinder)

Wed Feb 13 13:26:39 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkmenu.c: fix figuring accel path and changing behaviour.

Wed Feb 13 06:42:37 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtktable.c (gtk_table_size_allocate_pass1): partly revert
	my recent expanding change to not expand the table if all children
	have not epxand behaviour. this fixes palette views which often
	use homogeneous non-expanding tables.

Tue Feb 12 14:27:41 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_row_deleted): emit
	row_deleted before we start unreffing the nodes ourselves
	(gtk_tree_model_sort_increment_stamp): always increment the stamp,
	and not only if the stamp equals 0 (pointed out by Darin Adler)

	* gtk/gtktreemodel.c (gtk_tree_row_ref_deleted_callback): we want
	to continue the while loop and not the nested for loop.

Tue Feb 12 02:19:49 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtktable.c (gtk_table_size_allocate_pass1): always spread out
	the extra space allocated for the homogeneous case, as we don't
	properly deal with readjusting table allocation within it. (for  this
	purpose, a GtkAlignment can be used as table parent).

2002-02-11  Darin Adler  <darin@bentspoon.com>

	* gtk/gtktreemodelsort.c: (gtk_tree_model_sort_row_changed):
	Consider reordering the row even when there's no sort column, if
	there's a default sort function.
	(gtk_tree_model_sort_rows_reordered): Use symbolic constants.
	(gtk_tree_model_sort_level_find_insert): Add code to handle the
	case where there is no sort column, but a default sort function.
	(gtk_tree_model_sort_insert_value): Add code to handle the case
	where there is no sort column an no default sort function.
	(gtk_tree_model_sort_set_model): Use symbolic constant.
	(gtk_tree_model_sort_reset_default_sort_func): Use symbolic constant.

2002-02-11  Sven Neumann  <sven@gimp.org>

	* gtk/gtkfilesel.c: converted the "Delete File" dialog to
	GtkMessageDialog. Marked missing strings for translation.

Mon Feb 11 22:03:15 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkpaned.[ch]: Opaque resizing + prelighting for paned widget.
	* gtk/gtkvpaned.c, gtk/gtkhpaned.c: move reszing logic to gtkpaned.c

Mon Feb 11 21:42:17 2002  Kristian Rietveld  <kris@gtk.org>

	Implements DnD scrolling and fixes #71139

	* gtk/gtktreeview.c (gtk_tree_view_vertical_autoscroll): new function,
	(scroll_row_timeout): new function,
	(gtk_tree_view_drag_motion): create scroll_timeout, so
	scroll_row_timeout gets called

Mon Feb 11 17:54:46 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_size_allocate): set upper
	member of hadjustment correct, so the hscrollbars of lists smaller
	than 1 page (in width) are somewhat saner

2002-02-11  jacob berkman  <jacob@ximian.com>

	* gdk/gdkwindow.h (gdk_get_default_root_window): fix signature to
	match implementation

Mon Feb 11 16:48:34 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkliststore.c (gtk_list_store_set_valist): set value of
	func to NULL during initialization (we don't use func in the
	!SORTED case, so we just silent the compiler here) (#71029)

Mon Feb 11 16:40:44 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_set_model): install presize
	handler, so the validate_rows_handler will always be run (#70997)

Sun Feb 10 22:20:46 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkliststore.c (gtk_list_store_sort_iter_changed): increase
	value of new_location by one if cmp_a > 0 and we hit the end of
	the list and pass NULL instead of a 'NULL-iter' with
	_rows_reordered (#71060)

Sun Feb 10 12:32:44 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/Makefile.am modules/input/{imam-et.c, imti-er.c,
	imti-et.c} po/POTFILES.in: Add three Ethiopic input methods from
	Daniel Yacob.

2002-02-10  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkcalendar.c (gtk_calendar_class_init): Set finalize handler;
	(gtk_calendar_finalize): Rename gtk_calendar_destroy to 
	gtk_calendar_finalize since ::destroy can be called multiple times, 
	resulting in double-freeing memory.

2002-02-10  Hans Breuer  <hans@breuer.org>

	* gdk/win32/gdkgeometry-win32.c : don't reduce the scroll
	rect size by the scroll amount

	* gdk/win32/gdkwindow-win32.c
	* gdk/win32/gdkselection-win32.c : added some casts to
	make it compile with msvc's strict type checking

	* gtk/fnmatch.c : #include <ctype.h> again for tolower
	prototype. The fnmatch() code assumes to be in the crt 
	locale though it is feeded by utf8 strings from gtkfilesel.c

	* gtk/gtkfilesel.c : let ->cmpl_text be a strdup managed by
	_CompletionDir instead of referencing already freed memory

	* gtk/gtktooltips.c (gtk_tooltips_init) : fix typo to
	gtk_rc_parse_string (theDefaultTooltipColor) once as it
	was intended

	* tests/makefile.msc : added more tests

	* tests/testgtk.c (create_list) : don't try to load gtkenums.h
	from the current directory use ../gtk/gtkenums.h instead

2002-02-10  Kjartan Maraas  <kmaraas@gnome.org>

	* gtk/gtksizegroup.c: Fix a double "The" typo in a string.
	
2002-02-09  Matthias Clasen  <matthias@local>

	* gtk/gtknotebook.c (gtk_notebook_set_focus_child): Avoid segfault
	for selectable tab labels (even without a segfault, they make the
	notebook almost unusable, though).  (#69985)

2002-02-08  Matthias Clasen  <matthias@local>

	* gtk/gtkmenuitem.c (gtk_menu_item_set_accel_path): Silently do 
	nothing if the parent is not a menu.  (#66492)

2002-02-06  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkitemfactory.c (gtk_item_factory_from_widget,
	gtk_item_factory_path_from_widget): Try fetching the return value 
	from menu_item->submenu as a fallback.  (#69020)
	
Sat Feb  9 22:57:43 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_build_level): convert
	the iter to a child iter again, after doing _iter_children. It's
	possible that _iter_children added some rows and updated the stamp.

2002-02-09  Daniel Elstner  <daniel.elstner@gmx.net>

	* gtk/gtktextchild.c: Use == rather than = in sanity
	checks.  Ouch!

2002-02-09  Daniel Elstner  <daniel.elstner@gmx.net>

	* gtk/gtktextchild.c (CHECK_IN_BUFFER_RETURN): Add missing
	curled braces so that it doesn't always return.  Also indent
	both CHECK_IN_BUFFER* macros properly, and make use of
	G_STMT_START/G_STMT_END.

Sat Feb  9 13:27:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkbindings.h: Add prototype for
	_gtk_binding_reset_parsed().

Sat Feb  9 13:19:20 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in gtk/Makefile.am gtk/theme-bits/*: Add
	tools and images used for creating the check/radio
	button images in the default theme.

Sat Feb  9 13:58:41 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkpaned.[ch]: Keyboard navigation for GtkPaned
	F6: cycle between panes.
	F8: focus handle (#53584)
	
	* tests/testgtk.c: Add test cases for GtkPaned keyboard 
	navigation.
	
Sat Feb  9 00:16:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkimage-x11.c (_gdk_x11_copy_to_image): 
	XCopyArea with subwindow_mode = IncludeInferiors.
	(#70999)

	* demos/testpixbuf-save.c (configure_cb): Fix a minor
	memory management problem.

Fri Feb  8 20:24:58 2002  Owen Taylor  <otaylor@redhat.com>
	
	* gtk/gtkbindings.c (binding_compose_params): Fix problem
	with string-valued parameters (#70012, Johan Dahlin.)

	* gtk/gtkentry.c (gtk_entry_delete_whitespace): Fix 
	white space deletion.

Fri Feb  8 21:25:56 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_row_deleted): fix
	evil ref bug where the wrong row and a deleted row was unreffed.
	Found by Darin Adler <darin@bentspoon.com>

Fri Feb  8 18:46:13 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkbindings.[ch] (_gtk_binding_reset_parsed): Add
	a function to delete all bindings add by
	gtk_binding_parse_binding() when rereading RC files.

	* gtk/gtkrc.c (gtk_rc_reparse_all_for_settings): Reset
	binding set content as well as RC content.

	* gtk/gtkbindings.c (binding_compose_params): Fix 
	various GValue handling problems.

	* gtk/gtkentry.c (gtk_entry_class_init): Remove bindings 
	for C-b, C-f, M-b, M-f, C-a, C-e, C-w, C-y, M-space, C-u,
	C-k, M-\, M-d, C-d.

	* gtk/gtktextview.c (gtk_text_view_class_init): Remove
	same bindings as GtkEntry, plus C-n, C-p, C-space

        * gtk/gtkrc.key.default gtk/gtkrc.key.emacs gtk/Makefile.am:
	Add Emacs and Default key themes.
	
2002-02-08  Darin Adler  <darin@bentspoon.com>

	* gtk/gtktreeview.c: (gtk_tree_view_map_expanded_rows_helper):
	Remove a tiny bit more dead code.

2002-02-08  Darin Adler  <darin@bentspoon.com>

	* gtk/gtktreeview.c: (gtk_tree_view_map_expanded_rows_helper):
	Fix stale pointer bug.

Fri Feb  8 14:30:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (title_focus_in): Return FALSE if
	not showing the titles. (#70959, Thomas Leonard)

2002-02-08  Darin Adler  <darin@bentspoon.com>

	* demos/gtk-demo/main.c: (load_file): isspace -> g_ascii_isspace
	* gdk/x11/gdkim-x11.c: Remove gdki8n.h include.
	* gdk/x11/gdkkeys-x11.c: Remove <ctype.h> include.
	* gdk/x11/gdkmain-x11.c: Remove <ctype.h> include.
	* gtk/fnmatch.c: Remove <ctype.h> include.
	* gtk/gtkaccelgroup.c: Remove <ctype.h> include.
	* gtk/gtkaccellabel.c: (gtk_accel_label_refetch): toupper ->
	g_unichar_toupper, toupper -> g_unichar_totile
	* gtk/gtkbindings.c: Remove <ctype.h> include.
	* gtk/gtkfontsel.c: Remove <ctype.h> include.
	* gtk/gtkiconfactory.c: Remove <ctype.h> include.
	* gtk/gtkinputdialog.c: Remove <ctype.h> include.
	* gtk/gtklabel.c: Remove <ctype.h> include.
	* gtk/gtkmain.c: Remove <ctype.h> include.
	* gtk/gtkmenu.c: Remove <ctype.h> include.
	* gtk/gtkoldeditable.c: Remove <ctype.h> include.
	* gtk/gtkrc.c: Remove <ctype.h> include.
	* gtk/gtktextbtree.c: Remove <ctype.h> include.
	* gtk/gtktextiter.c: Remove <ctype.h> include.
	* gtk/gtktextsegment.c: Remove <ctype.h> include.

2002-02-08  Sven Neumann  <sven@gimp.org>

	* gtk/gtkfilesel.c
	* gtk/gtkgamma.c
	* gtk/gtkinputdialog.c: use stock labels for dialog action buttons.

2002-02-08  Darin Adler  <darin@bentspoon.com>

	* gtk/gtktreemodelsort.c: (gtk_tree_model_sort_ref_node),
	(gtk_tree_model_sort_unref_node): Pass the ref_node and
	unref_node calls through to the child model.

2002-02-08  Laszlo Peter  <laca@ireland.sun.com>

	* gtk/gtktextchild.c: s/__FUNCTION__/G_GNUC_FUNCTION/
	* gtk/gtktextview.c: ditto

2002-02-07  Havoc Pennington  <hp@pobox.com>

	* gtk/gtkspinbutton.h (struct _GtkSpinButtonClass): add
	change_value virtual function, to fix build

	* gtk/gtkpixmap.c (gtk_pixmap_class_init): parent_class was 
	from GtkWidget not GtkMisc. Not that it ever mattered.

Thu Feb  7 19:52:00 2002  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtknotebook.[ch]: Add ::move-focus-out signal
	to handle Control[-Shift]-Tab and Control-arrow
	bindings and implement bindings as per #53612.

	* gtk/gtktextview.c (gtk_text_view_move_focus): Fix 
	fetching the toplevel for plug-socket.

	* gtk/gtknotebook.c (gtk_notebook_class_init): Remove
	bindings for Return/Enter to select the page.

	* gtk/gtknotebook.c (gtk_notebook_change_current_page):
	Beep at ends.

	* gtk/gtknotebook.c (focus_tabs_move): Don't wrap around
	and beep at ends.

	* gtk/gtknotebook.c (gtk_notebook_focus): When focusing into
	the page with the arrow keys, focus the first widget,
	not the directionally closest widget.

Thu Feb  7 19:00:10 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkspinbutton.c (gtk_spin_button_key_release): Convert
	to using  binding set for doing key bindings. (#62622,
	Requested by Skip Montaro)

	* gtk/gtkwindow.c (gtk_window_class_init): Add control-arrow
	bindings as overrides along with control-tab bindings.

	* gtk/gtknotebook.c (gtk_notebook_class_init): Fix return
	type for ::focus_tab signal.

Thu Feb  7 19:39:27 2002  Kristian Rietveld  <kris@gtk.org>

	Fixes #70782 and some drag dest rectangle/line issues

	* gtk/gtktreeview.c (gtk_tree_view_set_model): set
	GTK_TREE_VIEW_IS_LIST flag (we can switch from a TreeStore to a
	ListStore for example)
	(gtk_tree_view_get_path_at_pos): revert previous change, we
	shouldn't correct for the header, because we are taking bin_window
	coordinates here
	(gtk_tree_view_set_drag_dest_row): queue old drag_dest row and
	upper/lower neighbors for draw, so the drag dest rectangle/line will
	be cleared correctly
	(gtk_tree_view_get_dest_row_at_pos): correct for treeview header
	here, as drag_y is relative to the widget and _get_path_at_pos wants
	coords relative to bin_window, draw black outline rectangle after
	drawing the cells

Thu Feb  7 10:53:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_draw_text): Use layout text
	(which may be affected by invisible char) to compute
	selection bounds, not entry text. (#70733, Alex Larsson)

2002-02-07 Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtkwidget.[ch]:
	Change show_help signal to return gboolean instead of void. This
	allows the keypress which invokes the signal to be propagated to the
	focus widgets ancestors if not handled by the focus widget.
	
	* gtk/gtktoolips.[ch]
	Change _gtk_tooltips_show_tip () to return a gboolean indicating
	whether widget has tooltip to display.
	
2002-02-07 Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtkwidget.[ch]:
	Change popup_menu signal to return gboolean instead of void. This
	allows the keypress which invokes the signal to be propagated to the
	focus widgets ancestors if not handled by the focus widget.

	* gtk/gtkcolorsel.c gtk/gtkentry.c gtk/gtktextview.c:
	Change signature of popup_menu signal handler to return gboolean
	instead of void and return TRUE in the signal handler

2002-02-07  Anders Carlsson  <andersca@gnu.org>

	* gdk/x11/xsettings-common.c (xsettings_setting_free): Free 
	the setting name.

Wed Feb  6 23:28:39 2002  Kristian Rietveld  <kris@gtk.org>

	Fixes #70708

	* gtk/gtktreeview.c (gtk_tree_view_get_path_at_pos): we're dealing
	with widget coordinates here, so take the header height into
	account while converting
	(gtk_tree_view_widget_to_tree_coords): take header height into
	account
	(gtk_tree_view_tree_to_widget_coords): ditto
	(gtk_tree_view_get_dest_row_at_pos): we were passing coords
	relative to the tree with _get_path_at_pos, while that function
	wants coords relative to the widget

2002-02-06  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_scroll_hpages): remove unused variable
	(gtk_text_view_get_window): add warning about how you
	can't get the private window. #70683, and avoid default: in the
	switch so we get "enum value unhandled" warnings

2002-02-06  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextchild.c: Add warnings if you try to use a child
	anchor that isn't inside a buffer. Really kind of lame; 
	we should separate the anchor from the buffer. But not worth 
	fixing for now. #70601

Wed Feb  6 18:25:24 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c: rip out all the debugging ifdefs, as
	modelsort seems to be stable (and nobody complained :)

Tue Feb  5 19:13:42 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkgeometry-x11.c (gdk_window_queue): Keep
	the length of the anti-expose queue finite, by if
	it gets too long, first doing a XSync() and checking
	the event queue, and if that doesn't work, simply
	discarding all anti-expose items in the queue.

	* gdk/x11/gdkdnd-x11.c (gdk_window_cache_filter): Fix ordering
	on ConfigureNotify (#56349, Thomas Leonard)

2002-02-05  Havoc Pennington  <hp@redhat.com>

	* gtk/gtkimage.c (gtk_image_expose): offset area being gotten from
	pixmap by the align/padding offsets, so we don't get warnings
	in gdk_pixbuf_get_from_drawable (and so it works, of course)

2002-02-05  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkrc.c (gtk_rc_parse_file): Remove a (now) misleading comment.

2002-02-05  Federico Mena Quintero  <federico@ximian.com>

	* gdk/gdkwindow.h: Do not #include <gdk/gdkwindow.h>.

Tue Feb  5 22:54:16 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkliststore.c (gtk_list_store_insert_after): let's set the
	path, which we're going to pass with the emission of row_inserted, to
	the iter we inserted and not its sibling.

2002-02-04 Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtkmenu.c (gtk_menu_popup):
	Fix leak of GdkEvent (#70519)

Mon Feb  4 10:40:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c (gtk_default_draw_resize_grip):
	Fix from Matthias Clasen to clear background appropriately
	for theme by calling gtk_style_apply_default_background().
	(#70449)

Mon Feb  4 10:06:49 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c: gtk-double-click-time,
	not gtk-double-click-timeout. (#70501)

2002-02-04  Havoc Pennington  <hp@pobox.com>

	* gtk/gtksignal.c (gtk_signal_connect_while_alive): 
	(gtk_signal_connect_object_while_alive): rename 
	"signal" arg to "name" to avoid compiler warnings
	about shadowing signal(). #70453

2002-02-03  Anders Carlsson  <expander-master@gtk.org>

	* gtk/gtkstyle.c (gtk_default_draw_expander): Add 
	flipping support to the expanders.

Sat Feb  2 21:54:01 2002  Owen Taylor  <otaylor@redhat.com>

	RC file lookup improvements (#68234, suggestions
	from Matthias Clasen.)

	* gtk/gtkrc.c (gtk_rc_parse_file): Look for the 
	locale suffix variants (gtkrc.en_US, gtkrc.en) for
	all RC files we parse, not just the default RC
	files.

	* gtk/gtkrc.c (gtk_rc_parse_default_files): Remove
	support for charset specific RC files.

Sat Feb  2 20:16:04 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.c (_gtk_menu_shell_select_first): 
	Non-exported _gtk_menu_select_first() function that
	selects the first item of the menu in a standard
	way. (Skipping tearoffs.)

	* gtk/gtkmenushell.c gtk/gtkentry.c gtk/gtktextview.c
	gtkmenuitem.c: Use _gtk_menu_shell_select_first().

	* gtk/gtkmenuitem.c (gtk_real_menu_item_select): Remember
	if we are starting the timeout from a keypress so
	we can set menushell->ignore_enter properly.

	* gtk/gtknotebook.c (focus_child_in): Return something
	meaningful if there are no children.

	* gtk/gtkmenu.c (gtk_menu_key_press): Fix precendence
	problem.

Sat Feb  2 19:15:42 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_popup): Fix some bugs in
	the determination of xgrab_shell.

Sat Feb  2 17:43:00 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_grab_focus): Add a GtkSetting
	(gtk-entry-select-on-focus) controlling whether the
	contents of an entry are selected on focus in.

	* gtk/gtkmenu.c (gtk_menu_key_press): Add a GtkSetting
	(gtk-can-change-accels) controlling whether accelerators can be
	changed on the fly or not. (#51902)

	* gtk/gtkmenu.c (gtk_menu_key_press): Allow unmodified
	accelerators, now that accelerator changing can be turned
	off for those who won't expect it. (#61285)

	* gtk/gtkaccelgroup.c (gtk_accelerator_valid): Allow 
	Backspace/Delete/KP_Delete as valid accelerators.

	* gtk/gtkmenu.c (gtk_menu_key_press): Allow setting of
	Delete/Backspace as accelerators by making them toggle
	the menu item between empty and the pressed key.
	(#58605)

	* tests/testgtkrc: Remove the objectionably short cursor blink
	time setting.

Sat Feb  2 16:43:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_popup): To get around the fact
	that we may have a owner_events = FALSE grab in effect
	when we pop up a window, make a temporary grab on a
	different window, then grab on the real window. Fixes
	a problem where if a context menu popped up under the 
	cursor, the first item would be stuck unselected.
	(#59812, reported by Arnaud Charlet.)

2002-02-02  Peter Williams  <peterw@ximian.com>

	* gtk/Makefile.am (install-data-local): Install gtkrc.default
	from $(srcdir) for when $(builddir) is different.

Sat Feb  2 19:00:39 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/Makefile.am: remove TESTGTK_RCFILE define

Sat Feb  2 11:37:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_popup): Remove the 
	"select first item if popped up from keypress" hack --
	was causing more problems than it was worth 
	(#53191, #68483)

	* gtk/gtktextview.c (popup_targets_received): 
	 gtk/gtkentry.c (popup_targets_received): If activated
	from keyboard, select first item of popup menu.

Sat Feb  2 18:07:51 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_size_allocate): set upper member
	of vadjustment correct, so the vscrollbars of lists smaller than
	1 page are somewhat saner (#66905)

	* gtk/gtkliststore.c (gtk_list_store_remove_silently): do not
	increment the stamp, liststore is a model with persisting iters

Fri Feb  1 23:54:00 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.[ch] (gtk_rc_parse_engine):	Support 
	engine "" {} to mean override to the default 
	engine. (#70205)

Fri Feb  1 23:25:33 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.c (gtk_tooltips_init): Parse the
	RC string here when the first object is created
	rather than in the class_init to not break doc 
	building. (#70341, Havoc Pennington.)

	* gtk/gtkrc.c (parse_include_file): Use the directories
	for the currently parsed files as the starting point
	to look for include files. (#59975)

Fri Feb  1 20:21:56 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkinputdialog.c: use gtk_label_new_with_mnemonic for labels
	that actually have mnemonics

Fri Feb  1 19:57:59 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Fix use of ! in shell.

	* gtk/gtktooltips.c (gtk_tooltips_class_init) gtkrc.default: 
	Move the setting of default tooltips colors to gtktooltips.c
	from gtkrc.default. (Use default priority so themes will
	override.) (#58542)

Fri Feb  1 17:48:51 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_get_style): Fix ordering of
	priorities so that priorities take precendence over
	the ordering by type. (#70205)

	* test/testgtkrc tests/testgtk.c (create_rc_file): Add 
	some labels to test priorities in testgtkrc.

Fri Feb  1 00:37:49 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_move_cursor_page_up_down): use
	y coordinate relative to the tree and not the treeview window
	(fixes the PgDn/PgUp brokenness)

Fri Feb  1 23:40:31 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_button_press): adjust
	cell_area and background_area for possible treeview scroll
	(fixes #70283, #70065)

Fri Feb  1 22:20:13 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_size_allocate): use
	height - page_size not height - allocation->height (fixes #66269)

Fri Feb  1 15:22:23 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimage.c (gtk_image_class_init): Fix typo
	in property description. (Christian Rose.)

Fri Feb  1 14:50:36 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_parse_string): Handle reparsing
	any strings if the theme changes. (#69465)

	* tests/testgtk.c: Add a test for gtk_rc_parse_string().

Fri Feb  1 20:50:29 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_dy_to_top_row): set tree to
	NULL if tree_view->priv->tree is NULL (#70152, patch by John Harper).

Fri Feb  1 12:51:20 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (focus_child_in): Catch the
	cur_page == NULL (no children) case. (#70287,
	Paolo Maggi.)

Fri Feb  1 12:12:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (attempt_file_completion): 
	s/directory/folder/ in all labels and messages.

Fri Feb  1 08:57:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_exit_func): Remove this useless
	atexit handler. (existance pointed out by Stefan Kost)

	* gtk/gtkmain.c (gtk_init_check): Warning fixes.

Thu Jan 31 18:46:10 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodel.c (gtk_tree_row_reference_free): unref the
	model after the last use, not before.

Thu Jan 31 14:50:16 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.default gtk/Makefile.am: Install a Default
	RC file that sets the tooltips color to yellow. (#58542)

	* gtk/gtksettings.c (gtk_settings_class_init): make 
	the default theme "Default", not NULL.

Thu Jan 31 11:33:52 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkproperty-x11.c (insert_atom_pair): Fix 
	another missing static.

	* gtk/gtkimmodule.c (n_loaded_contexts): And another.

	* gdk/x11/Makefile.am gdk/x11/gxid_lib.c: Don't
	build gxid sources at all except in the vanishingly
	rare case of --with-xinput=xfree.

2002-01-31  Mark McLoughlin  <mark@skynet.ie>

	* gdk/gdkimage.c: (scratch_image_info_for_depth): make static.

	* gdk/x11/gdkimage-x11.c: (get_full_image): ditto.

	* gdk/x11/gxid_lib.[ch]: (_gxid_claim_device), (_gxid_release_device):
	renamed from gxid_(claim|release)_device.

	* gdk/x11/gdkinput-gxi.c: (_gdk_input_enable_window),
	(_gdk_input_disable_window): upd for gxid change.

	* gtk/gtkimage.c: (animation_timeout): make static.

	* gtk/gtkstyle.c: (draw_thin_shadow), (draw_spin_entry_shadow): make
	static.

	* gtk/gtktextutil.c: (bidi_menu_entries): make static.

Thu Jan 31 10:21:05 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkplug.c (gtk_plug_focus): Handle the case where
	bin->child is NULL. (#70153, Padraig O'Briain)

	* gtk/gtktextutil.c (_gtk_text_util_append_special_char_menuitems): 
	Actually call gettext() on the labels; previously they
	were marked with N_() but we never called gettext().

Wed Jan 30 20:15:49 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreestore.c (gtk_tree_store_set_valist): save last minute
	changes before committing.

	* gtk/gtkliststore.c (gtk_list_store_set_valist): ditto

Wed Jan 30 18:46:14 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkliststore.c (gtk_list_store_set_valist): only emit the
	signal if an interesting column changes.

	* gtk/gtktreestore.c: ditto.

	* gtk/gtktreeview.c (gtk_tree_view_set_cursor): change behavior so
	that it no longer grabs 

2002-01-30  Manish Singh  <yosh@gimp.org>

	* gtk/gtkhandlebox.c (gtk_handle_box_destroy): remove unused
	variable.

	* gtk/gtkwindow.c (gtk_window_get_icon): function returns a value,
	so return NULL with g_return_val_if_fail instead of g_return_if_fail.

2002-01-30  Matthias Clasen  <matthiasc@poet.de>

	* gtk/*.c: Remove excess g_return_if_fail calls from static
	and virtual functions.  (#57615)
	
2002-01-30  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkstyle.c (gtk_default_render_icon): Allow a -1 icon size.

Wed Jan 30 20:29:01 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkscale.c (gtk_scale_set_digits): fix revrted bug fix.
	(use a define for max digits).

Wed Jan 30 13:55:59 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_show): Try to make
	sure that we have some focused widget on map. (#50339)

	* gtk/gtkdialog.c (gtk_dialog_map): Handling picking
	a focus widget here differently so that if a
	response button gets picked, it's the default one.

	* tests/testgtk.c (make_message_dialog): Set the 
	default response for the dialogs.

Tue Jan 29 22:52:36 2002  Owen Taylor  <otaylor@redhat.com>

	* Released 1.3.13

	* configure.in: Micro version 13, interface, binary
	age 0. Require GLIB-1.3.13, Pango 0.24.

	* docs/Makefile.am (EXTRA_DIST): Add widget_geometry.txt,
	sizing-test.txt, tree-column-sizing.txt

	* docs/Makefile.am (EXTRA_DIST): Don't distribute
	Changes-1.2.txt, Changes-2.0.txt, README.linux-fb,
	since they are no longer canonical.

	* gtk/gtk.def: Convert spaces to tabs in front of
	gtk_widget_set_accel_path in case it matters.

	* NEWS: Updated for 1.3.13.

Tue Jan 29 22:31:07 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.[ch] gtkmenuitem.c gtkitemfactory.c: Export 
	gtk_widget_set_accel_path().

	* gtk/gtk.def: Add gtk_widget_set_accel_path.

Tue Jan 29 21:50:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccelmap.[ch] gtk/gtkbindings.[ch] gtk/gtkwidget.[ch]:
	Consistently use GdkModifierType. (#66950, Mark Patton)

	* gtk/gtkimagemenuitem.c (gtk_image_menu_item_new_from_stock):
	For consistency with gtk_button_new_from_stock(), fall back
	to gtk_image_menu_item_new_with_mnemnonic(). (#65944,
	Havoc Pennington)
	
	* gtk/gtkitemfactory.[ch] (gtk_item_factory_path_from_widget): 
	Make G_CONST_RETURN. (#68527, Matt Wilson)

Tue Jan 29 20:56:13 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtk[vh]scale.c (gtk_[vh]scale_new_with_range): Document
	that the end points are included in the range. (#69783,
	Jeffrey Baker)

Tue Jan 29 20:38:04 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkscale.[ch]: Revert the last changes to make the
	number of digits only effect drawing, instead, don't
	round unless we are in the 'draw_value' mode -- this
	is the behavior of GTK+-1.2, and keeps the behavior that
	if the user sees a displayed value, it is the correct value.

Tue Jan 29 19:51:05 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkenums.h: Deprecate GtkPreviewType,
	GtkSignalRunType, GtkSideType, GtkSubmenuPlacement, GtkSubmenuDirection
	(#68183, Matthias Clasen)

	* gtk/gtkmenuitem.h: Remove _gtk_menu_item_set_placement() from
	the public header to avoid having to use GtkSubmenuPlacement.

	* gtk/{gtkmenuitem.c,gtkmenubar.c,gtkmenushell.c}: #define
	GTK_MENU_INTERNALS to preserve access to GtkSubmenu*.

	* gdk/gdki18n.h: Deprecate contents. (Darin Adler.)

Tue Jan 29 19:32:47 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_get/set_property): 
	Fix wrong usage of g_value_set/get_object for PROP_TABS
	and memory leak in getter for PROP_TABS. (Jeff Franks)

Tue Jan 29 19:04:41 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c (gtk_style_render_icon): Document that
	a size of (GtkIconSize)-1 means don't scale.

	* gtk/gtkstyle.c (gtk_default_render_icon): Obey the
	-1 convention.

	* gtk/gtkimage.c (gtk_image_expose): Pass in -1 to
	gtk_style_render_icon() to make sure that we catch it
	obviously if the style's render function tries to
	scale.

Tue Jan 29 18:50:59 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimage.c (gtk_image_expose): Optimize exposes of
	partial insensitive images.

2002-01-24  Havoc Pennington  <hp@redhat.com>

	* gtk/gtkimage.c (gtk_image_expose): create insensitive version of
	the image regardless of storage type, #63305

	* demos/gtk-demo/images.c: add toggle button to demonstrate that
	GtkImage makes its contents insensitive

Tue Jan 29 17:40:02 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkpixbuf-render.c (gdk_pixbuf_render_to_drawable):
	Call _gdk_draw_pixbuf(), thus enabling using this function
	for pixbufs with alpha. (#68801)

	* gdk/gdkdraw.c (gdk_drawable_real_draw_pixbuf): Move
	implementation of gdk_pixbuf_render_to_drawable()
	to here.

Tue Jan 29 17:16:17 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklayout.c: Patch from Jacob Berkman to fix problem
	when the height/width of a layout was set before the
	adjustments were added. (#66294)

	* gtk/gtktreeview.c: Warning cleanups.

Tue Jan 29 16:35:04 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkhandlebox.c (gtk_handle_box_motion): Small
	fix to size of torn off window (#60271, Detlef Reichl)

	* gtk/Makefile.am: Don't install gtkhsv.h. (Pointed out
	by Ross Burton)

Tue Jan 29 18:50:46 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_move_cursor_page_up_down): free
	cursor_path after usage
	(gtk_tree_view_real_start_interactive_search): use new g_signal
	and g_object calls
	(gtk_tree_view_search_dialog_destroy): use g_object calls and free
	selected_iter if set
	(gtk_tree_view_search_position_func): rework so it will never ever
	appear offscreen (#68492)
	(gtk_tree_view_search_move): use new g_object calls
	(gtk_tree_view_search_init): free selected_iter if set, use new
	g_object calls
	(gtk_tree_view_leave_notify): don't destroy interactive search
	dialog

Tue Jan 29 23:07:03 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_real_start_interactive_search):
	send focus in event
	(gtk_tree_view_search_dialog_destroy): send focus out event (#66466)

2002-01-29  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkfontsel.c (gtk_font_selection_select_size): Show correct
	size in the size entry.

Tue Jan 29 16:11:55 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c (gtk_font_selection_show_available_sizes): Use
	gtk_tree_view_set_cursor() instead of gtk_tree_selection_select_iter().

	* gtk/gtkfontsel.c (gtk_font_selection_init): Add mnemonic to
	preview field. (#52433, patch from Anders Carlsson)
	
	* gtk/gtkfontsel.c (gtk_font_selection_dialog_init): Remove the 
	dialog separator. (#69558, Alex Larsson, patch from Anders Carlsson)

Tue Jan 29 15:24:59 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.[ch]: Switch over to GtkTreeView from
	GtkCList. Remove the entries above the font/face lists 
	since they were a little confusing. (Not sure about this 
	change, so the code is still there the entries are
	just hidden.) (#68890)

	* gtk/gtkfilesel.c: Switch over to GtkTreeView from
	GtkCList. Add mnemonics for fileops. Allow Control/Shift
	Tab to focus out.

	* gtk/gtkfilesel.c: Make fileop dialogs transient-for
	the fileselector. (#69336, patch from Melvin Hadasht)

	* gtk/gtkgamma.c (button_clicked_callback): Fix handling
	of gamma dialog a bit. (#69336, Matthias Clasen.)

Tue Jan 29 14:56:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.c (toplevel_focus_out_handler): Return boolean
	(and FALSE from focus_in / focus_out handlers. (#69528,
	Padraig O'Briain)

Tue Jan 29 14:47:54 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_init_check): Remove the scary startup
	warning. (#69480)

Tue Jan 29 14:24:49 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_class_init): Add <Control>Tab
	bindings for "move-focus" so that Control-Tab to escape from
	something that eats Tab just works if not otherwise overriden.

	* gtk/gtkspinbutton.c (gtk_spin_button_new_with_range) 
	* gtk/gtkvscale.c (gtk_vscale_new_with_range)
	* gtk/gtkhscale.c (gtk_hscale_new_with_range): Use a page_size
	of zero for the adjustment, since at times we think that the range
	is lower to upper - page_size. A page size equally to the 
	step_increment is, in any case, not meaningful.

2002-01-29  Tor Lillqvist  <tml@iki.fi>

	* README.win32: Add comment about gtk-1-3-win32-production branch
 	currently being ahead in functionality and code cleanliness (in
 	gdk/win32). Just in case somebody looks at the code in gdk/win32
 	here and starts fixing it, when it is going to change soonish
 	anyway.

2002-01-29  Sven Neumann  <sven@gimp.org>

	* gtk/gtkrc.c: don't install an empty icon_set if none of the image
	files could be found in the pixmap_path (bug #69398).
	
2002-01-29  Sven Neumann  <sven@gimp.org>

	* gdk/x11/gdkimage-x11.c (_gdk_x11_copy_to_image): fixed a segfault
	that showed up when using the color picker.

Tue Jan 29 11:51:14 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkscale.[hc]: fix default value for ::digits property,
	leave as 1 as per havoc's request.
	don't apply the draw_digits value to range->round_digits,
	so we don't perform gross quantization by default.

2002-01-25  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextbtree.c (_gtk_text_btree_delete): fix assertion
	failure by creating the line data, but not validating it at this
	stage. Also, remove old code related to the "bogus newline" mess
	that removed all tags from the last char in the buffer if you
	tried to delete it.
	(_gtk_text_line_data_new): put this here and prepend underscore,
	remove from gtktextlayout.c

Mon Jan 28 19:57:39 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/imhangul.c modules/input/imhangul-defs.h
	po/POTFILES.in. Add port of Emacs korean-hangul input
	method from Yusuke Tabata (#67665)

Mon Jan 28 18:25:10 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_draw_frame): Paint shadow
	before focus to give theme engines a bit morea
	flexibility. (#69857)

Mon Jan 28 16:23:20 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_dy_to_top_row): no longer
	g_assert.

2002-01-28  Jon Trowbridge  <trow@gnu.org>

	* gtk/gtktreeview.c (gtk_tree_view_set_model): When setting the
	GtkTreeView's model, set prelight_node, prelight_tree,
	button_pressed_node and button_pressed_tree to NULL. (#69603)

2002-01-28 Bill Haneman <bill.haneman@sun.com>

	* gtk/gtkstyle.c:
	Make sure that the default expanders are drawn with
	an outline thickness appropriate to the size of the
	expanders (RINT expander_size/7).
	Added static gtk_style_draw_polygon_with_gc(), to
	reduce code duplication.

	* gtk/gtktreeview.c: (gtk_tree_view_bin_expose):
	Use focus_line_thickness when drawing focus lines.

	* gtk/gtktreeviewcolumn.c:(gtk_tree_view_column_cell_get_size):
	Adjust requested width to include focus line thickness.
	(gtk_tree_view_column_cell_render_or_focus):
	Calculate a focus line rectangle which gets larger as the focus
	line thickness increases, to avoid overwriting cell content.
	Render left-aligned content at x+focus_line_width.
	(gtk_tree_view_column_cell_draw_focus):
	Don't draw a focus line around an editable text cell, since the
	text caret already indicates keyboard focus.
	Pass a GtkStateType appropriate to the focussed cell's state
	to gtk_paint_focus.

Mon Jan 28 14:44:40 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_real_select_cursor_row): Only
	activate/edit the row if shift is not pressed, #69248

2002-01-28  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkcurve.c (gtk_curve_set_vector): Fix build.

2002-01-28  Matthias Clasen  <matthiasc@poet.de>

	* gtk/{gtkalignment.c,gtkaspectframe.c,gtkbutton.c,
        gtkcellrenderer.c,gtkcellrendererpixbuf.c,gtkcombo.c,
        gtkcontainer.c,gtkcurve.c,gtkframe.c,gtklabel.c,
        gtkmessagedialog.c,gtknotebook.c,gtkspinbutton.c,gtktable.c,
        gtktext.c,gtktextview.c,gtktreeview.c,gtktreeviewcolumn.c,
        gtkviewport.c,gtkwidget.c}: General property notification 
	cleanup. (#69066)

2002-01-28  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkaccelgroup.c (gtk_accel_groups_activate): & with the
	default mod mask so accels work when numlock is on.

Sun Jan 27 23:23:23 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkrbtree.[ch]: add _gtk_rbtree_mark_invalid (my previous
	commit already needed this ...)

Sun Jan 27 22:13:02 2002  Kristian Rietveld  <kris@gtk.org>

	Fix for bug #69586

	* gtk/gtktreeprivate.h: get rid of tab_offset, introduce
	expander_size

	* gtk/gtktreeview.c: get rid of ->priv->tab_offset, introduce
	expander_size caching (from style), fix CELL_HEIGHT macro,
	use MAX ("RBNODE_HEIGHT", expander_size) (differs per case) for
	row height calculation, added style_set callback

2002-01-27  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtklabel.c (gtk_label_create_window): Set the cursor to
	GDK_XTERM.

	* gtk/gtktextview.h (struct _GtkTextView): add mouse_cursor_obscured.

	* gtk/gtkentry.h (struct _GtkEntry): Add mouse_cursor_obscured.

	* gtk/gtktextview.c (set_invisible_cursor): New function.
	(gtk_text_view_obscure_mouse_cursor): Likewise.
	(gtk_text_view_key_press_event): Call obscure_cursor if text 
	has been inserted.
	(gtk_text_view_motion_event): Restore the mouse cursor.

	* gtk/gtkentry.c (gtk_entry_realize): Add GDK_POINTER_MOTION_MASK.
	(set_invisible_cursor): New function.
	(gtk_entry_obscure_mouse_cursor): Likewise.
	(gtk_entry_key_press): call obscure_cursor if text has been inserted.
	(gtk_entry_motion_notify): Restore the mouse cursor.

2002-01-27  Sven Neumann  <sven@gimp.org>

	* gtk/gtkstyle.c (sanitize_size): removed unused return value.

Sat Jan 26 19:27:23 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.c (gtk_socket_grab_notify): Don't
	send MODALITY_ON/OFF if socket->same_app (More fixes for #69735)

Sat Jan 26 19:04:37 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (check_is_grabbed): Return FALSE not true
	in the grab_widget == NULL case. (Bug reported by 
	Padraig O'Briain, #69735)

	* gtk/gtkplug.c (handle_modality_on): Realize the modality
	window so gtk_widget_event() doesn't complain :-((((.

2002-01-25  Federico Mena Quintero  <federico@ximian.com>

	Merge from gdk-pixbuf stable.

	* gdk/gdkpixbuf-drawable.c (rgb565msb): Fixed the endianness
	conversion --- swap the individual 16 bit values instead of taking
	everying as a 32 bit value.
	(rgb565lsb): Likewise.
	(rgb555lsb): Likewise.
	(rgb555msb): Likewise.

2002-01-25  Alex Larsson  <alexl@redhat.com>

	* gdk/linux-fb/gdkdrawable-fb2.c (gdk_drawable_impl_fb_class_init):
	Implement copy_to_image instead of get_image
	
	* gdk/linux-fb/gdkimage-fb.c:
	Implement _gdk_image_new_for_depth, _gdk_windowing_get_bits_for_depth and
	_gdk_fb_copy_to_image.
	Based in part on patch from Mathieu Lacage <mathieu_lacage@realmagic.fr>

	* gdk/linux-fb/gdkmain-fb.c:
	Make ENABLE_FB_MANAGER region larger.

	* gdk/linux-fb/gdkprivate-fb.h:
	Change _gdk_fb_get_image to _gdk_fb_copy_to_image.

2002-01-25  Sven Neumann  <sven@gimp.org>

	* gtk/gtkwindow.c (gtk_window_get_size): changed the comment so
	that gtk-doc doesn't get confused.

Fri Jan 25 14:03:36 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkspinbutton.c (gtk_spin_button_draw_arrow): assert
	that the passed in arrow is always _UP or _DOWN, this catches
	false invocations which lead to drawing artefacts.
	(start_spinning): likewise, i.e. sanity check the passed in arrow.
	(gtk_spin_button_button_release): fix arrow redrawing.
	(gtk_spin_button_button_press): must set click_child for
	button3 even if we don't take spinning action right away.

	* gtk/gtkspinbutton.h (struct _GtkSpinButton): document
	valid values for click_child.

Thu Jan 24 23:03:24 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_get_path_at_pos): update docs,
	return current FALSE if x is smaller than the current visible area,
	not than the requested area, don't correct y coordinate,
	TREE_WINDOW_Y_TO_RBTREE_Y will do that. Fixes #67477.

Thu Jan 24 15:41:08 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c
	 (gtk_tree_view_motion_draw_column_motion_arrow): fix column
	 reordering fully.
	 (gtk_tree_view_size_allocate): fix evil bug.

Thu Jan 24 11:53:19 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_destroy): Don't clear
	the model until we clean up all the other objects
	that might refer to the object.

2002-01-24  Mark McLoughlin  <mark@skynet.ie>

	* gtk/gtkaccessible.h: include gtk/gtkwidget.h

Wed Jan 23 20:28:59 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_draw_arrow): 
	Use insensitive state for insensitive arrows, not
	just an "etched state". (#67172, Adrian Custer)

2002-01-23  Manish Singh  <yosh@gimp.org>

	* gtk/gtkentry.c (gtk_entry_set_text): use a variable that's actually
	been declared.

2002-01-23  Damon Chaplin  <damon@ximian.com>

	* configure.in (gtk_doc_min_version): set minimum gtk-doc version to
	0.9, since we need to use the new --type-init-func argument for
	gtkdoc-scangobj.

2002-01-23  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkentry.c, gtk/gtkwidget.c: Remove excessive
	g_return_if_fail() calls. (#57615)

	* gtk/gtkitemfactory.c (gtk_item_factory_delete_entries): Make
	it work for paths with underline accelerators. (#69247)

Wed Jan 23 15:12:16 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkspinbutton.c (gtk_spin_button_state_changed): 
	Stop spinning if widget becomes insensitive. (#56248)

Wed Jan 23 14:44:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkspinbutton.c (EPSILON): Decrease value since
	we now use doubles.

Tue Jan 22 16:58:37 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_size_allocate): Fix sizing bug
	I introduced accidentally, #69358

2002-01-22 Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtktreestore.c (gtk_tree_store_iter_children):
	Update last change to prevent core dump

Mon Jan 21 01:21:54 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreestore.c: add some more stamp checks (pointed out
	by Anders Carlsson)

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_insert_value): don't
	assume _row_changed will insert sort (because _row_changed doesn't
	need to follow this signal), so apply insert sort here
	(gtk_tree_model_sort_level_find_insert): header doesn't need to be
	set here, so use a return instead of g_return_val_if_fail.

Mon Jan 21 18:28:17 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_adjustment_changed): Update
	top_row.  Remove extraneous print statements.

2002-01-21  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkitemfactory.c (gtk_item_factory_popup, 
	gtk_item_factory_popup_with_data): Document allowed values
	for ifactory.

	* gtk/gtkitemfactory.c (gtk_item_factory_delete_entry): Make 
	it work for paths with underline accelerators.

Fri Jan 18 16:31:21 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_size_allocate): only resize the
	window.

Mon Jan 21 11:56:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_real_activate): Trap the 
	case where there is no default widget and the entry
	is the focus widget, since this also causes infinite
	recursion. (#69158)

Mon Jan 21 11:46:39 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c (gdk_init_check): Set the fallback program class here,
	rather than lazilygdk_get_program_class(), since we don't want
	-name to override it. (#69123, Ryan Lovett)

Mon Jan 21 10:29:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c: Fix wrong types for command line arguments 
	(#69124, Ryan Lovett)

	* gdk/gdk.c (gdk_arg_context_parse): Fix bug in parsing
	parsing '--arg VALUE'.

	* gdk/gdk.c: Remove unused variable gdk_error_trap_free_list.

2002-01-21  Havoc Pennington  <hp@pobox.com>

	* gdk/gdkwindow.c (gdk_window_add_filter): mention that window 
	arg can be NULL

Sat Jan 19 20:49:41 2002  Kristian Rietveld  <kris@gtk.org>

	* demos/gtk-demo/editable_cells.c: fix a load of open line ends
	(cell_edited): modified patch from German Poo Caaman~o
	to fix up old_text declaration and free the memory
	(do_editable_cells): unref the model after creating the treeview

	* demos/gtk-demo/list_store.c: fix a load of open line ends,
	(add_columns): set the sort column id, so we can sort

	* demos/gtk-demo/tree_store.c: fix a load of open line ends,
	(do_tree_store): unref the model after creating the treeview

2002-01-19  Havoc Pennington  <hp@pobox.com>

	* gtk/gtkwindow.c: link to new X11 section in a lot of places when
	mentioning the window manager.

	* gtk/gtkwidget.c (gtk_widget_hide_on_delete): don't mention
	window manager since we're portable.

Sat Jan 19 08:47:41 2002  Jeff Garzik  <jgarzik@mandrakesoft.com>

	* gdk/linux-fb/gdkproperty-fb.c (gdk_atom_name):
	Wrap case values in GPOINTER_TO_UINT().  Fixes build with gcc 3.x.

	* gtk/gtkmain.c:  Include sys/types.h if G_OS_UNIX.
	Fixes build with gcc 3.x and -ansi.

Fri Jan 18 23:01:37 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_parse_style): Fix problems when
	an engine declaration occurs in a reopened style, and
	g_free() of objects when errors occur.

2002-01-18  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkitemfactory.c (gtk_item_factory_get_widget_by_action):
	Clarify documentation. (#69026)

	* gtk/gtkprogressbar.c (gtk_progress_bar_size_request): Fix 
	missing initialization of adjustment. (#69025)

2002-01-17  Raja R Harinath  <harinath@cs.umn.edu>

	Simplify Makefiles. 
	<URL: http://bugzilla.gnome.org/show_bug.cgi?id=68969>
	* gdk/Makefile.am: Remove use of automake conditionals to pick
	library to build.
	* gtk/Makefile.am: Likewise.
	
	* gdk/Makefile.am (LDFLAGS): Use $(libdir), not @prefix@/lib.
	* gtk/Makefile.am (LDFLAGS): Likewise.

Thu Jan 17 20:13:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_redraw_tabs): Fix
	missing allocation.x/y offsets. (#68962, Jacob
	Berkman)

	* gtk/gtknotebook.c (gtk_notebook_size_allocate):
	Queue a redraw on the entire widget if we hide
	the last page or show the first. (Also #68962)
	
2002-01-17  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_move_cursor_internal): change
	GTK_MOVEMENT_PARAGRAPHS to go to start/end of paragraph before it
	starts to go up/down paragraphs. This makes Ctrl+Up/Ctrl+Down work
	as in the keynav spec, though it makes the interpretation of
	GTK_MOVEMENT_PARAGRAPHS different from the interpretation of some
	of the other GTK_MOVEMENT_ thingies, maybe, as if that enum makes
	any sense anyhow.

Thu Jan 17 16:34:55 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_real_select_cursor_row): For
	some reason, I was activating a row while just selecting it.
	Reported by andersca.
	(gtk_tree_view_size_request): add a
	validate_rows_handler to give us a rough width of the widget.

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_update_button):
	Queue a resize here just in case.  It's needed in over half the
	cases, and I don't want to do a diff to figure out exactly when
	it's needed.

2002-01-17  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkinputdialog.c,
	gtk/gtkcolorsel.c, gtk/gtkfilesel.c, gtk/gtkfontsel.c:
	Mark children as composite. (#66360)

	* gtk/gtkwidget.c (gtk_widget_push_composite_child): Explain
	composite children some more. (#66360)

2002-01-17  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextlayout.c (_gtk_text_layout_get_line_xrange): new
	function (which I then decided not to use but I think it's needed
	to fix #68963

	* gtk/gtktextview.c: add page_horizontally action signal and
	implement Ctrl+PgUp, Ctrl+PgDown based on patch from Padraig, 
	hackily modified to avoid adding GTK_MOVEMENT_ API. Part of 
	#53934

	* gtk/gtkmarshalers.list: add NONE:INT,BOOL

Thu Jan 17 17:02:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_real_unrealize): Call
	gtk_selection_remove_all() here, not in destroy/
	finalize. (#66636, Sergey Vlasov)

	* gtk/gtkselection.c (gtk_selection_request): Fix
	reentrancy problem with multiple conversions.

	* gtk/gtkselection.c (gtk_selection_remove_all): 
	Don't remove incrs, we don't need the widget for
	maintain the incr.

	* gtk/gtkselection.c (struct _GtkIncrInfo): Remove
	the widget field from here, we don't need it.

Thu Jan 17 13:08:34 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkmain-x11.c (gdk_error_trap_push): Move
	here, and save/restore the X error handler to allow
	people using GTK+ to set the X error handler to something
	custom without disturbing the operation of GDK.

	* gdk/linux-fb/gdkmain-fb.c (gdk_error_trap_push) 
	* gdk/win32/gdkmain-win32.c (gdk_error_trap_pop): Add
	dummy implementations.

	* gdk/x11/gdkmain-x11.c gdk/x11/gdkevents-x11.c 
	gdk/x11/gdkdnd-x11.c: Use gdk_error_trap_push()/pop()
	for all error trapping.

	* gdk/x11/gdkdnd-x11.c: Remove '#if 0' code.

	* gdk/x11/gdkdnd-x11.c (gdk_window_cache_new): Fix
	problem where we would add the results anyways,
	and then add it again if no error occurred, and problem
	where we could leave _gdk_error_warnings() unset.

Wed Jan 16 20:28:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c: Fix "deleting" filename by adding
	another boolean parameter to file_selection_populate() -
	whether to clear the entry. Also, never fill in the
	entry when the user clicks on something in the 
	directory list. (#6791, Reported by Jos Dehaes and many,
	many, many others.)

2002-01-16  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_scroll_pages): update
	cursor_y_pos with clamped delta rather than theoretical delta
	(#68788). Also, if we can't page up/down further then jump 
	to top/bottom of the document.

Wed Jan 16 19:33:41 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (gtk_file_selection_map): Refresh
	the dialog on map. (#52877, inspired by request from
	Murray Cumming)

Wed Jan 16 19:23:04 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkbindings.c (gtk_binding_entry_activate): 
	Support "optional" bindings. If a binding signal
	has a boolean return value, and returns FALSE it
	is as if it didn't exist all.

	* gtk/gtkbindings.c (binding_compose_params): Switch
	over to GValue.

	* gtk/gtknotebook.[ch]: Make the select_page() and
	change_current_page() signals only take effect when
	the focus is on the tab area so that key presses
	in children pass up to the toplevel correctly.

Wed Jan 16 12:16:37 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkoptionmenu.c (gtk_option_menu_size_request): Fix 
	calculation error in the (shouldn't happen) case where
	option_menu->height < child_requisition.height. (Patch
	from Jacob Berkman, #66969)

2002-01-15  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkenums.h (GtkMatchType): Deprecate. (#68183)

	* gtk/gtkscale.h (gtk_scale_value_width): Remove useless 
 	compatibility macro. (#67730) 

Wed Jan 16 10:54:38 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Fix typo in --help output.
	(Arnaud Charlet).

Wed Jan 16 10:18:42 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/stock-icons/Makefile.am (EXTRA_DIST): Add 
	gtkstockpixbufs.h.

	* configure.in: Make TIFF, JPEG, PNG loaders mandatory
	unless you configure with --without-libtiff, etc.
	(#54045, Brian Cameron)

2002-01-16  Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtkmenushell.c (gtk_real_menu_shell_move_current):
	Avoid unexpected warning message when navigating menu (#68517)

2002-01-15  Jody Goldberg <jody@gnome.org>

	* gtk/gtklayout.c (gtk_layout_realize) : It is possible that a
	GtkLayout may have been scrolled _before_ it was realized.

Tue Jan 15 18:10:24 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkspinbutton.c (gtk_spin_button_grab_notify): Stop
	the timer on destroy, or when we are notified that we are
	shadowed by a modal dialog.

	* gtk/gtkspinbutton.c: Remove explicit gtk_grab_add()/remove() -
	not needed any more.

	* gtk/gtkmain.c (gtk_grab_notify): Fix problem where notifications
	weren't sent out for the default grab group.

	* gtk/gtkmain.c (gtk_grab_notify): Fix notification of widgets that
	were getting events because they were part of the previous grab.

Tue Jan 15 12:23:33 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_mnemonic_activate_switch_page): 
	focus the activated tab, not the page. (#53612)

	* gtk/gtknotebook.c (gtk_notebook_set_focus_child): Track
	the last focus descendant of the page.

	* gtk/gtknotebook.c (gtk_notebook_real_switch_page): If the focus
	was on the previous page, move it to the last focused widget /
	first element on the new page, if possible, or if not, to the 
	notebook itself. (#68224, reported by Jonathan Blandford)

	* gtk/gtknotebook.c (focus_tabs_in): Don't focus tabs
	tabs aren't visible. (#65462, Damon Chaplin, fixed based 
	on patch from Anders Carlsson)

2002-01-15            Vitaly Tishkov       <tvv@sparc.spb.su>

        * gtk/gtkstyle.c
	a misprint in documentation for gtk_style_render_icon () is fixed

Mon Jan 14 23:21:47 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkmenuitem.c (gtk_menu_item_map): map event_window after
	mapping child, so we don't loose events.

2002-01-15  Sven Neumann  <sven@gimp.org>

	* gtk/gtkaccellabel.h
	* gtk/gtkitemfactory.c: fixed documentation by syncing the parameter
	names used in headers and code.

2002-01-14  jacob berkman  <jacob@ximian.com>

	* gtk/gtkrc.c (gtk_rc_get_im_module_path): close a comment block

Tue Jan 15 01:13:51 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c: fix a load of open line ends,
	(gtk_tree_model_sort_set_model): only free root level if it's
	!NULL

2002-01-14  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkoldeditable.c, gtk/gtkrc.c, 
	gtk/gtkstyle.c: Documentation additions.

	* gtk/gtkmenu.c (gtk_menu_set_accel_path),
	gtk/gtkmenuitem.c (gtk_menu_item_set_accel_path), 
	gtk/gtkwidget.c (gtk_widget_add_accelerator): Typo and markup fixes.

	* gtk/gtkitemfactory.c (gtk_item_factory_add_foreign): Document.

	* gtk/gtkaccelmap.c (gtk_accel_map_add_filter): Explain intended use.

Mon Jan 14 17:14:13 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkselection-x11.c (sanitize_utf8): Don't
	mangle sequences of consecutive \n or \r.

Mon Jan 14 17:42:28 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_stop_editing): allow cancel to
	happen.

	* gtk/gtktreeview.c (install_presize_handler): only install the
	handler if we're realized, #68056

Mon Jan 14 16:35:58 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_move_resize): Unset 
	initial_pos_set after the first configure request.

2002-01-13  Jody Goldberg <jody@gnome.org>

        * gtk/gtktexttag.c (get_color_arg) : set_boxed will copy the color
	  and will use a mem_chunk to do it.  Avoid an unnecessary copy, a
	  leak, and confusion.

Sun Jan 13 23:23:22 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_compute_hints): Fix problem where
	widget->requisition was being used instead of
	gtk_widget_get_child_requisition (), causing geometry widgets
	with usizes to misbehave.

2002-01-14  Sven Neumann  <sven@gimp.org>

	* gtk/gtkrc.c: g_getenv() returns a const string.

2002-01-14  Hasbullah Bin Pit  <sebol@ikhlas.com>

        * configure.in: Added ms at ALL_LINGUAS.
	* po/ms.po: Added Malay Translation.

2002-01-14  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkitemfactory.c: Documentation.

2002-01-13  Sven Neumann  <sven@gimp.org>

	* gdk/gdkwindow.c: documentation cleanups.

Sun Jan 13 01:15:45 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c: various cleanups,
	(get_child_iter_from_elt): removed,
	(gtk_tree_model_sort_elt_get_path): rewritten to be a lot cleaner
	and especially faster,
	(gtk_tree_model_convert_iter_to_child_iter): use
	gtk_tree_model_sort_elt_get_path

Sat Jan 12 16:57:31 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_real_start_interactive_search):
	revert Owen's change (using a strdupped string as object data), so
	the interactive search works again

2002-01-11  Havoc Pennington  <hp@pobox.com>

	* gtk/gtklabel.c: put in more links to Pango markup format docs
	(gtk_label_set_justify): mention gtk_misc_set_alignment

2002-01-12  Tor Lillqvist  <tml@iki.fi>

	Fixes contributed by Archaeopteryx Software: This is a first small
	part of their changes. Will commit more later.
	
	* gdk/win32/*.c: Add some more checks for failed GDI calls. If a
	call fails, don't use bogus values.

	 gdk/win32/gdkcursor-win32.c (_gdk_win32_data_to_wcursor): Plug
	memory leak: g_free() the AND and XOR bitmaps after use.
	(_gdk_cursor_destroy): If we are destroying the current Windows
	cursor, set the Windows cursor to none first.

	* gdk/win32/gdkgc-win32.c (predraw_set_foreground): Delete the old
	brush that was in the DC, like the win32-production branch does.

	* gdk/win32/gdkwindow-win32.c (gdk_window_impl_win32_finalize): If
	the window has a cursor which is the current Windows cursor,
	before destroying it set the current Windows cursor to none.
	(gdk_window_set_cursor): Also here, if destroying the current
	Windows cursor, set the current Windows cursor to none first.
	(gdk_window_get_pointer): Revamp logic.
	
2002-01-10  jacob berkman  <jacob@ximian.com>

	* gtk/gtkwidget.c (gtk_widget_add_events): actually iterate
	through the list rather than infinitely loop

2002-01-08  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkwidget.c (gtk_widget_set_style_recurse): Rename to
	reset_rc_styles_recurse(). (#68084)

2002-01-10            Vitaly Tishkov       <tvv@sparc.spb.su>
        * gtk/gtkimage.c
	* gtk/gtkimcontext.c
	* gtk/gtktreemodel.c
	* gtk/gtktreemodelsort.c
	* gtk/gtkwindow.c
	fix docs	

Wed Jan  9 20:56:42 2002  Jonathan Blandford  <jrb@redhat.com>

	* gdk/x11/gdkkeys-x11.c (get_xkb): get the types as well as the
	symbols because we need them in MyEnhancedXkbTranslateKeyCode.

2002-01-10  Tor Lillqvist  <tml@iki.fi>

	Apply the same fixes and improvements as to the
	gtk-1-3-win32-production branch: Bug fixes and cleanup of
	selection and DND functionality. Still doesn't work as well as the
	win32-production branch, though, but getting closer.

	After this, need to add Archaeopteryx Software's OLE2 DND support.

	* gdk/win32/gdkselection-win32.c (gdk_selection_owner_set,
	gdk_selection_send_notify, generate_selection_notify): Don't use
	SendMessage() to generate events for the same app, instead use
	gdk_event_put().

	* gdk/win32/gdkprivate-win32.h
	* gdk/win32/gdkglobals-win32.c
	* gdk/win32/gdkmain-win32.c
	* gdk/win32/gdkevents-win32.c: Thus, remove declaration, definition,
	initialisation and handling of gdk_selection_notify_msg,
	gdk_selection_request_msg and gdk_selection_clear_msg. 

	* gdk/win32/gdkselection-win32.c (gdk_text_property_to_text_list,
	gdk_free_text_list, gdk_string_to_compound_text,
	gdk_free_compound_text): Implement trivially, witrh a text_list
	always having a single element, and a compound text always
	consisting of just a single (UTF-8!) string. Let's see how well
	this works.

	* gdk/win32/gdkselection-win32.c (gdk_selection_convert): Fix
	non-ASCII paste from the clipboard: Try getting the same formats
	from the Windows clipboard that gdk_property_change() puts there:
	CF_UNICODETEXT, UTF8_STRING or CF_TEXT+CF_LOCALE.

	* gdk/win32/gdkproperty-win32.c (gdk_property_change): When
	storing text on the clipboard, handle non-ASCII text
	correctly. The logic is as follows:

	If we have only ASCII characters, use CF_TEXT.

	Else, if we are on NT, use CF_UNICODETEXT.

	Else (we are on Win9x), if all the characters are present in the
	code page of some installed locale, use CF_TEXT and also set
	CF_LOCALE to that locale.

	Else (still on Win9x) store as RTF. We use a very simple RTF
	string, just the text, no fonts or other crap, with the non-ASCII
	characters as Unicode \uN keywords. Additionally, also store the
	UTF-8 string as such, under the format "UTF8_STRING", so that GDK
	can also paste from the Clipboard what it has copied there. (Thus
	no need to implement any RTF parser.)
	
	(find_common_locale): New function, implements the search for a
	locale for case 3 above.

	* gdk/win32/gdkglobals-win32.c: New global variables
	compound_text, text_uri_list, utf8_string, cf_rtf and
	cf_utf8_string.

	* gdk/win32/gdkim-win32.c (_gdk_ucs2_to_utf8): New function,
	converts from a wchar_t string to UTF-8.
	(_gdk_utf8_to_ucs2): Rename from _gdk_win32_nmbstowchar_ts.
	(_gdk_utf8_to_wcs): Rename from gdk_nmbstowchar_ts.

	* gdk/win32/gdkevents-win32.c (build_keypress_event): Use
	_gdk_ucs2_to_utf8().

	* gdk/win32/gdkselection-win32.c: Remove some unnecessary logging.

	* gdk/win32/gdkdnd-win32.c: Plug memory leaks, the
	gdk_drag_context_ref() was called unnecessarily in a couple of
	places, meaning drag contexts were never freed. The same memory
	leaks seem to be present in gdk/linux-fb/gdkselection-fb.c, BTW.

	(gdk_drop_reply): For WIN32_DROPFILES drops, free the temporarily
	stored file list.

	* gdk/win32/gdkselection-win32.c: Clarify the use of the
	sel_prop_table. Now it is used only for storing the GDK_SELECTION
	"properties".

	The file names dropped with WM_DROPFILES -style DND is stored
	temporarily (between the drop and the target picking them up) in a
	separate place.

	Have a separate hash table to map selection atoms to owner
	windows. This used to be quite mixed up.

	(_gdk_dropfiles_store): New function, to store the dropped file
	list for the drop target to possibly fetch, and clear it
	afterwards, from gdk_drop_reply().

	(gdk_selection_owner_get): Much simplified now.

2002-01-09  jacob berkman  <jacob@ximian.com>

	* gtk/gtklayout.c (gtk_layout_style_set): set the background of
	our bin window also (fixes #58957)

Wed Jan  9 19:10:07 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeselection.c
	(_gtk_tree_selection_internal_select_node): Now we test we can
	unselect nodes before selecting new ones.
	(gtk_tree_selection_real_select_node): be careful comparing booleans.

Wed Jan  9 21:31:44 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkliststore.c (gtk_list_store_sort): pass NULL to
	gtk_tree_model_rows_reordered and not an iter with user_data
	set to NULL (which is an invalid liststore iter, so
	iter_n_children failed, etc)

2002-01-09  Sven Neumann  <sven@gimp.org>

	* tests/prop-editor.c: declared internal functions static.
	
Wed Jan  9 11:13:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenuitem.c (_gtk_menu_item_refresh_accel_path): 
	Fix problem with menus without accel groups, such as the
	menus for option menus.

	* gtk/gtkpaned.c (gtk_paned_expose): Only conditionalize
	drawing of handle on whether both children are visible,
	not the drawing of the other child!. (#68325, Diego Gonzalez)

Wed Jan  9 10:20:16 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdrawable-x11.c gdk/x11/gdkgc-c11.c: Check for
	RENDER before trying to use it... XRenderFindFormat() prints
	warnings if called when extension isn't present.

Wed Jan  9 15:20:40 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkmenuitem.c (gtk_menu_item_parent_set): update the accel
	path upon parent changes.

Wed Jan  9 13:20:14 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkviewport.c (gtk_viewport_size_allocate): small but important
	fix to force vadjustments at size_alocate time from Xavier Ordoquy
	<mcarkan@users.sourceforge.net>.

Wed Jan  9 11:23:39 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtklayout.c (gtk_layout_get_property): 
	* gtk/gtkspinbutton.c (gtk_spin_button_get_property): 
	* gtk/gtktreeview.c (gtk_tree_view_get_property): 
	* gtk/gtkwidget.c (gtk_widget_get_property): 
	* gtk/gtkfontsel.c (gtk_font_selection_get_property): 
	* gtk/gtkrange.c (gtk_range_get_property):
	* gtk/gtkviewport.c (gtk_viewport_get_property):
	* gtk/gtkprogressbar.c (gtk_progress_bar_get_property): don't cast a
	possible NULL pointer.

2002-01-08  Mike Kestner  <mkestner@speakeasy.net>

	* gtk/gtkcelleditable.h : Use G_TYPE_INSTANCE_GET_INTERFACE.
	* gtk/gtktreednd.h : ditto.
	* gtk/gtktreemodel.h : ditto.
	* gtk/gtktreesortable.h : ditto.
	* gtk/gtkwidget.h : Don't reference incomplete _GdkRectangle type.

2002-01-08  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkplug.c, gtk/gtksocket.c: Speak of window IDs rather 
	than XIDs in the docs.

	* gtk/gtkclipboard.c (gtk_clipboard_clear): Fix docs.

Tue Jan  8 18:39:23 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreedatalist.c (gtk_tree_data_list_compare_func): wow!
	Am I a moron or what 0 < 1 is not equivalent to strcmp ("a", "b")

Tue Jan  8 18:04:01 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktoolbar.c (gtk_toolbar_set_icon_size):
	Handle TOGGLE/RADIOBUTTON as well. (#68201,
	Damon Chaplin.)

	* gtk/gtktoolbar.c (get_first_child): Fix stupid 
	bug, just introduced.

Tue Jan  8 15:53:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_find_widget): Fix coordinate
	translations, once and for all.

	* gtk/gtktextbuffer.c (paste_from_buffer): Free
	the ClipboardRequest structure. (#66198, HideToshi
	Tajima)

2002-01-08  jacob berkman  <jacob@ximian.com>

	* gtk/gtklayout.c (gtk_layout_move_internal): queue a resize on
	the child rather than the layout. see bug #68263

Tue Jan  8 14:51:19 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkpaned.c (gtk_paned_expose): Don't draw
	the handle if we aren't showing both children.
	(#68135, Diego Gonzalez)

Tue Jan  8 14:45:43 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_add_events): Fix
	leak of result of gtk_container_get_children().

Tue Jan  8 14:42:19 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktoolbar.c: Fix leaks of results of
	gtk_container_get_children(). (#68199, Damon Chaplin)

Tue Jan  8 14:19:43 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcheckbutton.c (gtk_check_button_size_allocate): 
	Fix problem where child->requisition was accessed
	directly instead of calling get_child_requisition()
	(#68199, Damon Chaplin)

2001-01-08  James Henstridge  <james@daa.com.au>

	* gtk/gtkstyle.c: add trailing */ on doc comment.

Mon Jan  7 22:19:32 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdrawable-x11.c (draw_with_pixmaps): Fix a
	problem where were the offset into the image was passed
	into convert_to_format() wrong.

	* gdk/x11/gdkdrawable-x11.c (gdk_x11_draw_pixbuf): Call
	gdk_x11_drawable_update_picture_clip () before using
	the picture; allow update_picture_clip() to take a NULL gc
	to mean no clipping.

2002-01-07  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtksocket.c (gtk_socket_get_id): Doc typo fix. (#68172)

	* gtk/gtktreemodel.c (gtk_tree_path_is_descendant): Fix docs.

	* gtk/gtktreemodel.c (gtk_tree_model_rows_reordered): Document.

	* gtk/gtkwindow.c (gtk_window_remove_accel_group): Fix docs.

	* gtk/gtkrc.c (gtk_rc_get_style_by_paths),
	gtk/gtkwidget.c (gtk_widget_get_toplevel, 
	gtk_widget_push_composite_child), gtk/gtkdialog.c 
	(gtk_dialog_new_with_buttons, gtk_dialog_run): Keep gtk-doc
	from messing up the indentation of inline examples.	

	* gtk/gtkmain.c, gtk/gtkrc.c: Consistently call g_getenv() 
	instead of getenv().

	* gtk/gtktreemodel.c, gtk/gtkaccelgroup.c, gtk/gtkclipboard.c,
	gtk/gtkdnd.c, gtk/gtkiconfactory.c, gtk/gtkrc.c,
	gtk/gtkstyle.c, gtk/gtkselection.c: Doc fixes.

	* gtk/gtkaccelmap.c (gtk_accel_map_add_filter,
	gtk_accel_map_foreach_unfiltered, gtk_accel_map_load_scanner):
	Document.

2002-01-07  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkcellrendererpixbuf.c (gtk_cell_renderer_pixbuf_render): Remove
	unused pixels and rowstride variables.
	(gtk_cell_renderer_pixbuf_get_size): Check for non-NULL width.

Mon Jan  7 08:48:23 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkdnd.c (gtk_drag_find_widget): don't forget to offset
	the pointer by x/y_offset into the new window when we found
	the drag destination.

	* gtk/gtkaccelmap.c (internal_change_entry): fix return code
	for simulation when the entry already contains the required
	accel key and mod.

2002-01-06  Matthias Clasen  <matthiasc@poet.de>
 
	* docs/debugging.txt: Replace GTK_NO_CHECK_CASTS by 
	G_DISABLE_CAST_CHECKS.

	* gtk/gtkaccelgroup.c (gtk_accel_group_from_accel_closure,
	gtk_accel_group_query, gtk_accel_group_find,
	gtk_accel_groups_from_object): Document.

	* gtk/gtkaccellabel.c (gtk_accel_label_set_accel_closure): Document.

2002-01-04  Hans Breuer  <hans@breuer.org>

	* gdk/gdkdraw.c gdk/gdkpixbuf-drawable.c : 
	need to cast image->mem away from void* to avoid 
	'error C2036: 'void *' : unknown size'. Doing pointer 
	arithmetics on void pointers is a GCCism afaik.

	* gdk/gdkpixbuf-render.c : #include "gdkinternals.h" for
	_gdk_draw_pixbuf ()

	* gdk/makefile.msc gdk/win32/makefile.msc 
        gdk/gtk/makefile.msc.in : use -FI msvc_recommended_pragmas.h

	* gdk/win32/gdkdrawable-win32.c : use _gkd_win32_copy_to_image
	and take care of image->visual possibly NULL.

	* gdk/win32/gdkimage-win32.c : implement _gdk_image_new_for_depth(),
	_gdk_win32_copy_to_image() and _gdk_windowing_bits_for_depth().
	Again take care of image->visual possibly NULL.

	* gdk/win32/gdkprivate-win32.h : declare _gdk_win32_copy_to_image()

	* gdk/win32/gdkevents-win32.c : use gdk_drawable_get_colormap
	instead of private field access

	* gdk/win32/gdkpixmap-win32.c (gdk_pixmap_new) : adapt
	colormap setting to the gdk-X behaviour

2001-01-04  Matthias Clasen  <matthiasc@poet.de>

 	* gtk/gtkwidget.c: Documentation additions.

2001-01-04  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkobject.c (gtk_object_dispose): Fix a comment.

	* gtk/gtkwidget.c (gtk_widget_set_sensitive): tiny docs change

2002-01-04  Havoc Pennington  <hp@pobox.com>

	* gtk/gtkwidget.c (gtk_widget_set_sensitive): tiny docs change
	
Fri Jan  4 13:05:15 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_find_widget): At least
	don't infinite loop if the widget and window heirarchies
	don't correspond.

	* gtk/gtkdnd.c (gtk_drag_find_widget): Handle changes
	in heirarchy in ::drag_motion, ::drag_drop callbacks
	by referencing child widget lists. (Patch from Tim)

	* gtk/gtkdnd.c (gtk_drag_find_widget): Fix a problem
	with widgets where window.x != widget->allocation.x

Fri Jan  4 01:36:48 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdrawable-x11.c (convert_to_format): Optimize
	a little bit. (More for consistency than because it
	makes much of a difference.)

Thu Jan  3 22:18:15 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdrawable-x11.c gdk/x11/gdkprivate-x11.h
	(_gdk_x11_have_render): Private function to tell if we have RENDER
	extension.

	* gdk/x11/gdkgc-x11.c (_gdk_x11_gc_get_fg_picture): Return
	None if we don't have RENDER extension.

	* gdk/x11/gdkpango-x11.c (gdk_pango_context_get): Don't
	use Xft unless we have render extension.

	* gdk/x11/gdkdrawable-x11.c (gdk_x11_drawable_get_picture):
	Handle missing render extension.

	* gdk/gdkdraw.c gdk/gdkdrawable.h gdk/gdkpixmap.c gdk/gdkwindow.c
	gdk/gdkinternals.h: Add a private copy_to_image() virtual function
	to the GdkDrawable vtable that extends get_image() to allow
	copying onto existing images.  Make the default implementation of
	get_image() use this so that backends don't have to implement
	both. Add private wrapper _gdk_drawable_copy_to_image().

	* gdk/x11/gdkimage-x11.c gdk/x11/gdkprivate-x11.c
	gdk/x11/gdkdrawable-x11.c (_gdk_x11_copy_to_image): Implement
	copy_to_image() semantics, speed up by using ShmPixmaps and
	XCopyArea when possible, XFlush() after ungrabbing the server,
	generally redo the logic once again.

	* gdk/gdkinternals.h gdk/x11/gdkimage-x11.c
	_gdk_windowing_bits_per_depth(): Function to convert from depth to
	bits-per-pixel. (We assume only one bpp per depth - X requires
	this.)

	* gdk/gdkinternals.h gdk/gdkrgb.c gdk/gdkimage.c: Move the GdkRGB
	scratch image code into a generic _gdk_image_get_scratch() chunk
	of code that we can use other places we need scratch images.

	* gdk/gdkimage.c gdk/x11/gdkimage.c gdk/gdkinternals.h:
	Add _gdk_image_new_for_depth() as the backend 
	to _gdk_image_new() to allowing creating images with
	a depth and no visual.

	* gdk/gdkpixbuf-drawable.c: Fix so that getting 
	parts of images not at 0,0 actually works.

	* gdk/gdkdrawable.h gdk/gdkinternals.h gdk/gdkdraw.c
	gdk/gdkwindow.c gdk/gdkpixmap.c gdk/gdkpixbuf-render.c: 
	 - Add a new GdkDrawableClass vfunc _draw_pixbuf, and 
	  _gdk_draw_pixbuf() [ will be made public later ], to allow 
	  backends to accelerate drawing pixbufs. 
	 - Move the implementation of gdk_pixbuf_render_to_drawable_alpha()
	   to be the default implementation. 
	 - Update docs for gdk_pixbuf_render_to_drawable_alpha(). 
	 - Optimize the default implementation by using 
	   _gdk_image_copy_to_pixmap() and scratch shared images, and
	   special casing the compositing.

	* gdk/x11/gdkdrawable-x11.c: Accelerate _gdk_draw_pixbuf()
	with alpha using the RENDER extension.

        * gdk/gdkpixbuf-drawable.c (gdk_pixbuf_get_from_drawable):
	Optimize by _gdk_image_copy_to_pixmap() and scratch images.

	* tests/testrgb.c: Add test for speed of alpha composition,
	reduce the number of iterations since alpha composition
	can be a bit slow.

	* gdk/x11/gdkimage-x11.c gdk/gdkprivate-x11.h (_gdk_x11_image_get_shm_pixmap): 
	Private function to get a ShmPixmap for an image, if possible.

2002-01-04  Anders Carlsson  <andersca@gnu.org>

	* tests/testtreesort.c: Add my cool list of integers.

Thu Dec 27 18:12:55 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkproperty-x11.c (gdk_property_get): Fix
	problem where retrieved atoms weren't properly returned.

2002-01-03  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktextview.c (gtk_text_view_key_press_event): When
	tab is pressed and the text view isn't editable, 
	move the focus instead.

	* gtk/gtkstyle.c (gtk_default_draw_focus): Free dash list if
	necessary.

	* gtk/gtkhsv.c (gtk_hsv_get_focus_gc): Free dash list.

	* gtk/gtkcolorsel.c (get_focus_gc): Free dash list.

	* gtk/gtkdnd.c (set_icon_stock_pixbuf): Don't unref the mask
	if it's NULL.

	* gtk/gtktreeview.c: Rename gtk_tree_view_queue_draw_node to
	_gtk_tree_view_queue_draw_node.
	(gtk_tree_view_row_has_child_toggled): Only redraw one node.

	* gtk/gtktreesortable.c (gtk_tree_sortable_set_sort_func): 
	sort_column_id can be 0.

	* gtk/gtktreeselection.c (gtk_tree_selection_real_select_node):
	Only redraw one the node being selected.

	* gtk/gtktreeprivate.h: Add _gtk_tree_view_queue_draw_node.
	
Wed Jan  2 23:09:06 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkcontainer.c (_gtk_container_queue_resize): don't ignore
	realized but visible && !mapped resize containers (which is
	possible with unset CHILD_VISIBLE now).

2002-01-02  jacob berkman  <jacob@ximian.com>

	* gtk/Makefile.am (LDFLAGS): automake still doesn't support
	libsomething_la_LDFLAGS, so fix the build again

2002-01-01  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (gtk_text_view_expose_event): propagate
	exposes to no window children not in the buffer window.
	(gtk_text_view_class_init): add move_focus bindings for Ctrl-Tab
	- is this the right way to do it?
	(gtk_text_view_focus): add focus method, just chains up for now, 
	I'm not sure why the GtkContainer implementation doesn't work

	* gtk/gtktextbtree.c (_gtk_text_btree_insert_child_anchor): fill
	in the text line for the child anchor segment

	* tests/testtext.c (do_add_focus_children): add another test
	example (to put focusable buttons into the widget)

2002-01-01  Havoc Pennington  <hp@pobox.com>

	* docs/README.linux-fb: note that this file is obsolete

	* docs/Changes-2.0.txt, docs/Changes-1.2.txt: Add notes to these
	files that they should not be edited and look in the reference 
	manual instead. Probably these files should just be replaced by 
	the note, and their main contents deleted.

	* gtk/gtktextview.c: docs

	* gtk/gtktextmark.c: docs

	* gtk/gtktextchild.c: docs

	* gtk/gtktextbuffer.c: docs stuff

	* gtk/gtkclipboard.c (gtk_clipboard_get): fool with docs to maybe
	give people more leads in sorting out PRIMARY vs. CLIPBOARD

2002-01-01  Tor Lillqvist  <tml@iki.fi>

	* demos/Makefile.am (test-inline-pixbufs.h): Append EXEEXT to
	../gdk-pixbuf/gdk-pixbuf-csource.

2001-12-31  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkgc-win32.c (predraw_set_foreground): Improved error
	handling.
	(gdk_win32_hdc_get,gdk_win32_hdc_release): Silence gcc -Wall.

	* gdk/win32/gdkimage-win32.c (_gdk_win32_get_image): Silence gcc
	-Wall.  Use GDK_IS_PIXMAP_IMPL_WIN32 instead of GDK_IS_PIXMAP in
	one more place.

	* gdk/win32/gdkinput-win32.c (_gdk_input_other_event): Silence gcc
	-Wall.

	* gtk/Makefile.am (libgtk_win32_1_3_la_LDFLAGS): Add -lwsock32.

2002-01-01  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (gtk_text_view_get_default_attributes): doc 
	fix
	
2002-01-01  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (changed_handler): Replace call to
	gtk_widget_size_request() that expected to actually compute the
	request with a direct use of widget_class->size_request, so we get
	our size request right; fixes remaining part of #63065 reported by
	Matthias Clasen

2001-12-31  Havoc Pennington  <hp@pobox.com>

	* tests/testtext.c (do_insert_and_scroll): remove backward_char
	since we no longer have bogus newline
	(dialog_response_callback): remove another backward_char horkage, 
	reported by Matthias Clasen #63065

2001-12-31  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextbtree.c (gtk_text_btree_node_view_check_consistency):
	fix an incorrect assertion that the "valid" flag is always correct
	in a node and add explanatory comment. This keeps me from 
	reproducing #59101, but I'm remembering that 59101 was actually 
	about incorrect pixel totals, so I'm not sure 59101 is actually 
	fixed. May just have stopped happening due to some change in 
	how C-k works.

2001-12-31  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (gtk_text_view_start_selection_drag): extend
	selection if shift is down, bug #50939
	(gtk_text_view_button_press_event): add double/triple click
	selection to the current selection if shift is down

2001-12-31  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextiter.c (gtk_text_iter_get_visible_line_index): fix 
	to use ensure_byte_offsets not ensure_char_offsets, patch 
	from Padraig O'Briain bug #67356
	
2001-12-30  Havoc Pennington  <hp@pobox.com>

	* gtk/gtkdialog.h (GtkDialogFlags): fix GtkDialogFlags to have 
	the right values, reported by Jeff Franks

2001-12-30  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkwindow.c, gtk/gtkimcontextsimple.c: Minor documentation tweaks.

2001-12-28  Matthias Clasen  <matthiasc@poet.de>

	* gdk/x11/gdkproperty-x11.c, gdk/x11/gdkselection-x11.c: 
	Minor documentation tweaks.

2001-12-28  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkfont-win32.c: Use G_N_ELEMENTS().
	(unicode_classify): Don't return -1 on encountering an
	unclassified character, but play it safe and return U_BASIC_LATIN.

Thu Dec 27 16:05:30 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkarrow.c gtk/gtkimage.c gtkpixmap.c: Make interpretation
	of misc->xpad/ypad consistent with GtkLabel. Do 
	directional flipping when interpreting misc->xalign/yalign.
	Fix off-by-one error for negative x,y. (#67472, reported
	by Mathieu Lacage)

Thu Dec 27 15:45:41 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_set_style_internal):
	Remove optimization that was causing problems because
	we called gtk_widget_size_request() before we called
	gtk_widget_queue_resize() so RESIZE_NEEDED was not
	set. Optimization shouldn't mattter now that we
	are smart about needlessly size requesting or allocating
	widgets. (#67598, reported by Jacob Berkman)

Thu Dec 27 15:38:20 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_stop_navigating_submenu_cb):
	Call gdk_window_get_pointer() on menu->bin_window not
	menu->window, so we get the correct window for the
	menu item. (#65213, Guillermo S. Romero)

Thu Dec 27 15:13:44 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_set_title): Allow unsetting
	the title by setting to NULL. Move docs inline. 
	Update the title if the tearoff window already
	exists. Code cleanup. (Fixes #65190, reported by
	Vitaly Tishkov.)

Thu Dec 27 14:04:22 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.c (gtk_socket_key_press_event): 
	gtk/gtkplug.c (gtk_plug_key_press_event): Don't do
	special handling of key presses unless we are doing 
	iter-app embedding. (Fixes #67590, Anders Carlsson)

Thu Dec 27 16:37:04 2001  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_row_deleted),
	(gtk_tree_model_sort_sort_level),
	(gtk_tree_model_sort_insert_value): fix a few places where
	I was confused between modelsort iters and other iters. This was
	really going to happen someday ;)

Wed Dec 26 23:41:41 2001  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_rows_reordered): ensure
	we are unprelighted before reordering

	* gtk/gtktreemodel.c (gtk_tree_row_ref_reordered_callback): we
	need to break out of the for loop, not return (this fixed
	the 'selection freeze' bug).

	* gtk/gtktreemodelsort.c: more fixage and cleanups. It seems to
	be pretty stable now, though it still needs some more code
	cleanups.

Wed Dec 26 12:32:31 2001  Owen Taylor  <otaylor@redhat.com>

	* docs/Changes-2.0.txt: Document the fact that
	gtk_paned_set_handle_size() has been removed.

	* gtk/gtkpaned.h Remove gtk_paned_handle_size() compat macro, 
	since it pointed to gtk_paned_set_handle_size(), which
	was removed. (#66760, Matt Wilson)

Wed Dec 26 12:28:24 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_highlight): Connect 
	gtk_drag_hightlight_expose _after_, so it works with
	widgets that paint there entire background. (#66735)

Wed Dec 26 12:17:06 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkplug.c (gtk_plug_size_allocate): Assign the
	allocation to widget->allocation. (Fixes #67290,
	Chris Phelps.)

Wed Dec 26 11:49:01 2001  Owen Taylor  <otaylor@redhat.com>

	(#67542, reported by Anders Carlsson)
	
	* gtk/gtkstyle.c (gtk_style_real_init_from_rc): Merge
	rc_style->font_desc with defaul style instead of replacing
	it.

	* gtk/gtkrc.c (gtk_rc_style_real_merge): Allow partial
	font descriptions in RC styles by calling
	pango_font_description_merge(). 

2001-12-24  James Henstridge  <james@daa.com.au>

	* gtk/gtkdialog.h (doc comment): s/<!>/<!-- -->/ to make the doc
	valid with both SGML and XML.

Sat Dec 22 12:38:03 2001  Owen Taylor  <otaylor@redhat.com>

	* configure.in: 1.3.12, interface, binary age 0.

	* configure.in: Require new versions of Glib, Pango, ATK.

	* NEWS: Updated.

	* configure.in: Make explicit what libtool we are executing.
	(Tomas Ogren)

	* gdk/gdkcolor.c gdk/gdkgc.c gdk/gdkwindow.c: Doc fixes.

	* gtk/gtkwidget.c (gtk_widget_[class]path) gtkrc.h : Fix 
	parameter names for docs.

Sat Dec 22 22:35:29 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_realize) 
	  gtk/gtkplug.c (gtk_plug_realize): Include GDK_KEY_RELEASE_MASK.

	* gtk/gtkentry.c (gtk_entry_key_release)
	  gtk/gtktextview.c (gtk_text_view_key_release_event): Pass
	key release events to the input method.

	* gtk/gtkimcontextsimple.c (gtk_im_context_simple_filter_keypress): 
	Handle release of Control/Shift to end hex sequence.

	* modules/input/gtkimcontextxim.c (gtk_im_context_xim_filter_keypress): 
	Handle key releases as well as presses.

2001-12-21  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtktoolbar.c (gtk_toolbar_insert_element): Trivial doc adjustment.

	* gtk/gtklabel.c (gtk_label_new_with_mnemonic),
	gtk/gtkbutton.c (gtk_button_new_with_mnemonic): More precise
	documentation about underscores and mnemonics. (#66380)

	* gtk/gtktextiter.c (gtk_text_iter_backward_word_starts): Fix
	cyclic reference in docs.

	* gtk/gtklabel.c (gtk_label_set_justify): Correct documentation
	of default value. (#65402)

	* gtk/gtkmain.c (gtk_set_locale, gtk_disable_set_locale): 
	Markup fixes.

2001-12-20  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktreeview.c (gtk_tree_view_realize): Don't call
	map here.

Tue Dec 18 16:15:55 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkgc.h: Explicitely deprecate gdk_gc_set_font()
	(reported by Jeff Franks.)

Tue Dec 18 16:07:28 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkkeys.h (struct _GdkKeymapClass): Fix 
	prototype for direction_changed. (Reported by
	Jeff Franks.)

2001-12-18  Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtktreeview.c (gtk_tree_view_get_expander_column):
	Fix typo (list->data becomes list->next)

2001-12-06  Havoc Pennington  <hp@redhat.com>

        Add Unicode control char menu, based on patch from Dov.
	Bug #63495
	
	* gtk/gtkentry.c (gtk_entry_commit_cb): share code via
	gtk_entry_enter_text
	(gtk_entry_enter_text): function to do "typing in text"
	(popup_targets_received): add the Unicode menu items

	* gtk/gtktextview.c (popup_targets_received): add missing mnemonic
	on Input Methods item, and add the unicode menu items.

	* gtk/gtktextutil.h, gtk/gtktextutil.c: private utilities to be
	used in GtkEntry and GtkTextView - may become public later.	

2001-12-16  Kjartan Maraas  <kmaraas@gnome.org>

	* gtk/gtkprogressbar.c: Fix a typo.
	* gtk/gtkpaned.c: Fix a typo.
	
2001-12-15  Darin Adler  <darin@bentspoon.com>

	Fix some warnings.

	* gdk/x11/gdkproperty-x11.c: (gdk_property_get): Fix wrong type in
	g_new -- bug if sizeof (GtkAtom) != sizeof (GtkAtom *).
	* gdk/x11/gdkwindow-x11.c: (create_moveresize_window): FALSE -> NULL
	* gtk/gtkaccellabel.c: (gtk_accel_label_refetch): Remove unused local.
	* gtk/gtklistitem.c: (gtk_list_item_expose): Remove unused local.
	* gtk/gtktextiter.c: (_gtk_text_iter_backward_indexable_segment):
	Restructure loop to get rid of uninitialized variable warning. Also
	gives a tiny efficiency gain.

2001-12-15  Murray Cumming  <murrayc@usa.net>

	* Fixed first arg type of GtkScale's "format_value" signal's
	function pointer.

2001-12-14            Vitaly Tishkov       tvv@sparc.spb.su
        docs/reference/gtk/tmpl/gtkcelleditable.sgml
                gtkcelleditable -> GtkCellEditable
        docs/reference/gtk/tmpl/gtktreesortable.sgml
                gtktreesortable -> GtkTreeSortable

2001-12-13  Sebastian Wilhelmi  <wilhelmi@ira.uka.de>

	* demos/testpixbuf-drawable.c, demos/testpixbuf-save.c,
	demos/testpixbuf-scale.c, demos/testpixbuf.c: Call g_object_ref
	and g_object_unref instead of gdk_pixbuf_ref and gdk_pixbuf_unref
	resp.

Thu Dec 13 22:02:41 2001  Kristian Rietveld   <kris@gtk.org>

	* gtk/gtktreeview.c (validate_visible_area): free path
	at the end

2001-12-13  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkdialog.c, gtk/gtkrc.c, gtk/gtkwidget.c: Markup fixes.

Thu Dec 13 20:37:27 2001  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_button_press): do not try
	to find the clicked node in the tree when tree == NULL

2001-12-13  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktreeview.c (gtk_tree_view_button_press): Compare 
	event->state with the default mod mask. 

2001-12-12  jacob berkman  <jacob@ximian.com>

	* gtk/gtk*.h (GTK_IS_*_CLASS): s/obj/klass/ where appropriate

Wed Dec 12 17:22:45 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimmulticontext.c (gtk_im_multicontext_set_slave):
	Reset the existing slave before removing it to give
	it a chance to commit and emit "preedit_changed" 
	in case there was still a preedit string.

2001-12-12  Matthias Clasen  <matthiasc@poet.de>
	
	* gtk/gtktextlayout.c: Typo fixes
	* gtk/gtkwindow.c (gtk_window_set_position): Typo fix. (#66746)

	* gtk/gtkwidget.c (gtk_widget_send_expose, gtk_widget_get_toplevel, 
	gtk_widget_get_default_direction): Doc fixes. (#66727, #66737, #66744)

	* gtk/gtkstyle.h (GTK_STYLE_NUM_STYLECOLORS): Remove. (#66467)

Wed Dec 12 16:43:10 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_unrealize): Remove
	validate_rows_timer in unrealize.  Reported by Matthew Wilson.

Wed Dec 12 16:18:26 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_realize): Remove support for
	"prepainting" the menu before realizing other than
	via gtk_style_set_background() - this was broken when
	we added menu scroll support.

	* gtk/gtkmenu.c (gtk_menu_paint): Pay attention to the
	window in the expose event -- fixes problem with border
	flashing during scrolling.

Wed Dec 12 15:11:49 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksettings.c (gtk_settings_get_property): Support
	using names/nicks for the gdk_settings values for enum valued
	types. (#57678, reported by Anders Carlsson)

Wed Dec 12 15:01:33 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_set_tab_label): keep in sync
	with insert_page_menu.  Code duplication is bad.

	* gtk/gtklabel.c (gtk_label_mnemonic_activate): Whoops -- got the
	wrong fix yesterday.

Wed Dec 12 14:27:30 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenubar.c (window_key_press_handler): Fix check for
	modifiers.

2001-12-12  James Henstridge  <james@daa.com.au>

	* gtk/gtkmenu.c (gtk_menu_key_press): check GTK_MENU_ITEM
	(menu_item)->accel_path first when looking up the accel path.

Tue Dec 11 19:18:21 2001  Owen Taylor  <otaylor@redhat.com>

	* tests/testgtk.c (layout_expose_handler): Only draw
	for events on the bin window.

Tue Dec 11 18:55:16 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtklabel.c (gtk_label_mnemonic_activate): Small fix to let
	mnemonics work with notebooks.

Tue Dec 11 15:25:06 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_size_allocate): Change
	bin_window to be located at y=TREE_VIEW_HEADER_HEIGHT(tree_view).
	Makes some flicker while scrolling go away.

2001-12-11  Michael Natterer  <mitch@gimp.org>

	* demos/testpixbuf-save.c: added new keyboard shortcut 'a' which
	adds alpha to the pixbuf; re-load the saved pixbuf and
	pixel-by-pixel compare it with the original one.

Tue Dec 11 15:39:08 2001  Soeren Sandmann  <sandmann@daimi.au.dk>

	* ChangeLog: Fix wrong ChangeLog entry
	* gtk/gtkstyle.c (gtk_default_draw_shadow_gap): Fix drawing of top
	right corner

2001-12-10  jacob berkman  <jacob@ximian.com>

	* gdk/x11/gdkinput-xfree.c (_gdk_input_grab_pointer): 
	* gdk/x11/gdkmain-x11.c (gdk_pointer_grab): 
	(gdk_keyboard_grab): do not grab things if the nograb debug flag
	is set

	* gdk/gdkinternals.h: 
	* gdk/gdk.c: add nograbs debug flag to disable grabs of the
	keyboard / mouse

Mon Dec 10 19:42:29 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (validate_rows_handler): stupid bug where I
	didn't reset the timer.

2001-12-10  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkcontainer.c (gtk_container_child_type): Close comment.

2001-12-09  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkviewport.c: Add docs.

Mon Dec 10 16:21:38 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkrbtree.c (_fixup_parity): New function to fixup parity.
	RBTree corruption bug--

2001-12-10  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktreeview.c (gtk_tree_view_remove_widget): Return
	if edited_column is NULL, also grab focus before removing
	the cell_editable.

Sun Dec 09 15:06:51 2001  George Lebl <jirka@5z.com>

	* gtk/gtkrange.c (gtk_range_calc_layout): check for 0 value on the
	  denominator in the horizontal case just like we do in the vertical
	  case (why I didn't notice that there were two cases the first time
	  around is beyond me:).  Also fix indentation in the vertical case.

2001-12-09  Anders Carlsson  <andersca@gnu.org>

	* gdk/x11/gdkevents-x11.c: Update xsettings name.

	* gtk/gtkdnd.c (gtk_drag_check_threshold): Use the
	gtk-dnd-drag-threshold GtkSetting.

	* gtk/gtksettings.c (gtk_settings_class_init): Add 
	setting for dnd drag threshold.

2001-12-09  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkcontainer.c: Add docs.

2001-12-08  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkwidget.c: Doc markup fix. 

	* gtk/gtktreeviewcolumn.c: Markup fixes. (#66447)

	* gtk/gtktreestore.c: Typo fixes. (#66445)

	* gtk/gtkaccelgroup.c: Misc doc markup. (#66425) 

	* gtk/gtkclipboard.c (gtk_clipboard_get_owner): Fix reference
	to gtk_clipboard_set_with_owner(). (#66424)
 
Sat Dec  8 16:12:10 2001  Christopher Blizzard  <blizzard@redhat.com>

	* gdk/gdk.c (gdk_init_check): Fallback to setting the prgname to
	"<unknown>" if someone doesn't pass in a valid argc.  (Patch from
	Fabrice Bellet <fabrice@gnu.org>, #54127).

Sat Dec  8 10:04:54 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkrbtree.c (_gtk_rbtree_debug_spew): Add debug spew to lots
	of places, so that people with crashy trees can just run their
	program with GTK_DEBUG=TREE.

Sat Dec  8 20:57:24 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtkliststore.c (gtk_list_store_remove): nuke the stamp++,
	per jrb's request

2001-12-08  Anders Carlsson  <andersca@gnu.org>

	* tests/testgtk.c (layout_expose_handler): Don't return TRUE
	since then the default GtkLayout expose handler won't be called.

Fri Dec  7 23:42:50 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (validate_rows_handler): remove
	g_return_if_fail.

	* gtk/gtktreeview.c (validate_visible_area): Patch from Manish
	Singh <yosh@gimp.org> to fix bug when rendering Tree with an
	empty model.

Fri Dec  7 20:06:14 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (validate_visible_area): get logic right,
	#66249

	* gtk/gtkrbtree.c (_gtk_rbtree_remove_node): fix bug where
	removing a node ended up with a corrupt tree.  Really really nasty
	bug.
	(_gtk_rbtree_debug_spew): new debug helper function
	(_fixup_validation): new inline function to clean up code
	readability a lot. 

Fri Dec  7 19:34:51 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktoolbar.c (gtk_toolbar_insert_element):
	Close comment.

2001-12-07  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkstyle.h: Typo fixes.

	* gtk/gtkstyle.c, gtk/gtktoolbar.c: Add docs.

	* gtk/gtkrc.c (gtk_rc_find_pixmap_in_path): Fix docs.

Fri Dec  7 16:05:22 2001  Owen Taylor  <otaylor@redhat.com>

	* modules/input/gtkimcontextxim.c: Display the XIM
	status callbacks with a popup window. (Patch from
	HideToshi Tajima, #50628, somewhat modified.)

Fri Dec  7 12:07:15 2001  Tim Janik  <timj@gtk.org>

	* gtk/Makefile.am: each source generation rule needs to use its own
	temporary file, to avoid clashes for parallel builds. fixed rules
	for gtkmarshalers.h and gtkmarshalers.c to use their own temp files.

2001-12-07  Havoc Pennington  <hp@pobox.com>

	* gdk/x11/gdkcursor-x11.c (gdk_cursor_new): fix up my list of
	"cursors that are actually useful" in gdk_cursor_new() docs

Thu Dec  6 23:09:21 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtk[hv]paned.c (gtk_[hv]paned_size_allocate): Fix errors
	in computing the size of the second child.

Thu Dec  6 16:50:17 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c: Make button 1 clicks on the trough
	do pages, button 3 steps. (Patch from Hans Breuer
	#63735)

2001-12-06  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtklabel.c: Fix docs. (#66383)

	* gtk/gtkbbox.c (gtk_button_box_set_child_secondary): Fix docs. 
     	(#66278, #66280)
	
	* gdk/gdkwindow.h (gdk_window_get_deskrelative_origin),
	gdk/gdkimage.h (gdk_image_get): Deprecate. (#66208)

	* gtk/gtkcolorsel.c (gtk_color_selection_set_update_policy):
	Don't emit a g_warning() about being deprecated. (#66208)	

	* gtk/gtkaccellabel.c (gtk_accel_label_set_accel_widget): Add docs.

	* gtk/gtkcontainer.c: Doc fixes.
	
	* gtk/gtkliststore.c (gtk_list_store_clear): Add docs; misc doc fixes.

	* gtk/gtkstyle.c (gtk_style_attach): Add docs.

2001-12-05  Sven Neumann  <sven@gimp.org>

	* gtk/gtkwidget.c (gtk_widget_reset_shapes): close comment.

	* gtk/queryimmodules.c: g_dir_read_name() returns const.

Tue Dec  4 21:46:13 2001  HideToshi Tajima  <hidetoshi.tajima@sun.com>

	* gtk/gtktreeprivate.h: restore the else case of #ifdef __GNUC__
	#66225
	
2001-12-04  Manish Singh  <yosh@gimp.org>

	* gtk/gtkmain.c
	* gtk/queryimmodules.c: g_module_symbol takes a gpointer *, not just
        a gpointer.

	* gtk/gtkwidget.c (gtk_widget_push_composite_child): minor cosmetic
	correction to docs.

	* demos/gtk-demo/item_factory.c: add GTK_WINDOW() cast

2001-12-04  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextbtree.c (gtk_text_btree_remove_tag_info): remove
	g_assert_not_reached() that was bogus, since we demand-create the
	tag info. reported by Chris Phelps

        Jump through assorted hoops to fix bug from Chris Phelps where 
	removing tags from the table resulted in btree trying to 
	access tag->table
	
	* gtk/gtktextbuffer.c: set up mechanics of adding/removing 
	ourselves to the tag table

	* gtk/gtktexttagtable.c (_gtk_text_tag_table_add_buffer) 
	(_gtk_text_tag_table_remove_buffer): private cruft to 
	let us notify buffer of disappearing tags

	* gtk/gtktexttag.h: remove BTreeNode typedef from this public
	header, put it in tagprivate	

	* gtk/gtktextbtree.c (_gtk_text_btree_new): don't connect to
	tag_removed; it's emitted too late.
	(_gtk_text_btree_notify_will_remove_tag): rename tag_remove_cb to
	this

	Padding for ABI-compat expansion
	
	* gtk/gtktexttag.h (struct _GtkTextAttributes): pad this
	(struct _GtkTextAppearance): one pad in here too

	* gtk/gtktextlayout.h (struct _GtkTextLayoutClass): padding here

	* gtk/gtktextview.h (struct _GtkTextViewClass): more padding,
	since action signals etc. seem pretty likely

	* gtk/gtktextbuffer.h (struct _GtkTextBufferClass): padding

	* gtk/gtktexttag.h (struct _GtkTextTagClass): padding

	* gtk/gtktexttagtable.h (struct _GtkTextTagTableClass): padding

2001-12-04  Matthias Clasen  <matthiasc@poet.de>

        * gdk/gdkcolor.h (gdk_colormap_change): Deprecate. (#65851)

        * gdk/gdktypes.h (GdkKeyInfo): Remove. (#66025)

	* gtk/gtkwindow.c, gtk/gtkwidget.c: Add docs, markup fixes.

Tue Dec  4 18:51:44 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeviewcolumn.h: remove gtk_tree_view_column_cell_event,
	#62084.

Tue Dec  4 18:38:35 2001  Jonathan Blandford  <jrb@redhat.com>

	* demos/gtk-demo/main.c: (create_tree): Minor fix.

	* docs/tree-column-sizing.txt: Update

	* gtk/gtkrbtree.[ch]: Massive work to support validation.

	* gtk/gtktreemodel.c: Doc fixes.

	* gtk/gtktreeview.c: Incremental reflow added.
	* gtk/gtktreeviewcolumn.c: ditto
	* gtk/gtktreeviewcolumn.h: ditto

2001-12-04  Havoc Pennington  <hp@redhat.com>
	
	* gtk/gtktexttag.c (gtk_text_tag_set_property): add a warning for
	"invisible" property, #65999

2001-12-04  Matt Wilson  <msw@redhat.com>

	* gtk/gtktreestore.c (gtk_tree_store_insert): fixed docs

Tue Dec  4 12:16:31 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksettings.c (gtk_settings_set_property_value):
	Simplify, make more efficient and fix memory leak
	when turning quark into a string. (#66103, HideToshi
	Tajima)

	* gtk/gtkcolorsel.c: Ref and sink priv->tooltips in
	init() and unref priv->tooltips in destroy rather
	than calling gtk_object_destroy() which has no
	effect on memory management. (#66104, HideToshi
	Tajima)

	* gtk/gtkcolorsel.c (palette_set_color): Use g_object_set_data_full()
	so we free the when the object is freed. (Fixes memory
	leak, #66096, HideToshi Tajima)

	* gdk/gdkevents.c (gdk_synthesize_window_state): Use 
	a full GdkEvent structure to avoid reads of uninitialized/
	invalid memory in gdk_event_put() (#65877, patch
	from Hidetoshi Tajima)

Tue Dec  4 11:06:54 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenuitem.c: Revert my last mistaken change - 
	toggle-size-request doesn't take a requisition.

	* gtk/gtkmenuitem.c (gtk_menu_item_class_init): Fix
	reference to marshaler that no longer exists.

Mon Dec  3 16:39:17 2001  Owen Taylor  <otaylor@redhat.com>

	Patch from Bill Haneman (with many modifications) to make
	the focus color work on dark themes and to make the
	focus line width configurable. (#61079, #63074)

        * gtk/gtkwidget.c: Add style properties, 
	::focus-widget, ::focus-line-width, and ::focus-padding.

	* gtk/gtkstyle.[ch]: Make gtk_paint_focus() take a 
	state argument as well so we can use fg[STATE] to
	draw instead of always drawing with black. 
	Cange paint_focus() to respect GtkWidget::focus-width
	and GtkWidget::focus-line-pattern. Fix continuity
	problem where the default 1-1 stipple had a blob
	in one corner and a gap in the other. Change the
	interpretation of x/y/width/height to be the bounding
	box of the focus rect instead of the rectangle
	passed to gdk_draw_rectangle.

	* gtk/gtkcheckbutton.c gtk/gtklistitem.c gtk/gtknotebook.c 
	gtk/gtkoptionmenu.c gtk/gtkradiobutton.c gtk/gtkspinbutton.c 
	gtk/gtktextview.c gtk/gtktreeview.c: Handle ::focus-width 
	and ::focus-line-padding.

	* gtk/gtkentry.c: Handle :;focus-width property; cleanup
	and remove duplicated code; fix drawing of focus rectangle
	when interior-focus = FALSE. (#63072, #63073)

	* gtk/gtkrange.c gtk/gtktext.c gtk/gtktreeitem.c
	gtk/gtktreeviewcolumn.c: Basic fixups to make compile;
	Range and TreeViewColumn will need more extensive fixing.

	* gtk/gtkcolorsel.c: Honor focus line attributes when
	drawing the focus on the color swatches. (#63071)

	* gtk/gtkhsv.c: Honor focus line attributes when
	drawing the focus for the ring and triangle.

	* docs/widget_geometry.txt: Start at documenting how 
	various widgets are drawn.

	* gtk/gtkbutton.c (_gtk_button_paint): Export 
	_gtk_button_paint() librarywide, so we don't have 
	duplicate a bunch of code in gtktogglebutton.c.

	* gtk/gtktogglebutton.c: Use _gtk_button_paint().

Mon Dec  3 21:04:13 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkmarshalers.list: remove VOID:BOXED,POINTER and
	NONE:POINTER.

2001-12-03  Alex Larsson  <alexl@redhat.com>

	* gtk/gtkaccellabel.c:
	* gtk/gtkarrow.c:
	* gtk/gtkcolorsel.c:
	* gtk/gtkcontainer.c:
	* gtk/gtklabel.c:
	* gtk/gtktextview.c:
	* gtk/gtktogglebutton.c:
	* gtk/gtktreeview.c:
	* gtk/gtkwindow.c:
	Return FALSE from expose handlers.

Mon Dec  3 21:15:59 2001  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreedatalist.c (_gtk_tree_data_list_value_to_node): if
	we use pointers, we should free the previous pointer first (if
	it exists), before we set a new pointer. (#64726)

	* gtk/gtktreeprivate.h: get rid of cursor_drag

	* gtk/gtktreeview.c (gtk_tree_view_unrealize): remove check	
	for cursor_drag
	(gtk_tree_view_bin_expose): don't directly return in the while
	loop
	(gtk_tree_view_class_init): indentend expanders by default
	(gtk_tree_view_header_focus): only give the button focus
	if it's clickable, visible and the column is reorderable
	(#65539)

	* gtk/gtktreeviewcolumn.c (_gtk_tree_view_column_realize_button):
	create and free cursor

Mon Dec  3 10:23:07 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcalendar.c (gtk_calendar_size_request): Fix
	some bugs with size requisition. (From Bill Haneman)

	* gtk/gtkcalendar.c: Draw headers and selection in 
	base/text[SELECTED] instead of fg/bg[SELECTED].

	* gtk/gtkcalendar.c: Miscellaneous cleanups to drawing
	code and formatting.

2001-12-03  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (set_window_height): 
	(set_window_width): Hmm, setter functions normally assign the new
	value to the object field. Reported by Chris Phelps.

2001-11-30  jacob berkman  <jacob@ximian.com>

	* gtk/gtknotebook.c (gtk_notebook_remove_tab_label): set the
	signal id to 0 after we disconnect from it

2001-11-30  Matthias Clasen  <matthiasc@poet.de>

	* gdk/gdkdrawable.h (gdk_drawable_ref, gdk_drawable_unref),
	gdk/gdkcolor.h (gdk_colormap_ref, gdk_colormap_unref),
	gdk/gdkdnd.h (gdk_drag_context_ref, gdk_drag_context_unref),
	gdk/gdkgc.h (gdk_gc_ref, gdk_gc_unref):	 Deprecate.

	* gdk/gdkvisual.h: Use GDK_DISABLE_DEPRECATED, not 
	GTK_DISABLE_DEPRECATED.

	* gdk/gdkcolor.c (gdk_colormap_ref, gdk_colormap_unref),
	gdk/gdkgc.c (gdk_gc_ref, gdk_gc_unref): Document.

Fri Nov 30 16:37:01 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcombo.c (gtk_combo_popup_list): Sanitize
	move/resize code, removing various bad, non-functional
	hacks. (Fixes #65048, reported by Damon Chaplin.)

Fri Nov 30 16:12:21 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkpango.c: Patch from Hidetoshi Tajima to fix 
	bad match error when target drawable is not the 
	same depth as the root window. (#65841)

	* HACKING: Update.

2001-11-29  Matthias Clasen  <matthiasc@poet.de>

	* gdk/gdkwindow.c: Typo fix.

Thu Nov 29 21:35:56 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtkmenu.c (gtk_menu_motion_notify): add checks for
	empty menu items to behave like insensitive items (#59456)

	* gtk/gtkmenuitem.c (gtk_real_menu_item_activate_item): select
	next item if the first item in the menu is a tear off item
	(#59456-2, suggestion by Matthias Clasen)

	* gtk/gtkmenushell.c (gtk_menu_shell_button_press),
	(gtk_menu_shell_button_release), (gtk_menu_shell_entry_notify),
	(gtk_menu_shell_leave_notify), (gtk_real_menu_shell_move_current),
	(gtk_real_menu_shell_activate_current): add check, so empty
	menu items behave like insensitive items (#59456)
        
	* gtk/gtkmenuitem.[ch]: add _gtk_menu_item_is_selectable to make
	the checks more readable ...
	
	* gtk/gtkmenushell.c (gtk_menu_shell_button_press),
	(gtk_menu_shell_button_release): causes the menu to dropdown if the
	caption is clicked again (#64977)

2001-11-29  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextiter.c (_gtk_text_iter_forward_indexable_segment):
	assertion here that we were at the end iterator was not correct;
	change code to move us to the end iterator. bug #65731

Wed Nov 28 20:05:44 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccellabel.c (gtk_accel_label_refetch): Remove 
	improper use of g_locale_to_utf8() to convert from
	latin-1, and do it the easy way by building the string
	correctly in the first place.

Wed Nov 28 19:34:15 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkproperty-x11.c (gdk_property_change, gdk_property_get): 
	Convert atoms to and from atoms for properties of type XA_ATOM.
	(#65555, patch from Hidetoshi Tajima)

Wed Nov 28 18:37:04 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.[ch] (gtk_socket_add_id): Rename 'id' parameter 
	to avoid problems with Objective C.

2001-11-28  Matthias Clasen  <matthiasc@poet.de>
	
	* gtk/gtkaccelmap.c: Typo fixes. (#65607)

	* gtk/gtkfixed.c (gtk_fixed_set_has_window, gtk_fixed_get_has_window):
	Fix docs. (#65505)

	* gtk/gtkwindow.c (gtk_window_set_mnemnonic_modifier): Document.

Wed Nov 28 18:19:12 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_set_tearoff_hints): Move
	accounting of menu->tearoff_scrollbar width to here
	and make sure we have the correct requisition.

	* gtk/gtkmenu.c (gtk_menu_position): Fix fixme
	by using gtk_window_move().

	* gtk/gtkmenu.c (gtk_menu_set_tearoff_state): Force
	the requisition to be updated by calling
	gtk_widget_size_request() (#65440)

	* gtk/gtktearoffmenuitem.c (gtk_tearoff_menu_item_activate): 
	queue resize before calling gtk_menu_set_tearoff_state().

Wed Nov 28 22:20:44 2001  Kristian Rietveld  <kristian@planet.nl>

	* demos/gtk-demo/editable_cells.c: fix typo

	* demos/gtk-demo/list_store.c (add_columns): remove call to
	gtk_tree_view_column_set_clickable which didn't make sense

2001-11-28  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_paint): put the warning
	explaining the validation error in front of the G_BREAKPOINT

	* gtk/gtkrange.c (gtk_range_adjustment_value_changed): call
	process updates with include_children = FALSE instead of TRUE, so
	we redraw the range only, not the whole darn window.  Making
	GtkRange a NO_WINDOW widget had weirdly caused the text widget
	Trace/breakpoint trap bug to become much easier to trigger.

Wed Nov 28 14:12:03 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/Makefile.am (gdk_public_h_sources): Remove reference
	to gdkcursors.h.

2001-11-28  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkwindow.c (gtk_window_move): Add markup to docs.

	* gdk/gdkcursor.h: Directly include the contents
	of gdkcursors.h in the GdkCursorType enum.

	* gdk/gdkcursors.h: Deleted.

	* gdk/gdkkeysyms.h: Remove XFree86-specific keysyms, add 
	header boilerplate.

	* gdk/Makefile.am: Remove the X-derived-headers rule.

Tue Nov 27 20:17:55 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcheckmenuitem.c (gtk_check_menu_item_activate):
	Notify on the ::active property _here_, not in
	gtk_check_menu_item_set_active.

Mon Nov 26 19:11:18 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkcellrendererpixbuf.c
	(gtk_cell_renderer_pixbuf_class_init): add 2 properties
	(PIXBUF_EXPANDER_OPEN and PIXBUF_EXPANDER_CLOSED)

Sun Nov 25 21:19:02 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkgeometry-x11.c: Add long, but horribly sketchy
	comment about what is going on in this file.

	* gdk/x11/gdkgeometry-x11.c (gdk_window_compute_position): Fix 
	x/y problem.

Sun Nov 25 18:59:19 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkoptionmenu.c (gtk_option_menu_calc_size): 
	Calculate size based on the _child_ of the menu item,
	not the menuitem. (#65005, Damon Chaplin)

	* gtk/gtklistitem.c (gtk_list_item_new_with_label): Add
	some extra vertical padding to the label widget ... restores
	GTK+-1.2 spacing. (#65085, Damon Chaplin.)

2001-11-26  Tor Lillqvist  <tml@iki.fi>

	* demos/pixbuf-demo.c
	* demos/gtk-demo/pixbufs.c: M_PI -> G_PI.

	* demos/gtk-demo/main.c (read_line): No flockfile() or
	getc_unlocked() on Win32.

2001-11-25  Tor Lillqvist  <tml@iki.fi>

	* configure.in
	* acconfig.h: As we now use GDir, no need to check for dirent.h.

Sun Nov 25 23:18:39 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtktexttag.c (gtk_text_tag_set_property): free font_desc
	when finished (#65266)

Sun Nov 25 23:16:29 2001  Kristian Rietveld  <kristian@planet.nl>

	* gdk/x11/gdkwindow-x11.c (gdk_window_set_icon_list): free
	data after we set the property. (#65264)

Sun Nov 25 23:14:06 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtkbutton.c: add destroy method so label_text gets freed
	if it has been allocated (#65268)

Sat Nov 24 13:39:51 2001  Manish Singh  <yosh@gimp.org>

	* gdk/linux-fb/gdkdrawable-fb2.c
	* gdk/linux-fb/gdkpango-fb.c: update to latest Pango API

	* gdk/linux-fb/gdkwindow-fb.c: implement gdk_window_show_unraised

	* gdk/linux-fb/gdkfont-fb.c (gdk_font_load): plug memleak on
	set_family
	
	* gdk/linux-fb/gdkfbswitch.c: minor cleanups

Sat Nov 24 22:05:27 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtkmenushell.c (gtk_menu_shell_button_release): don't
	deactivate menu when menu_item isn't sensitive (#61389)

Sat Nov 24 15:35:26 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtktreemodel.c (gtk_tree_model_foreach): free path before
	we return (in case of a failure here)

Fri Nov 23 19:22:50 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c: Handle events in windows other
	than widget->event_window properly. (#65079, reported
	by Damon Chaplin)

	* gdk/gdkevents.c (gdk_event_get_coords): Fix x/y bug.

Fri Nov 23 18:57:46 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmessagedialog.c (gtk_message_dialog_init): Align
	the image at the top. (#65020, request from Seth Nickell)

Fri Nov 23 18:49:53 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/{gtkclist,gtkctree.c} (draw_row): Remove some strange
	arithmetic that was resulting in rows being drawn too low.
	(#65001, reported by Damon Chaplin)

Fri Nov 23 18:36:42 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c (gtk_range_button_press): Offset 
	invalidated range correctly.

	* gtk/gtkclist.c (hadjustment_value_changed): Fix scrolling 
	of title window. (#65001, reported by Damon Chaplin)

	* gtk/gtkcombo.c (gtk_combo_button_event_after): Replace
	horrible hack with use of ::event_after.

Thu Nov 22 15:01:03 2001  Owen Taylor  <otaylor@redhat.com>

	* Version 1.3.11

	* configure.in (ATK_REQUIRED_VERSION): Require
	GLib-1.3.11, Pango-0.22, ATK-0.7.

	* tests/prop-editor.c (property_widget): Restore
	to working as well as it did before.

	* gtk/gtklistitem.h: Mark deprecated since it is
	an integral part of GtkList.

 	* demos/gtk-demo/demo-common.h: New header file,
	for a common functions not important to the meat
	of the demos.
	
	* demos/gtk-demo/main.c (demo_ifind_file): Add a utility
	function to search for a file used by the demo.

	* demos/*.c: Use demo_find_file.

2001-11-23  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtktextbuffer.c (gtk_text_buffer_create_tag),
	gtk/gtkruler.c (gtk_ruler_get_metric): Actually commit typo 
	fixes already mentioned in ChangeLog entry on 2001-11-14.

	* docs/reference/gtk/tmpl/drawing.sgml: Minor markup fixes.

2001-11-23  Hans Breuer  <hans@breuer.org>

	* gdk/win32/gdkfont-win32.c (gdk_font_from_description) : 
	reflect Pango API change

	* gtk/gtk.def : updated externals

	* gtk/gtkfixed.c (gtk_fixed_get_has_window) : use 
	g_return_val_if_fail() to avoid 'function must return a value'

	* gtk/gtkrc.c : added spaces to fix small coding style issues
	* gtk/gtkwidget.c : ... and linebreaks. Also a static for
	'static correctness'

	* gtk/makefile.msc.in : temporary(?) disable gtk<plug|socket>
	because they only can be build on win32 after applying my patch

Wed Nov 21 22:55:37 2001  Tim Janik  <timj@gtk.org>

	* gtk/gtkbutton.c (gtk_button_map): raise event window afte
	children, in order for the input pnly window to stay *above*
	children.

Wed Nov 21 22:44:27 2001  Tim Janik  <timj@gtk.org>

	* tests/testtreeview.c: make hackery worse ;) by checking fundamental
	type walks againts G_TYPE_FUNDAMENTAL_MAX.
	
	* tests/prop-editor.c: disable type hackery.

Wed Nov 21 17:41:39 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkimage.c (gdk_image_get): Fix problem with
	lost parameter.

Wed Nov 21 17:01:25 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcellrenderer.h gtk/gtktreemodel.h 
	gtk/gtktreeprivate.h gtk/gtktreesortable.h: Remove
	trailing commas in enum declarations.

Wed Nov 21 15:21:26 2001  Owen Taylor  <otaylor@redhat.com>

	* configure.in (GTK_MICRO_VERSION): Version 1.3.11, 
	interface, binary age 0.

	* NEWS: Updates

	* gtk/gtktreemodel.c gtk/gtkrc.c gtk/gtkentry.c: SGML
	fixes in docs.

	* gtk/gtkmain.h: Remove unused and misnamespaced
	get_gtk_win32_directory() prototype.

	* gdk/gdkimage.c (gdk_image_get): Fix parameter names
	to match header.

	* gdk/gdkwindow.h: Fix parameters to gdk_window_shape_combine_mask(),
	gdk_window_set_transient_for(), gdk_window_set_geometry_hints(),
	to match docs.

	* gdk/gdkevents.c (gdk_event_get_coords)
	  gtk/gtkcellrenderertoggle.c (gtk_cell_renderer_toggle_get_active)
	  gtk/gtkdnd.c (gtk_drag_set_icon_stock):
	Fix parameter names in docs.
	
	* docs/faq/Makefile.am (FAQ_FILES): Add missing files.
	(#64961, Akira Tagoh)

Wed Nov 21 11:41:29 2001  Owen Taylor  <otaylor@redhat.com>

	* tests/testgtk.c (create_tooltips): Ref-sink the tooltips object.

	* gtk/gtktoolbar.c (gtk_toolbar_init): Ref-sink the tooltips object.

	* gtk/gtkfilesel.c (open_new_dir): Fix some constness warnings.

	* gtk/gtkaccelgroup.c: Rename gtk_accel_groups_from_acceleratable()
	back to gtk_accel_groups_from_object(), change @acceleratable
	parameter to gtk_accel_groups_activate() accordingly.

	* gtk/gtkaccelmap.c (gtk_accel_map_lookup_entry): Remove
	left-over comment about quark return.

	* gtk/gtkaccelmap.h: Fix spelling of gtk_accel_map_foreach_unfiltered().

 	* gtk/gtk-boxed.defs (GtkIconSource): added as a boxed type.
        (Patch from Matt Wilson)

	* gtk/gtkobject.c (gtk_object_finalize): Warn if a floating
	object is finalized.

Tue Nov 20 21:25:08 2001  Tim Janik  <timj@gtk.org>

	* applied patch from owen to get rid of accel map notifiers.
	changed things to fix reentrancy and API as discussed on gtk-devel.

	* gtk/gtkaccelgroup.[hc]:
	(gtk_accel_group_finalize): unregister this accel group from all
	accel map paths.
	(accel_closure_invalidate): handle invalidation of closures by
	disconnecting their accelerators.
	(quick_accel_add): move closure connection and changed notification
	into this function to reduce code duplication. don't emit change
	notification on closurers without accelerators.
	(quick_accel_remove): rewrite, do the exact opposite of quick_accel_add
	for a GtkAccelGroupEntry.
	(gtk_accel_group_connect): get rid of the accel_path_quark argument.
	(gtk_accel_group_connect_by_path): new function to add accelerators
	with an accel path.
	(gtk_accel_group_disconnect_closure): new function, disconnect a
	closure from of an accel group.
	(gtk_accel_group_disconnect): loop over all closure for a accel_ley,
	accel_mods pair and remove them.
	(_gtk_accel_group_reconnect): new function that basically does
	gtk_accel_group_disconnect_closure() and
	gtk_accel_group_connect_by_path() once an accel path changed.
	(gtk_accel_groups_disconnect_closure): remove this, there's
	gtk_accel_group_disconnect_closure().
	
	* gtk/gtkaccelmap.[hc]: keep list of accel groups per entry now,
	nuke notifiers.
	(_gtk_accel_path_is_valid): make this non-static for
	gtkwidget.c and gtkaccelgroup.c assertions.
	(gtk_accel_map_add_notifer): removed this function.
	(gtk_accel_map_remove_notifer): same.
	(_gtk_accel_map_add_group):
	(_gtk_accel_map_remove_group): (un-)register accel groups, with
	accel paths for correct propagation.
	(gtk_accel_map_add_entry): return void.
	(gtk_accel_map_lookup): return gboolean instead of GQuark.
	
	* gtk/gtkitemfactory.c (gtk_item_factory_add_foreign): always
	set accel_path on widgets.
	
	* gtk/gtkwidget.[hc]:
	(accel_path_changed): got rid of this, changes are handled by
	accel maps internally now.
	(_gtk_widget_set_accel_path): get things to work without notifiers.
	(gtk_widget_list_accel_closures): list accel closures of a widget.
	
	* gtk/gtkwindow.[hc]: rename ::accels_changed, to ::keys_changed.

2001-11-20  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkcontainer.c (gtk_container_propagate_expose): Typo fix.

Tue Nov 20 23:01:01 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtktreemodel.c (gtk_tree_row_reference_unref_path):
	replace gboolean free_last in the function parameters with
	gint depth. Changes to reflect new situation.

	* gtk/gtktreemodel.c (gtk_tree_row_reference_unref_path_helper):
	replace gboolean free_last, with gint depth, add gint current_depth.
	Changes to reflect new situation.

	* gtk/gtktreemodel.c (gtk_tree_row_ref_deleted_callback): changes
	to reflect new situation

	* gtk/gtktreemodel.c (gtk_tree_row_reference_free): ditto

Tue Nov 20 12:37:10 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_paint): Fix problem
	where notebook gap was double shifted by allocation.x/y

	* gtk/gtknotebook.c (gtk_notebook_unmap): Chain up
	to unmap children.

Tue Nov 20 14:49:59 2001  Tim Janik  <timj@gtk.org>

	* gtk/gtkvpaned.c (gtk_vpaned_size_allocate): fix
	allocation to be relative to paned->allocation, now
	that this is a NO_WINDOW widget.
	* gtk/gtkhpaned.c (gtk_hpaned_size_allocate): same here.

	* gtk/gtkaccellabel.c (gtk_accel_label_class_init): ::closure
	needs to be a boxed property.

Mon Nov 19 17:34:40 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkradiobutton.c (gtk_radio_button_draw_indicator):
	Use the widget's state when drawing the indicator, as
	in GtkCheckButton. This gives us color changes for
	un-prelighted checkbuttons. (#63308, Matt Wilson)

Mon Nov 19 17:11:23 2001  Owen Taylor  <otaylor@redhat.com>

	(Fixes related to #64428, Michael Meeks)

	* gtk/gtkplug.c (gtk_plug_set_is_child): Unmap the
	widget, so it gets mapped again properly when we
	add to a parent.

	* gtk/gtkplug.c (_gtk_plug_add_to_socket): Set
	plug->socket_window. 

	* gtk/gtkplug.c (_gtk_plug_remove_from_socket): Set
	socket_window to NULL, not FALSE.

	* gtk/gtkplug.c (_gtk_plug_add_to_socket): Set
	socket->same_app to TRUE. (#64612)

Mon Nov 19 15:50:41 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfixed.[ch] docs/Changes-2.0.txt: Add 
	gtk_fixed_set/get_has_window() to remove criticism
	about GTK_WIDGET_SET_FLAGS() hacks.

2001-11-19  Michael Natterer  <mitch@gimp.org>

	* gtk/gtknotebook.c: show notebook->event_window with
	gdk_window_show_unraised(), so it doesn't catch the events which
	should go to the tab widgets first.

Mon Nov 19 15:30:51 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_class_init): Add a
	"resizable" property, to get rid of the
	GTK_TREE_VIEW_COLUMN_RESIZABLE sizing flag.
	(gtk_tree_view_column_set_resizable): New function to set resizable.
	(gtk_tree_view_column_set_resizable): getter.

	* tests/testtreecolumns.c (add_clicked): modify for above change.

	* Makefile.am (install-data-hook): remove old .pc files before
	installing the new one.  We used to symlink this, and it will
	break old installs.

2001-11-19  Havoc Pennington  <hp@pobox.com>

	* tests/testtext.c (fill_example_buffer): put in a test for
	negative indentation values

Mon Nov 19 14:08:18 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_init): Change default for
	justify to GTK_JUSTIFY_LEFT. Assuming that multiline
	labels are most often wrapped labels, this gives better
	compatibility with GTK+-1.2, where justification was
	ignored for wrapped labesl and is a more sensible
	default in any case. (#64489)

	* gtk/gtklabel.c (gtk_label_class_init): Fix default
	for wrap property to FALSE.

2001-11-19  jacob berkman  <jacob@ximian.com>

	* gtk/Makefile.am (gtk_extra_sources): add gtkmarshal.list

Mon Nov 19 13:56:45 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (gdk_window_focus): Use 
	RevertToParent, not RevertToNone. (#64613, 
	Matthias Clasen)

Mon Nov 19 12:28:02 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkframe.c (gtk_frame_class_init): label_xalign
	and label_yalign need to be float properties to
	correspond to GTK+-1.2, to gtk_frame_set_label_align,
	and to the types of the xalign and yalign properties of GtkMisc.
	(#63484, Vitaly Tishkov)

Mon Nov 19 12:24:30 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.h (struct _GtkSocketClass): Fix return
	of plug_added vfunc. (#64408, Jeff Franks)

Mon Nov 19 12:07:20 2001  Owen Taylor  <otaylor@redhat.com>

	* configure.in (deps): Undef HAVE_STDLIB_H before
	checking for jpeg, because jconfig.h has this
	in it too (%#$@!). Fix from Matthias Clasen, #64500.

Mon Nov 19 11:30:03 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkproperty-x11.c (get_atom_name): Fix a 
	memory leak when retrieving atom names. (Michael Meeks,
	#64508)

2001-11-18  Alex Larsson  <alexl@redhat.com>

	* gdk/x11/gdkfont-x11.c (gdk_font_from_description):
	Update to new Pango API.
	
Sun Nov 18 19:47:29 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkobject.h docs/Changes-2.0.txt: Rename the
	GTK_DESTROYED flag to GTK_IN_DESTRUCTION, remove the
	GTK_OBJECT_DESTROYED() check macro.

	* gtk/gtkbindings.c (gtk_bindings_activate): Remove
	instances of GTK_OBJECT_DESTROYED() that weren't
	needed any more.

	* gtk/gtkdialog.c: Exchange use of GTK_OBJECT_DESTROYED
	for a connection to ::destroy.

Sun Nov 18 18:18:11 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfixed.c: Make a NO_WINDOW widget, as it should
	have been since the beginning, but as special hack,
	allow clearing the NO_WINDOW flag to get a window widget.

Sun Nov 18 22:01:36  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtktreestore.c: return TRUE when value changed, so
	row_changed is being emitted

2001-11-18  Hans Breuer  <hans@breuer.org>

	* gtk/gdkaccelmap.c : make it compile with msvc: !HAVE_UNISTD_H;
	no label without op, even if it's a no-op.

	* gtk/gtk.def :
	* gtk/makefile.msc.in : reflect marshaler split, some clean-up	

	* config.h.win32.in : remove definition of HAVE_DIRENT_H
	* gtk/gtkfilesel.c : due to GDir (new in glib) DIR isn't
	required anymore, replace it.
	* gtk/queryimmodules.c : DIR -> GDir replacement, also
	getcwd() -> g_get_current_dir()

	* gdk/win32/gdkgeometry-win32.c : adapt to refactored gdkgeometry-x11.c
	Even 'noisy laugh' scolling appears to work, though I still can't
	claim to have fully understood what it is supposed to do ...

Sat Nov 17 21:07:46 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkenums.h: Include glib-object.h instead of
	gobject/gsignal.h

	* gdk/{gdkinternals.h,gdkwindow.c,gdkwindow.[ch],
	  x11,{fb,win32,x11/gdkwindow-*.c}: Add a dummy GdkScreen
	argument to the window_at_pointer() field of
	GdkPointerHooks. (Patch from Erwann Chenede)

	* gdk/gdkdrawable.h (struct _GdkDrawableClass ): Up
	to 6 pointers.

2001-11-17  Matt Wilson  <msw@redhat.com>

	* gtk/gtkenums.h: must include glib-object.h only

Sat Nov 17 19:26:20 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_key_press_event): Reprioritize
	key bindings in order of visibility - mnemonics, then 
	accelerators, then send key to the focus widget, then
	bindings on the GtkWindow.

	* gtk/gtklayout.h docs/Changes-2.0.txt tests/testgtk.c: 
	Removed the xoffset, yoffset fields of GtkLayout which were
	identically zero for compat with 1.2, but were no longer 
	compatible with	all uses of these fields in 1.2.

	* gtk/gtkwindow.c (gtk_window_set_default): Remove 
	unused variable.

Sat Nov 17 19:08:13 2001  Owen Taylor  <otaylor@redhat.com>

	* tests/testtreeview.c (gtk_tree_model_types_get_type): 
	We no longer need to create the signals here ... they
	come from the interface.

	* gtk/maketypes.awk: Use GType, not GtkType in output.

	* gtk/gtktypeutils.h: Mark virtually all of this
	file deprecated.

	* gtk/gtkcontainer.h: Deprecate gtk_container_foreach_full;
	the only use of this function is the GtkArg using
	GtkCallbackMarshal, since destroy notification is
	silly here.

Sat Nov 17 18:26:45 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am gtk/gtkmarshal.list gtk/gtkmarshalers.list
	gtk/*.c gtk/gtksignal.h: Make gtkmarshal.list/gtkmarshal.h
	only for compatibility with GTK+-1.2; and deprecate it; 
	put all marshalers we actually use into gtkmarshalers.list 
	and use the _gtk_marshal_ prefix for these marshalers.

2001-11-17  Murray Cumming  <murrayc@usa.net>

	* gtk/gtktexttagtable.c (gtk_text_tag_table_class_init):
	The first parameters of the signals are now registered as
	GTK_TYPE_TEXT_TAG instead of G_TYPE_OBJECT.
	
2001-11-17  Tor Lillqvist  <tml@iki.fi>

	* gtk-zip.sh.in: Build separate runtime and developer
	packages.

	* gtk/gtk.def: Reflect recent accelerator-related changes.

Fri Nov 16 19:44:35 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_set_default): Move 
	notification of "has_default" to here, so it
	is safe to call gtk_window_set_default() instead
	of gtk_widget_grab_default().

	* gtk/gtkwindow.c (gtk_window_set_focus): Make it call
	gtk_widget_grab_focus(), which then calls 
	_gtk_widget_internal_set_focus(). This makes 
	gtk_window_set_focus() a safe way of both setting
	and unsetting the focus widget.

	* gtk/gtkwidget.c (gtk_widget_propagate_state): Use
	gtk_widget_get_toplevel(), instead of gtk_widget_ancestor
	to find the toplevel.

	* gtk/gtkwindow.h: Move gtk_window_set_focus/default
	from the "internal functions" section.

2001-11-16  jacob berkman  <jacob@ximian.com>

	* tests/testgtk.c (create_radio_buttons): add some no-indicator
	radio buttons

	* gtk/gtkradiobutton.c (gtk_radio_button_init): since we are
	initially active, also initially be depressed
	(gtk_radio_button_clicked): also update our depressed state

Thu Nov 15 12:54:36 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_key_press_event): Propagate
	key press events not just to focus/window but also to
	intermediate widgets.

	* gtk/gtknotebook.c: Handle Ctrl-PageUp/Ctrl-PageDown
	to switch pages. (Needs some work on handling focus
	when switching pages.)

Fri Nov 16 14:06:31 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c: Fix child allocations to be relative to 
	widget position and some drawing bugs.

	* gtk/gtkmenuitem.c (gtk_menu_item_paint): Fix problem
	with reading uninitialized variable.

Fri Nov 16 00:16:40 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/{gtkmenuitem.[ch],gtkcheckmenuitem.c,gtkimagemenuitem.c,
	gtkradiomenuitem.c,gtktearoffmenuitem.c}: Make Menu items
	NO_WINDOW widgets.

	* gtk/gtk{h,v,}paned.[ch]: Make NO_WINDOW widgets, some
	cleanup.

	* gtk/gtkstyle.c (gtk_default_draw_handle): Don't assume
	we are drawing in a window when drawing the paned handle.

2001-11-16  Sven Neumann  <sven@gimp.org>

	* demos/gtk-demo/appwindow.c
	* demos/gtk-demo/menus.c: reduce compiler warnings

Thu Nov 15 19:47:09 2001  Owen Taylor  <otaylor@redhat.com>

	* demos/gtk-demo/main.c (button_press_event_cb): Remove 
	unused callback to make things compile with 
	gtk_tree_view_path_at_pos_change().

Thu Nov 15 18:44:33 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreedatalist.c (_gtk_tree_data_list_free): maybe fix #64160

2001-11-15  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkwindow.c (gtk_window_new): Move '.' out of quote. (#64407)
 
Thu Nov 15 16:24:55 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_get_bin_window): New function
	to get a GdkWindow to compare event->window to.

	* gtk/gtktreeview.c (gtk_tree_view_move_cursor_left_right): emit
	the signal for lateral motion too, #64361

	* gtk/gtktreeview.c (gtk_tree_view_get_path_at_pos): remove window
	arg as it is useless, #64137

Thu Nov 15 16:07:42 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c: Some small drawing fixes for scroll arrows.

Thu Nov 15 14:19:34 2001  Owen Taylor  <otaylor@redhat.com>
 
 	* gdk/gdkwindow.c (gdk_window_invalidate_maybe_recurse): Cal
 	gdk_window_invalidate_maybe_recurse() for recursion.
 	(Soeren Sandmann)

 	* gtk/gtkviewport.c: Make !redraw_on_allocate. (Soeren Sandmann)
 
	* gtk/gtkcontainer.c (gtk_container_expose): Call
	gtk_container_forall() not _foreach() to propagate,
	since we need to propagate exposes to internal children
	as well.

	* gtk/gtkwidget.c (gtk_widget_set_events, gtk_widget_add_events): 
	Remove the restriction of only being able to call these
	on window widgets, since we have lots of NO_WINDOW widgets
	with windows now; for add events, recurse over the children
	of widget->window to find one owned by the widget.

	* gtk/gtkbutton.[ch]: Make a NO_WINDOW widget, using an input-only
	window to catch events.

	* gtk/gtktogglebutton.[ch]: Remove the code for switching
	between NO_WINDOW and WINDOW widgets based on the mode.

	* gtk/gtkcheckbutton.c gtk/gtkoptionmenu.c gtk/gtkclist.c
	gtk/gtktreeview.c: Adopt to NO_WINDOW change for GtkButton.

	* gtk/gtkrange.[ch]: Make into a NO_WINDOW widget.

	* gtk/gtkhscale.c, gtk/gtkvscale.c: Adopt to NO_WINDOW
	change for range.

	* gtk/gtknotebook.[ch]: Make into a NO_WINDOW widget.
 
	* docs/Changes-2.0.txt: Add a note about the NO_WINDOW changes.

Thu Nov 15 11:59:35 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmessagedialog.c: Patch from Murray Cumming to add
	"message_type" and "buttons" CONSTRUCT properties. (#64069)

	* tests/testsocket.c: Expand tests to add a "local passive
	child" (Test case for #64428)

2001-11-14  jacob berkman  <jacob@ximian.com>

	* gtk/gtkgamma.c (button_clicked_callback): create the label with
	a mnemonic

2001-11-15  Sven Neumann  <sven@gimp.org>

	* tests/testgtk.c: make it compile without warnings.

2001-11-14  Alex Larsson  <alexl@redhat.com>

	* gtk/gtklabel.c:
	Don't recalculate the layout on each gkt_label_ensure_layout () for
	wrapped labels.

Wed Nov 14 17:40:23 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_get_expander_column): Return
	the currently selected column when we get the column, #64380

	* gtk/gtkentry.c (gtk_cell_editable_key_press_event): Handle Esc
	to cancel CellRendererText editting, #63613

	* gtk/gtkcellrenderertext.c: ditto

	* gtk/gtkcellrenderertext.h: formatting changes

2001-11-14  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkbutton.c (gtk_button_get_label): Rearrange docs (#64566)

	* gtk/gtktextbuffer.c (gtk_text_buffer_create_tag): Typo fix (#64474)

	* gtk/gtkruler.c (gtk_ruler_get_metric): Typo fix (#64470)

	* gtk/gtknotebook.c (gtk_notebook_prepend_page): Typo fix (#64467)

	* gtk/gtklabel.c: Documentation fixes (#64452)

2001-11-14  Daniel Egger  <degger@fhm.edu>

	* gdk-pixbuf/io-xpm.c: 
	(xpm_skip_whitespaces): Remove unused static function.
	(xpm_skip_string): Dito.	
	(xpm_extract_color): Declare const variable const to avoid warnings. 

	* gtk/gtkfixed.c: (gtk_fixed_map): Remove unused static function.
	
	* gtk/gtkplug.c: #if 0'ed prototype for #if 0'ed code.
	
	* gtk/gtksocket.c: Change type of mask to g_message to %ld for 
	a long.

Wed Nov 14 15:14:48 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcontainer.c (gtk_container_idle_sizer): Back
	out accidental commit of debugging timing code.

2001-11-14  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_move_cursor): fix Control-E so
	it doesn't move to a new line each time you press it

	* gtk/gtktextiter.c (gtk_text_iter_forward_to_line_end): fix
	return value, #62987

2001-11-14  Havoc Pennington  <hp@redhat.com>

	* tests/testtextbuffer.c (main): bulk of the tests were commented
	out, oops.

	* gtk/gtktextiter.c (find_paragraph_delimiter_for_line): make this 
	function work, should resolve #63426
	(gtk_text_iter_ends_line): return TRUE for the end iterator

	* gtk/gtktextiter.h: put padding back in GtkTextIter, I thought of
	a couple things that might get cached in here.

Tue Nov 13 21:00:59 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_class_init): new
	"model" construct property for language bindings.

	* gtk/gtktreestore.c (gtk_tree_store_set_column_types): New
	function to let you set the column types of a GtkTreeStore for
	language bindings.

	* gtk/gtkliststore.c (gtk_list_store_set_column_types): ditto.

2001-11-13  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_add_child_in_window): docs
	including reference to bugzilla bug about how we should have 
	a better way of positioning children

	* gtk/gtktextview.h (struct _GtkTextViewClass): add some padding

	* gtk/gtktextview.c (gtk_text_view_size_allocate): assign zero
	size to side rects if they don't exist, #63438

2001-11-13  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_key_press_event): fix to
	properly replace selection with Return or Tab

	* gtk/gtktextdisplay.c (gtk_text_layout_draw): fix broken code
	that didn't locate the end of the line correctly, should fix #63800

2001-11-13  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_size_request): add border width
	to requisition, request non-anchored children
	(gtk_text_view_size_allocate): handle border width, allocate
	non-anchored children
	(text_view_child_new_window): set the child as object data
	(gtk_text_view_move_child): allow children at negative
	coordinates, no reason why not
	(gtk_text_view_forall): make it copy the list of children before
	walking it, to avoid reentrancy issues	
	(gtk_text_view_move_child): short-circuit if position is unchanged
	(changed_handler): only queue_resize if requisition has changed
	(gtk_text_view_init): don't redraw_on_allocate, since we can do 
	a better job of invalidation ourselves

	* tests/testtext.c: add tests for the fixed-position children

Tue Nov 13 19:51:43 2001  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c (handle_accels_changed): protect idle handle
	with gdk threads macro.

Mon Nov 12 23:08:37 2001  Tim Janik  <timj@gtk.org>

	* gtk/maketypes.awk: fix type utils generation on unix.

	* gtk/gtkaccelmap.[hc]: new files, implementing a global accelerator
	registry.

	* gtk/gtkaccelgroup.[hc]: major API/implementation revamp:
	removed GTK_ACCEL_SIGNAL_VISIBLE, gtk_accel_group_get_default,
	gtk_accel_group_get_entry, gtk_accel_group_(un)lock_entry,
	gtk_accel_group_add/remove, gtk_accel_group_handle_add/remove,
	gtk_accel_group_create_add/remove, gtk_accel_group_entries_from_object.
	introduced ::accel_changed signal for change notification, and
	gtk_accel_group_connect/disconnect to connect closures to accel groups.
	made gtk_accel_group_attach/detach and gtk_accel_group_activate private
	functions.
	deprecated gtk_accel_group_ref/unref.

	* gtk/gtkaccellabel.[hc]: changes to make accellabels pay attention
	to accel group changed notification and basically operate on closures.
	removed gtk_accel_label_get_accel_object and
	gtk_accel_label_set_accel_object.
	introduced gtk_accel_label_set_accel_closure, and for convenience,
	gtk_accel_label_set_accel_widget.

	* gtk/gtkitemfactory.[hc]: removed accelerator propagation code
	which mostly moved into gtkaccelmap.[hc].
	removed gtk_item_factory_parse_rc*, gtk_item_factory_dump_*
	and gtk_item_factory_print_func.

	* gtk/gtkmain.c: call _gtk_accel_map_init().

	* gtk/gtkmenuitem.[hc]: introduced gtk_menu_item_set_accel_path(),
	that associates an accelerator path with menu items, through which
	persistent accelerator settings on menu items are enabled.

	* gtk/gtkmenu.[hc]: added gtk_menu_set_accel_path() so accelerator
	paths of menu item can be default constructed to allow installation
	of accelerators on menu items that don't come with an accelerator
	binding by default.

	* gtk/gtksettings.c: fix STRING type rc settings by special casing
	them appropriately in the parser.

	* gtk/gtksignal.[hc]: allow a class function offset of 0 for
	gtk_signal_newv().

	* gtk/gtkwidget.[hc]: accelerator API revamp.
	removed ::accelerator_add/remove signals, gtk_widget_accelerator_signal,
	gtk_widget_accelerators_locked, gtk_widget_remove_accelerators and
	gtk_widget_(un)lock_accelerators.
	accelerators maintained through gtk_widget_add/remove_accelerator()
	are not runtime changable now, the correct sequence to setup a
	widget for runtime changable accelerators is now:
	  gtk_accel_map_add_entry(accel_path, key, mods);
	  _gtk_widget_set_accel_path(widget, accel_path, accel_group);

	* gtk/gtkwindow.[hc]: accelerator changes, proxy and coalesce accel
	group changes (as well as mnemonic changes) through the new signal
	::accels_changed.

Sat Nov 10 12:08:56 2001  Tim Janik  <timj@gtk.org>

	* gtk/gtksettings.c (_gtk_settings_parse_convert): properly handle
	GString->string conversions.

Mon Nov 12 19:33:52 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmessagedialog.c (gtk_message_dialog_new): Warn
	if GTK_DIALOG_NO_SEPARATOR is passed in and ignore it.

2001-11-12  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtktreeview.c: Documentation fixes. (#64377)
	
	* gtk/gtktreestore.c: Documentation fixes. (#64376)

2001-11-11  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkiconfactory.c, gtk/gtktextbuffer.c, gtk/gtktreemodel.c,
	gtk/gtkwindow.c, gtk/gtknotebook.c, gtk/gtkradiobutton.c, 
	gtk/gtktextiter.c, gtk/gtkdialog.c: Mass fixing of trivial doc bugs.  
	(#63544, #57007, #64141, #63472, #57108, #60818, #61562)

2001-11-10  Hans Breuer  <hans@breuer.org>

	* gdk/win32/gdkevents-win32.c (gdk_event_translate) : make sure 
	we know what we are talking about when asked for MINMAXINFO.
	Also some cleaning for !HAVE_DIMM_H etc.

2001-11-10  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtktreeviewcolumn.c: Fix docs for 
	gtk_tree_view_column_set_sort_order. (#62647)
	
	* gtk/gtkcontainer.c: Fix docs for 
	gtk_container_set_border_width. (#64139)

	* gtk/gtkcolorsel.c: Documentation fixes.

2001-11-10  Hans Breuer  <hans@breuer.org>

	* gtk/gtkfontsel.c : use g_strcasecmp(), some poor platforms
	don't have strcasecmp()

	* gtk/gtktextview.c : to fix crashing on e.g. TextView::find need 
	to remove the idle funcs in gtk_text_view_destroy (). To reduce 
	code duplication wrap it in its own function and use it in 
	gtk_text_view_unrealize () and gtk_text_view_destroy_layout ()

	* gdk/win32/gdkdrawable-win32.c : implement the finalize
	method like the X11 version does, allow to set_colormap NULL
	* gdk/win32/gdkwindow-win32.c : adapt GdkWindowImplWin32::
	set_colormap, also some adaption to X11 version :
	(gdk_window_hide) call _gdk_window_clear_update_area
	(gdk_window_reparent) call _gdk_window_init_position

	* gdk/win32/gdkwindow-win32.c (gdk_window_set_geometry_hints) : 
	call gdk_window_resize() after all hints are set, because the
	window resizing process (WM_GETMINMAXINFO) takes all of them into 
	account

	* gdk/win32/gdkfont-win32.c : make gdk_font_equal return a gboolean

	* gdk/win32/gdkvisual-win32.c : register GdkVisual with 
	sizeof (GdkVisualPrivate)

	* gdk/gdk.def gtk/gtk.def : upated externals

	* gdk/makefile.msc gdk/win32/makefile.msc gdk-pixbuf/makefile.msc
	  gdk-pixbuf/pixops/makefile.msc gtk/makefile.msc.in tests/makefile.msc :
	from now on use make.msc from $(TOP)/glib/build/win32

	* gtk/stock-icons/makefile.msc : add stock_missing_image

2001-11-08  Tor Lillqvist  <tml@iki.fi>

	* README.win32: Add headers. Add section about ActiveIMM.

	* configure.in: Add --with-ie55 flag to specify the location of
	the "IE55 libs and headers" package downloadable from Microsoft,
	which contains, among other things, the Active IMM header dimm.h
	and UUID library uuid.lib. Use test -f instead of AC_CHECK_FILE.
	Require GLib 1.3.10.
	
	* config.h.win32.in: New version, produced by merging two
	configure-generated ones (for gcc and MSVC). Hopefully #defines
	the same flags that the previous, hand-written one, did.

	* gdk/Makefile.am
	* gdk/win32/Makefile.am: Handle the uuid library from the IE55 lib.

	* gdk/win32/gdkevents-win32.c: Conditionalize ActiveIMM
	stuff. Remove unused GdkIOClosure.

	* gdk/win32/surrogate-dimm.h: Remove, use real dimm.h instead (if
	available).

	* gdk/win32/libie55uuid.la: New file, handwritten libtool wrapper
	for uuid.lib. (Does it really have to be this hard to use an
	existing library with libtool? Probably I am missing something.)

2001-11-08  Darin Adler  <darin@bentspoon.com>

	* gtk/gtklabel.c: (gtk_label_ensure_layout): Fix an obvious
	typo where it says LEFT instead of CENTER.

2001-11-07  Darin Adler  <darin@bentspoon.com>

	* gtk/gtkdialog.c: (gtk_dialog_set_response_sensitive),
	(gtk_dialog_set_default_response): Add g_return_if_fail.

Mon Nov  5 22:34:29 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktreednd.[ch] (struct _GtkTreeDragSourceIface): 
	Add row_draggable() vfunc, and wrapper function.

	* gtk/gtktreednd.[ch] (struct _GtkTreeDragDestIface): Make
	row_drop_possible take a GtkSelectionData, rather than
	model/row pair.

	* gtk/gtktreestore.c gtk/gtkliststore.c: Update for 
	new DND interfaces.

	* gtk/gtktreeview.[ch]: Remove the row_draggable_func
	location_dropable_func from gtk_tree_view_set_rows_drag_source/dest.
	and rename them to enable_model_drag_source/dest.

	* gtk/treeviewcolumn.c: Add DND of columns between rows.
	Still can't drop _to_ the left tree, but other places
	work.

	* gtk/gtktreeview.c (unset_reorderable): Unset the
	reorderable property if unset/enable_model_drag_source/dest
	are called manually.

	* gtk/gtktreestore.c (gtk_tree_store_row_drop_possible): 
	Correct for change in depth count handling.

	* gtk/gtktreeview.c (gtk_tree_view_create_row_drag_icon):
	Pass in a expose area to gtk_tree_view_column_cell_render()

2001-11-06  Havoc Pennington  <hp@redhat.com>

	* demos/gtk-demo/textview.c (easter_egg_callback): wacky easter egg

Tue Nov  6 10:13:16 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkgc-x11.c: Fix misplaced HAVE_XFT.

2001-11-05  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_paint): expose the child
	widgets in here
	(gtk_text_view_realize): set parent window of child widgets
	(gtk_text_view_size_request): use child req to decide whether
	to invalidate layout, not widget->requisition

	* gtk/gtktextdisplay.c (render_layout_line): set
	shaped_width_pixels for NULL shape objects, so that we properly
	draw the "missing pixbuf/widget" thing
	(render_layout_line): don't draw the widget here
	(gtk_text_layout_draw): pass out a list of widgets that need exposing

	* demos/gtk-demo/textview.c (insert_text): add demo of child
	widgets

	* gtk/gtktextlayout.c (add_child_attrs): remove debug spew

	* gtk/gtktextdisplay.c (render_layout_line): remove debug spew

	* gtk/gtktextview.c (gtk_text_view_update_child_allocation): add
	scroll offsets
	(gtk_text_view_value_changed): poke new X and Y into child allocations

2001-11-06  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkmain.c (find_module): Do search GTK_BINARY_VERSION
	-specific directory on Windows, too (#63759).

Mon Nov  5 12:46:44 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdrawable-x11.[ch] gdk/x11/gdkgc-x11.c
	gdk/x11/gdkpixmap-x11.c gdk/x11/gdkprivate-x11.h
	gdk/x11/gdkwindow-x11.c: Redo Xft support to go
	directly to Picture objects instead of using XftDraw.
	This fixes the problem where we weren't able to 
	properly destroy XftDraw objects before destroying
	the accompanying windows, and probably improves
	efficiency a bit too. (#50214)

Mon Nov  5 10:01:49 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkgeometry-x11.c (gdk_window_compute_position): 
	Clamp max window width/height to 32767, not 32768 since
	we have to be able to deal with a dx/y of -32768 without
	getting a width of 65536 when guffaw scrolling.

	* gdk/x11/gdkgeometry-x11.c: Implement gdk_window_scroll()
	for the guffaw scrolling case, fixing some problems with
	copy-area case as well. Fix BadValue bug with moving windows
	by large amounts.

	* gdk/x11/gdkgeometry-x11.c (gdk_window_clip_changed): Update
	clip in window structue before calling gdk_window_invalidate_region
	since that trims new invalidations to the window's visible
	region.

	* gdk/x11/gdkwindow-x11.c (gdk_window_set_static_gravities): 
	Really set the static window gravity on the children, not
	repeatedly on the window.

	* gtk/testgtk.c: Add a torture test for big windows and 
	gdk_window_scroll().

Sun Nov  4 17:36:08 2001  Manish Singh  <yosh@gimp.org>

	* acconfig.h configure.in: sigsetjmp is macroized in some places,
	so use AC_TRY_LINK instead of AC_CHECK_FUNCS for the check.

Sun Nov  4 19:16:23 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkcolor.c (gdk_color_parse): Implement gdk_color_parse()
	in terms of pango_color_parse().

	* gdk/{linux-fb,win32,x11}/gdkcolor-*.c: Remove port-specific
	gdk_color_parse() implementations.

Sun Nov  4 18:39:43 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksizegroup.c (gtk_size_group_set_mode): 
	queue_resize_on_group with both the old and new mode, not
	just the new mode. (#60171, Nicolas Setton). Also, notify
	the "mode" property.
	
Sun Nov  4 16:02:08 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.[ch]: Add a function gdk_window_invalidate_maybe_recurse() 
	for use in "shallow invalidation" of a widget. (Windows belonging
	to the widget, but not to the widget's children)

        * gtk/gtkprivate.h gtk/gtkwidget.c gtk/gtksizegroup.c: Add private
	flags GTK_ALLOC_NEEDED, GTK_REQUEST_NEEDED.  These flags are set
	up on ancestors up to the resize container on queue_resize. Size
	requests only actually take place if GTK_REQUEST_NEEDED, size
	allocations only take place if GTK_ALLOC_NEEDED or the size
	changed.

        * gtk/gtkcontainer.c gtk/gtkwidget.c: Remove
	container->resize_widgets and the RESIZE_NEEDED flag since the
	above flags are sufficient to figure out what needs to be
	resized/reallocated. Remove code manipulating
	container->resize_widget.

        * gtk/gtkwidget.[ch]: Add gtk_widget_set_redraw_on_alloc(); this
	allows widgets to turn off being automatically invalidated is when
	they are resized.

	* gtk/gtkwidget.[ch] (gtk_widget_size_allocate): Invalidation when
	a widget is resized or moved is "shallow" as described above -
	only the windows that need to be invalidated are invalidated.

	* gtk/gtkbox.c gtk/gtktable.c gtk/gtkalignment.c docs/Changes-2.0.txt: 
	Make these widget's init functions call 
	gtk_widget_set_redraw_on_allocate(widget,FALSE).

	* gtk/gtkwindow.c (gtk_window_configure_event): Call 
	_gtk_container_queue_resize(), since we don't want
	redrawing. (Probably could be done for other 
	calls to gtk_widget_queue_resize() in gtkwindow.c,
	but this is the most important one.)

	* gtk/gtkwindow.c (gtk_window_move_resize): Don't call
	gtk_widget_queue_draw() - size_allocate() handles
	that as appropriate.

	* gtk/gtkframe.c (gtk_frame_size_allocate): Invalidate instead
	of queue_clear() to avoid invalidating children.

2001-11-04  jacob berkman  <jacob@ximian.com>

	* gtk/gtkmain.c (find_module): don't free the module name until
	after we load the module

Sat Nov  3 13:57:21 2001  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkctree.c: Convert GTK_TYPE_CTREE_NODE to pointer
 	derivation instead of boxed derivation.
 
 	* gtk/gtkmarshal.list: Remove some now unused marshallers.
 
2001-11-04  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkimmodule.c: Can't include gtkprivate.h (I added the
	include yesterday, without really thinking), as that defeats the
	working of correct_libdir_prefix() (it becomes a no-op.). Add
	comment mentioning that. Thanks to Hans Breuer for noticing.
	
2001-11-03  Daniel Elstner  <daniel.elstner@gmx.net>

	* gtk/gtkwindow.h (frame_event): Use GtkWindow* as first
	signal argument (was GtkWidget*).

	* gtk/gtkwindow.c (gtk_window_frame_event),
	  gtk/gtkwindow-decorate.c (gtk_decorated_window_frame_event):
	Fixed argument types as above, removed GTK_WINDOW casts and
	added some GTK_WIDGET casts instead.

2001-11-03  Hans Breuer  <hans@breuer.org>

	* gtk/gtkfilesel.c (gtk_file_selection_finalize) : chain
	finalize to parent class to get removed from the toplevel_list.
	Should fix 'random' crashes of #63474.

	* gtk/gtktreemodelsort.c : chain finalize() to parent class

2001-11-03  Tor Lillqvist  <tml@iki.fi>

	* modules/input/Makefile.am: Use -no-undefined on Windows. Look
	for .dll or .so as appropriate as module suffix.

	* gtk-zip.sh.in: Use correct import library names.

	* gtk/gtk.def: Add a couple of missing entry points. (#63585)

	* gtk/gtkimmodule.c (correct_libdir_prefix): New function, used on
	Windows to turn build-time paths from a gtk.immodules distributed
	as part of a binary package into runtime ones in the
	end-user-chosen installation directory.
	(gtk_im_module_init): Use it for module path and domain
	directory.

2001-11-02  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkrc.c (gtk_rc_make_default_dir): Fix typo: extraneous
	comma.  Include gtkprivate.h for GTK_LIBDIR etc definitions on
	Windows.

2001-10-30  Tor Lillqvist  <tml@iki.fi>

	* Makefile (install-data-hook): Use cp, not $(LN_S) on the .pc
	files. Configure on Win32 (running on Cygwin) thinks symlinks
	exist, but pkg-config is not necesarily a Cygwin program, and
	doesn't understand them.

Fri Nov  2 16:45:17 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkrbtree.c (_gtk_rbtree_remove_node): Clean up height code
	a bit.  I don't think it's completely correct yet, but it's
	getting there.

Fri Nov  2 16:14:15 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkviewport.c (gtk_viewport_size_request): Remove
	random + 5 for width and height. If people want padding,
	they should add padding. (Note the +5 isn't padding
	that will always appear - it just appears in the case
	where the widget is allocated it's requisition.)
	(#51018, Janet Davis)

Fri Nov  2 15:53:23 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimcontext.h (struct _GtkIMContextClass): Pad
	the structure for future expansion.

Fri Nov  2 15:30:34 2001  Owen Taylor  <otaylor@redhat.com>

	Patch from HideToshi Tajima (#51922)
	
	* gtk/gtkimmulticontext.c: Proxy set_use_preedit().

	* gtk/modules/input/gtkimcontextxim.[ch]: Implement
	set_use_preedit().
	
	* gtk/modules/input/gtkimcontextxim.[ch]: If we have
	to destroy the input context because we change the
	client window or use_preedit, make sure we empty
	the preedit string.

Fri Nov  2 14:55:53 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/{gtkcolorseldialog.c,gtkfilesel.c,gtkfontsel.c,
	gtkgamma.c,gtkmessagedialog.c}: Go to the GUP
	proposed ordering of buttons with [OK] in the lower
	right hand corner. Patch from Gregory Merchan,
	#56331.

Fri Nov  2 11:51:49 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtklabel.c (gtk_label_select_region_index): remove
	extraneous gtk_label_clear_layout (label)

2001-11-02  Sebastian Wilhelmi  <wilhelmi@ira.uka.de>

	* tests/makefile.msc, gtk/makefile.msc.in: Removed
	-DGTK_DISABLE_COMPAT_H.

	* docs/Changes-2.0.txt:
	s/GDK_DISABLE_COMPAT_H/GDK_DISABLE_DEPRECATED/

	* gtk/gtkcompat.h.in, gdk/gdkcompat.h: Removed from CVS.

Fri Nov  2 10:21:03 2001  Owen Taylor  <otaylor@redhat.com>

	* examples/**/Makefile.am: Convert to use pkg-config
	rather than gtk-config. (#53375, Skip Montanaro)

2001-11-02  Matt Wilson  <msw@redhat.com>

	* gtk/gtkdialog.c (find_child_by_response_id): remove totally
	broken unused, non-compiling, static function.

Fri Nov  2 08:17:06 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdialog.c (gtk_dialog_set_response_sensitive): 
	Iterate through children of the action area, not of
	the vbox. (#58278, Sergey Kuzminov)

2001-11-01  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktext.c (gtk_text_set_position): handle -1 argument in
	order to remove a workaround in Nautilus that forced
	GTK_ENABLE_BROKEN

	* gtk/gtkwidget.c (gtk_widget_modify_style): fix typos in the docs

Thu Nov  1 20:09:31 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c: Patch from George Lebl to 
	fix division by zero for full scroll bars. (#62114)

Thu Nov  1 19:56:40 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_main_do_event): ref/unref
	around gtk_widget_event() if we are going to
	set a flag afterwards. (#63464)

Thu Nov  1 19:44:48 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkiconfactory.c gtk/stock-icons/Makefile.am: 
	Actually add the missing/broken image icon as the
	image for the "missing image" stock icon.

Thu Nov  1 19:18:34 2001  Owen Taylor  <otaylor@redhat.com>

	* demos/gtk-demo/stock_browser.c (do_stock_browser): 
	Set a reasonable default height for the window.

	* demos/gtk-demo/stock_browser.c (id_to_macro): Fix
	bug where subsequent '-' weren't converted to '_'.
	(#59550, Matthias Clasen)

	* demos/gtk-demo/appwindow.c (menu_items): Don't right 
	justify the Help menu - just include a comment on
	how to do it. (#63539, 	Marius Andreiana)

	* gtk/gtkiconfactory.c (gtk_icon_set_get_sizes): Don't 
	list GTK_ICON_SIZE_INVALID.

	* demos/gtk-demo/stock_browser.c: Show the biggest available
	size, not a fixed size. (Often reported, including #63539, 
	Marius Andreiana)

Thu Nov  1 19:11:35 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkrbtree.c (gtk_rbtree_reorder_fixup): Fix reorder_fixup,
	#59583

	* gtk/gtktreeselection.c (gtk_tree_selection_set_mode): fix
	warning.

Thu Nov  1 16:54:00 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktypeutils.h: Make GtkFunction return boolean, not gint.
	(Daniel Elstner).

Thu Nov  1 16:20:56 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimcontext.[ch]: Add:
	  - A ::retrieve_surrounding signal that asks the widget for
	    context around the insertion point.
	  - A ::delete_surrounding signal that asks the widget to 
	    delete context aroudn the insertion point.
	  - gtk_im_context_set_context() for widgets to set context
	    around the insertion point in response to ::retrieve_context.
	  - gtk_im_context_get_context() for context to get context
	    around the insertion point

	* gtkmarshal.list: Add BOOL:INT,INT

	* gtk/gtkimmulticontext.c: Proxy the get_surrounding() /
	set_surrounding() methods, and the ::retrieve_surrounding /
	::delete_surrounding signals.

	* gtk/gtkentry.c gtk/gtktreeview.c: Hook up to the
	GtkIMContext::retrieve_surrounding / ::delete_surrounding
	signals.

Thu Nov  1 15:45:04 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_rows_reordered):
	it's amazing how well things work sometimes, even when they're
	completely wrong.

	* gtk/gtktreeview.c (gtk_tree_view_real_collapse_row): Fix bug
	where you could try to collapse a node w/o it having children.

	(gtk_tree_view_class_init): remove Shift L<->R as they already
	existed for expand/collapse.

Thu Nov  1 12:21:31 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_focus_to_cursor): Fix crash
	found by Matt Wilson.

Thu Nov  1 00:44:50 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_class_init): Support Shift,
	Control, and Shift|Control L<->R, #63475

Wed Oct 31 18:53:51 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodel.c (gtk_tree_row_ref_deleted_callback): fix
	infinite loop noticed by yosh.

2001-11-01  Michael Meeks  <michael@ximian.com>

	* gtk/gtksocket.c (gtk_socket_unrealize): unset the
	GTK_REALIZED flag so we don't re-enter when we are
	destroyed from the plug side.

Wed Oct 31 18:23:47 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkoptionmenu.c (gtk_option_menu_detacher): 
	Add a "menu" property and notify on it. (#62798,
	Padraig O'Briain)

	* gtk/gtkselection.[ch] gtk/{gtkentry.c, gtkfilesel.c,
	gtkoldeditable.c, gtktextbuffer.c, gtktextview.c}: 
	Fix set_text to take a gchar, not a guchar, and to have 
	a len argument.

Wed Oct 31 15:31:13 2001  Manish Singh  <yosh@gimp.org>

	* gtk/gtkstock.c: fix typo to make it compile

Wed Oct 31 17:27:20 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkcellrenderertext.c (gtk_cell_renderer_text_render): if
	the widget is insensitive, draw the text insensitively, #63306

2001-10-31  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkstock.c: Add stock items for most stock icons. (#61757)

Wed Oct 31 16:53:48 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreednd.c (gtk_tree_set_row_drag_data): rename
	gtk_selection_data_set_tree_row, #60218
	(gtk_tree_get_row_drag_data): rename
	gtk_selection_data_get_tree_row, #60218

	* gtk/gtktreemodel.c (gtk_tree_row_ref_deleted_callback): Actually
	get this right, after the third try, #63122.

2001-10-31  jacob berkman  <jacob@ximian.com>

	* gdk/gdkselection.h (GDK_TARGET_STRING): 
	(GDK_SELECTION_TYPE_STRING): these should be 31, not 3.  Hooray
	for Xatoms (and not using the XA_* macros)!

Wed Oct 31 15:38:14 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.[ch] (gtk_window_get_focus): Add a
	gtk_window_get_focus() getter to determine the currently
	focused widget within the window. (#63145, request
	from Damian Ivereigh)

Wed Oct 31 14:45:08 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkenums.h (enum): Add GTK_SELECTION_NONE enum, #61695

	* gtk/gtktreeselection.c (gtk_tree_selection_set_mode): Handle new
	GTK_SELECTION_NONE enum.
	(_gtk_tree_selection_internal_select_node): ditto

	* gtk/gtkcellrenderer.h (struct _GtkCellRendererClass): add
	constness.

	* gtk/gtkcellrenderertoggle.c: more yummy constness.

	* gtk/gtkclist.c (gtk_clist_set_selection_mode): g_return_if_fail
	if mode == GTK_SELECTION_NONE

Wed Oct 31 14:05:17 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_class_init): Added a
	"cursor_changed" signal, #62850.

2001-10-31  Matt Wilson  <msw@redhat.com>

	* gtk/gtktreedatalist.c (_gtk_tree_data_list_alloc): after
	allocating the treedatalist, zero it to make sure the values are
	cleared from any garbage that was in this chunk.

2001-10-31  Murray Cumming  <murrayc@usa.net>

	* gtk/cellrenderertext.h: "edited" default signal handler
	gchar* args are now const.
	gtk/cellrenderertoggle.h: "toggled" default signal handler
	gchar* arg is now const.
	Also changed other signal handlers for "edited" and "toggled" to
	have the same signature.

Tue Oct 30 19:17:57 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_sort_level): massize
	rewrite.  Static models now totally work.  I'm not 100% sure about
	row_inserted and row_changed, but I'll get those later.

2001-10-30  Sven Neumann  <sven@gimp.org>

	* configure.in: use GLIB_AC_DIVERT_BEFORE_HELP() so we get proper
	output for configure --help.

2001-10-30  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (changed_handler): Update the IM spot location
	here, if text was invalidated in the visible area, because the
	scroll offset doesn't normally change in that case, and the mark
	isn't set, just implicitly moved over as text is added/removed
	
Mon Oct 29 19:18:35 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkseparatormenuitem.c: Code cleanup.
	(gtk_separator_menu_item_class_init): Fix bugs in this code.

2001-10-29  jacob berkman  <jacob@ximian.com>

	* gdk/Makefile.am (LDFLAGS): 
	* gtk/Makefile.am (LDFLAGS): automake doesn't support conditionalized
	LDFLAGS, so put win32 flags in here

Mon Oct 29 15:41:58 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_sort_level): Darn.
	I can't believe this took this long to fix.

Mon Oct 29 13:54:49 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_rows_reordered): fix
	reordered signal.

Mon Oct 29 12:27:51 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (gtk_file_selection_rename_file): Grab
	the focus to the fileop entry for create dir / rename
	file. (#62838)

Mon Oct 29 12:21:49 2001  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Don't use AC_CHECK_FILE to check for a 
	file since it always spits warnings about cross compilation,
	use -f instead. It's not like we cross compile properly
	anyways.

	* configure.in (gtktargetlib): Move call to AC_PROG_CC
	to suppress autoconf warning.

	* acconfig.h: Add some missing #undefs from recent
	Win32 additions.

Mon Oct 29 11:31:40 2001  Owen Taylor  <otaylor@redhat.com>

	* m4macros/gtk-2.0.m4: Don't try to use pkg-config
	when we didn't find it. (#62944, Eric Lemings)

	* m4macros/gtk-2.0.m4: Fix problem with spaces around =
	sign in assignment. (#63209, Arkadiusz Miskiewicz)

2001-10-29  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktreeview.c (gtk_tree_view_size_request): Calculate
	the buttons size request before using it. Fixes #61696.

2001-10-29  Tor Lillqvist  <tml@iki.fi>

	* README.win32: Updates.

	* gtk-zip.sh.in: New file, used to build distribution package for
	Windows.

	* gdk/gdkglobals.c: Mark gdk_threads_mutex for DLL export when
	applicable with GDKVAR.

	* gdk/win32/libwntab32x.la: New file, hand-written wrapper for the
	Wintab library.

	* gdk/win32/gdkwin32.h
	* gdk/win32/gdkprivate-win32.h: Reorganise to match corresponding
	X11 headers better, and to enable gdkwin32.h to be installed and
	included from applications, but not the *-win32.h headers.

	* gdk/win32/*.c: Corresponding small changes, simplifications of
	#includes.
	
	* gdk/win32/gdkregion-win32.c: Remove.

	* gdk/win32/gdkevents-win32.c (print_event): Add GDK_SETTING.

	* gdk/win32/gdkfont-win32.c
	* gdk/win32/gdkgeometry-win32.c: Remove unused variables.

	* gdk/win32/gdkproperty-win32.c (gdk_atom_intern): Don't insert
	GDK_NONE values into hash table.

	* gtk/gtk.def: Update.

	* gtk/gtkfilesel.c: Include <winsock.h> (if available) for
	gethostname().

	* gtk/gtkmain.c 
	* gtk/gtkrc.c: (Win32) Save actual DLL name for later use in DLL
	entry function. Avoid hardcoded paths GTK_LIBDIR, GTK_SYSCONFDIR,
	GTK_DATA_PREFIX and GTK_LOCALEDIR, instead add functions that call
	g_win32_get_package_installation_subdirectory() with the actual
	DLL name saved above. Redefine above directory name macros to call
	these functions. Remove some ifdefs.

	* gtk/maketypes.awk: Output GTKTYPEBUILTINS_VAR (that marks
	variable for export on Win32) also to the _vars file.

	Changes for autoconfiscated build on Win32, and addition of Win32
	backend to the related files:
	
	* configure.in: Like in GLib, set LT_CURRENT_MINUS_AGE for use
	when forming DLL name in some files. Set MS_LIB_AVAILABLE is
	lib.exe is available. Call AC_LIBTOOL_WIN32_DLL. Set
	PLATFORM_WIN32, OS_WIN32 and USE_WIN32 automake conditionals. Add
	win32 target, using pangowin32. Don't use the
	-export-symbols-regex option on Win32, we use .def files to list
	exported symbols. Check <winsock.h> (for gethostname() in
	gtkfilesel.c). Enclose nested AC_CHECK_* macros in brackets to
	prevent premature m4 expansion.

	* acconfig.h: Add HAVE_WINTAB.

	* gdk/Makefile.am: Add libgdk-win32-1.3.la target and associated
	macros and rules. Use -no-undefined on Win32. Use gdk.def file. If
	MS_LIB_AVAILABLE, build MS import library. Install the import
	libraries. If HAVE_WINTAB, link with the Wintab library.

	* gdk/win32/Makefile.am: Actually enable building the win32
	objects here, not just list all files in EXTRA_DIST. Link in the
	compiled resource file from rc/gdk-win32res.lo. If HAVE_WINTAB,
	copy the Wintab library into the .libs directory. 

	* gdk/win32/gdkwindow-win32.c (RegisterGdkClass): Don't assume the
	name of the GDK DLL when fetching the icon. Use the HMODULE saved
	in gdk_dll_hinstance by DllMain.

	* gdk/win32/rc/Makefile.am: Build gdk-win32res.lo using the
	build/win32/lt-compile-resource script.

	* gdk/win32/rc/gdk.rc.in
	* gtk/gtk-win32.rc.in: Use the DLL name that libtool would use.

	* gtk/Makefile.am: Add libgtk-win32-1.3.la target and associated
	macros and rules. Use -no-undefined on Win32. Use gtk-win32.def
	file. Install import libraries.

2001-10-29  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkiconfactory.c (get_default_icons): Fix build.

2001-10-28  Hans Breuer  <hans@breuer.org>

	* gdk/gdk.c gdk/gdkevents.c
	  gdk/win32/gdkcolor-win32.c gdk/win32/gdkdnd-win32.c
	  gdk/win32/gdkdrawable-win32.c gdk/win32/gdkevents-win32.c
	  gdk/win32/gdkfont-win32.c gdk/win32/gdkgc-win32.c
	  gdk/win32/gdkim-win32.c gdk/win32/gdkmain-win32.c
	  gdk/win32/gdkprivate-win32.h gdk/win32/gdkproperty-win32.c
	  gdk/win32/gdkselection-win32.c gdk/win32/gdkwin32.h
	  gdk/win32/gdkwindow-win32.c gdk/win32/gdkwindow-win32.h :
	static correct-ness, underscore prefixing of library internal 
	functions
	(applied the undisputed and the win32 part. Of the latter 
	 I'm probably the one who will change it back again, if Owen
	 decides that the Gdk*Impl types should not be private to Gdk)

	* gdk/gdk.def : added the remaining exported functions

2001-10-28  Matthias Clasen  <matthiasc@poet.de>

	* gtk/gtkcellrenderertoggle.c, gtk/gtkimcontextsimple.c,
	gtk/gtkimmulticontext.c, gtk/gtkimagemenuitem.c,
	gtk/gtkiconfactory.c, gtk/gtkwindow.c: Documentation updates.

2001-10-28  jacob berkman  <jacob@ximian.com>

	* gtk/gtkcolorsel.c (gtk_color_selection_class_init): do not call
	gtk_settings_get_default() here as that requires an X connection
	(which breaks doc building with no X connection) and is not
	multihead safe
	(gtk_color_selection_init): delay palette loading until realize
	time
	(gtk_color_selection_realize): load the palette, and initialize
	the global palette if it hasn't been already

	* gtk/gtkpreview.c (gtk_preview_class_init): don't initialize the
	visual/cmap fields of klass->info since they are gone
	(gtk_preview_get_visual): just return gdk_rgb_get_visual ()
	(gtk_preview_get_cmap): just return gdk_rgb_get_colormap ()
	(gtk_preview_realize): don't set VISUAL and COLORMAP attributes

	* gtk/gtkpreview.h (struct _GtkPreviewInfo): remove visual and
	cmap fields
	(gtk_preview_get_visual):
	(gtk_preview_get_cmap): mark as deprecated

	* docs/Changes-2.0.txt: add a little note about the GtkPreviewInfo
	changes

Sun Oct 28 09:15:39 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimcontext.h (struct _GtkIMContext): Fixed
	structure to have GObject not GtkObject as
	parent_instance. (Jeff Franks.)

2001-10-27  Matthias Clasen  <matthiasc@poet.de>

	* gdk/x11/gdkinput.c: Typo fix.

2001-10-26  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (gtk_text_view_mark_set_handler): Call
	update_im_spot_location here explicitly
	(gtk_text_view_reset_im_context): don't update the spot location
	here

2001-10-27  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktreemodel.c (gtk_tree_model_get): Fix typo in docs.
	This fixes #62942.

	* gtk/gtkspinbutton.c (gtk_spin_button_new_with_range): 
	Clarify that we're returning a spin button in the _new function.
	This fixes #54097.
	
Fri Oct 26 20:55:57 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkbutton.c: Revert changes to GTK_RUN_LAST. 
	Unfortunately, people apparently erroneously connect
	to ::clicked for GtkToggleButton and expect
	they know what happened in the default signal handler
	instead of appropriately connecting to notification
	signal ::toggled. When the revolution comes, such
	people will be first against the wall.

	We'll just have to go back to the old less-reliable
	set-it-back hacks for handling model-view check
	buttons and radio buttons. :-(. 

2001-10-27  Hans Breuer  <hans@breuer.org>

	* gtk/gtkbbox.c gtk/gtkctree.c gtk/gtkhbbox.c
	  gtk/gtkimmulticontext.c gtk/gtklabel.c gtk/gtkliststore.c
	  gtk/gtkmenu.c gtk/gtkpaned.c gtk/gtkrc.c gtk/gtkscale.c
	  gtk/gtkstyle.c gtk/gtktextbuffer.c gtk/gtktextlayout.c
	  gtk/gtktexttag.c gtk/gtktexttagtable.c gtk/gtktextview.c
	  gtk/gtktreestore.c gtk/gtkvbbox.c : 
	to simplify parsing for exported functions:
	- made implementation signature static, when the local 
	  prototype already was
	- put the functions return value on it's own line
	- added as space between the function name and the 
	  opening bracket

	* gtk/gtk.def : added the remaining exported functions

2001-10-27  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_set_fixed_width): 
	Add note about width having to be greater than 0. This fixes
	#55574. 

	* gtk/gtktextiter.c (gtk_text_iter_backward_sentence_start): 
	Fix docs to say previous instead of next.
	(gtk_text_iter_backward_word_start): Likewise.
	This fixes bug #62980.

	* gtk/gtkcontainer.c (gtk_container_set_border_width): Mention
	that the valid width is in range 0-65535 pixels. Fixes bug 
	#56754.

	* gtk/gtksizegroup.c (gtk_size_group_set_mode): Remove
	a dot in the documentation. Fixes bug #62632.

	* gdk/x11/gdkmain-x11.c: Replace int and guint with
	long and gulong in some places to make the code 64-bit
	clean.
	(_gdk_windowing_init_check): Replace gint with gulong.
	This patch was made by George Lebl and fixes bug #62113.

	* tests/testgtk.c (create_range_controls): Don't set a 
	fixed height on the hscale widget. This fixes "bug" 
	#55840.
	(create_window_states): Set up destroy signals so that
	all windows will be destroyed when one is. This fixes 
	bug #58133.

2001-10-26  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktreeview.c: 
	(gtk_tree_view_class_init): Create new "indent_expander"
	style property.

	(gtk_tree_view_get_arrow_xrange): Add a tree argument
	to the function since the xrange can change depending
	on where in the tree we are. 
	
	(coords_are_over_arrow): Update function call to
	gtk_tree_view_get_arrow_xrange.
	(gtk_tree_view_draw_arrow): Likewise.
	
	(gtk_tree_view_real_expand_collapse_cursor_row):
	Call real_{expand|collapse}_row, so that we'll have an
	animation.

Fri Oct 26 20:13:36 2001  Kristian Rietveld  <kristian@planet.nl>

	* tests/Makefile.am: fixed a small typo

Fri Oct 26 18:27:11 2001  Kristian Rietveld  <kristian@planet.nl>

	* demos/gtk-demo/list_store.c (create_model): Anders
	Carlsson suggested to use G_N_ELEMENTS here

2001-10-26  Sven Neumann  <sven@gimp.org>

	* gtk/gtkbutton.[ch]
	* gtk/gtkdnd.c: fixed inline comments
	
	* gtk/gtkgamma.c: gtk_entry_get_text() returns a const gchar.

2001-10-26  Hans Breuer  <hans@breuer.org>

	* gdk-pixbuf/gdk_pixbuf.def : 
	* gdk/gdk.def : 
	* gtk/gtk.def : updated externals

	* gdk/win32/gdkpixmap-win32.c : removed duplicate of
	gdk_window_lookup implementation. It already was in
	gdk/win32/gdkwindow-win32.c

	* gdk/win32/gdkproperty-win32.c : made it compile again
	after GdkAtom API change

	* gtk/gtk/makefile.msc.in : updated

Wed Oct 24 11:36:33 2001  Owen Taylor  <otaylor@redhat.com>

	* configure.in (GTK_MICRO_VERSION): Version 1.3.10,
	require GLib 1.3.10.

	* NEWS: updates.

Thu Oct 25 16:27:29 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkrbtree.c (_gtk_rbnode_rotate_left): Add support for
	invalid nodes.
	 (_gtk_rbnode_rotate_right): Ditto.
	 (_gtk_rbtree_node_mark_invalid): New function.
	 (_gtk_rbtree_node_mark_valid): New function.

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_class_init): We're a
	GObject, not a GtkObject.
	(gtk_tree_model_sort_row_has_child_toggled): Rewrote to be more
	correct.
	(gtk_tree_model_sort_row_deleted): ditto.
	(gtk_tree_model_sort_{un,}ref_node): Fix.

	* gtk/gtktreeview.c: Protean incremental reflow support (commented
	out)

	* gtk/gtktreeview.h (GtkTreeViewSearchEqualFunc): change char *key
	to const char *key.

	* gtk/gtktreemodel.c (gtk_tree_row_reference_unref_path_helper):
	Important 1 line fix to fix a lot of refcounting woes.

2001-10-25  Matt Wilson  <msw@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_destroy): call
	gtk_text_view_destroy_layout after gtk_text_view_set_buffer (which
	now invalidates) so that we remove our idle functions.
	(gtk_text_view_destroy_layout): remove the first_validate_idle as
	well.

	* gtk/gtktexttag.c (gtk_text_tag_class_init): the valid range for
	the 'indent' property is G_MININT to G_MAXINT.  Don't use
	-G_MAXINT for the minimum of the 'rise' property, use G_MININT
	instead.

2001-10-24  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktreeview.c: 
	(gtk_tree_view_real_expand_row): add an animate argument
	(gtk_tree_view_real_collapse_row): likewise
	
	(gtk_tree_view_button_press), (gtk_tree_view_button_release), 
	(gtk_tree_view_collapse_all), (gtk_tree_view_expand_row),
	(gtk_tree_view_collapse_row): update functions that call
	real_{expand|collapse}_row to set the animate argument 
	accordingly.
	
2001-10-24  Alex Larsson  <alexl@redhat.com>

	* gdk/linux-fb/gdkfont-fb.c:
	Update to new Pango APIs

	* gdk/linux-fb/gdkproperty-fb.c:
	Update to new GdkAtom APIs

	* gdk/linux-fb/gdkwindow-fb.c:
	Remove warnings

Mon Oct 22 20:07:21 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreestore.c (gtk_tree_store_prepend): Fix docs, #62808

Wed Oct 24 22:54:07 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_row_inserted): treat
	s_path as a child path

Wed Oct 24 20:29:47 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtktreemodelsort.c: more changes in an attempt to get
	it right. It's not yet ready for general consumption.

	* tests/treestoretest.c: add a button and entry for the new
	iter_change function
	(iter_change): new function, to test
	the row_changed signal implementation of the GtkTreeModelSort

	* tests/testtreesort.c: cleanups, changes to test more features
	of the GtkTreeModelSort at once

2001-10-24  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextbuffer.c (clipboard_clipboard_buffer_received):
	remove hack to strip off the bogus newline, since we killed the
	bogus newline; fixes #61779

2001-10-24  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_update_adjustments): don't
	create layout if we didn't have one
	(gtk_text_view_set_buffer): invalidate so we get the idle handlers
	as appropriate, avoids blanking the screen 
	(gtk_text_view_invalidate): new function to do invalidation,
	containing old guts of invalidated_handler

Wed Oct 24 10:29:47 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkalignment.c (gtk_alignment_class_init): Improve
	dreadful tooltips.

Tue Oct 23 17:31:42 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c gdk/win32/gdkwindow-win32.c: Always 
	set window->parent (except or the root window itself); if 
	the window's parent is not a GdkWindow, or is a window of 
	type GDK_WINDOW_FOREIGN, set window->parent to the root parent.

	* gdk/gdkwindow.c (gdk_window_get_toplevels): Don't include
	windows of type GDK_WINDOW_FOREIGN.

2001-10-24  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextiter.c (gtk_text_iter_backward_chars): if we move to
	the front of a segment, use the "slow" technique for moving
	backward, so we don't mess up the any_segment field in the iter. 
	Fixes #57707

	* tests/testtextbuffer.c: add code to detect #57707, to avoid
	regression

2001-10-23  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (popup_targets_received): only sensitize Cut
	if selection contains some editable text, #60975
	(gtk_text_view_scroll_to_iter): remove warning about scrolling
	prior to map; it should actually be OK to do so in many cases, 
	it would be nice to warn about scrolling when many lines have
	height 0, but I don't know what to do about that. Perhaps 
	move part of flush_scroll into this function? comment added 
	to consider this.

2001-10-23  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (changed_handler): Correctly keep the same
	text on the top of the screen, considering that the changed region
	may have overlapped the first paragraph. Should fix msw's "text
	widget scrolled to wrong place on map" bug, and probably some
	other scrolling cases as well.
	(gtk_text_view_set_scroll_adjustments): start adjustments at 0.0, 
	instead of some random value

	* gtk/gtktextview.c (gtk_text_view_class_init): actually override
	grab_focus, so #59708 is really fixed

2001-10-24  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkentry.c: (append_action_signal): Use an image menu item here
	(popup_targets_received): Call append_action_signal with stock items
	
	* gtk/gtklabel.c: (append_action_signal): Use an image menu item here
	(gtk_label_do_popup): Call append_action_signal with stock items
	
	* gtk/gtktextview.c: (append_action_signal): Use an image menu item here
	(popup_targets_received): Call append_action_signal with stock items

2001-10-23  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (changed_handler): queue a resize here; will
	temporarily slow down the widget a lot, until we figure out how to
	optimize to avoid full redraw everytime we queue a resize.

2001-10-23  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextiter.c (test_log_attrs): handle case where offset ==
	0 and char_len == 0, bug #61729

2001-10-23  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextiter.c (gtk_text_iter_forward_cursor_positions): fix
	return value, #61714 (Vitaly Tishkov)
	(gtk_text_iter_backward_sentence_starts): ditto
	(gtk_text_iter_backward_word_starts): ditto
	(gtk_text_iter_forward_word_ends): ditto
	(gtk_text_iter_forward_sentence_ends): ditto
	(gtk_text_iter_backward_cursor_positions): ditto

2001-10-23  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextlayout.c (gtk_text_layout_get_iter_at_pixel): Apply
	fix from Dov Grobgeld, #61858

2001-10-23  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_update_im_spot_location): 
	Update IM spot location at appropriate times, #50626
        (Hidetoshi Tajima)

2001-10-23  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_grab_focus): scroll to cursor
	on grab focus, unless it's caused by button click, #59708

Tue Oct 23 11:53:00 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am (INCLUDES): Remove G_DISABLE_CONST_RETURNS.

	* gtk/gtkfontsel.[ch]: Make gtk_font_selection_get_font()
	G_CONST_RETURN. (Murray Cumming)	

	* gtk/gtkfontsel.c (gtk_font_selection_dialog_get_preview_text):
	Make G_CONST_RETURN.

	* gtk/gtkfilesel.c (open_user_dir): Fix bug with freeing
	results of g_get_home_dir().

	* gtk/gtkfilesel.c: Make filesel->fileop_file a duplicated 
	copy. Storing the return from gtk_entry_get_text() is evil.

	* gtk/gtkcombo.c gtk/gtkcellrenderertext.c gtk/gtkbindings.c 
	gtk/gtkfilesel.c gtk/gtkfontsel.c gtk/gtkimmodule.c 
	gtk/gtkobject.c gtk/gtkoldeditable.c gtk/gtktreedatalist.c
	gtk/gtksignal.c: Add const.

	* gdk/x11/gdkkeys-x11.c (get_direction): Add missing const.

	* gtk/gtktreeview.c: Namespace object data keys to be safe, even 
	if we are setting them on private widgets.

	* gtk/gtktreeview.c (gtk_tree_view_real_start_interactive_search): 
	Duplicate entry->text before setting it as object data.

2001-10-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextbuffer.c (gtk_text_buffer_place_cursor): don't back
	up a char from the end iterator, fixes #61859 ("can't put cursor
	at the end of the buffer")

	* gtk/gtktextiter.c (gtk_text_iter_forward_to_line_end): fix this
	to work with delimiters other than newline.

	* tests/testtextbuffer.c: add some tests for get_chars_in_line,
	get_bytes_in_line

	* gtk/gtktextiter.c (gtk_text_iter_get_chars_in_line): fix for the
	last line, since the newline is no longer counted.
	(gtk_text_iter_get_bytes_in_line): ditto

2001-10-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextbtree.c (_gtk_text_btree_insert): add assertion that 
	#58290 would trigger if it reappeared, I think

2001-10-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextiter.c (_gtk_text_iter_forward_indexable_segment):
	add temporary code to dump btree contents on assertion failure
	described in #62656
	
	* gtk/gtktextbtree.c (ensure_end_iter_segment): add some
	assertions that we're getting the right end iter segment

	* gtk/gtktextiter.c (_gtk_text_iter_forward_indexable_segment):
	verify that we aren't on the end iterator after moving 
	forward one segment - fixes return value in an obscure case. 
	Also, some trivial code cleanup/rearranging.
	
2001-10-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextlayout.h: add a #error unless you define
	GTK_TEXT_USE_INTERNAL_UNSUPPORTED_API, so people don't use this accidentally

        * gtk/gtktext*.c: #define GTK_TEXT_USE_INTERNAL_UNSUPPORTED_API as appropriate.
	
2001-10-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_get_border_window_size): fix 
	#62365

2001-10-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_get_window_type): fix 
	#62436

2001-10-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_set_border_window_size): Fix 
	#62366

Mon Oct 22 11:47:47 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c: Add cursor-position, selection-bound 
	properties. (#62148, reported by Padraig O'Briain)

	* gtk/gtkentry.c (gtk_entry_class_init): Rename text_position
	to cursor_position. (1.3.x addition, text_position is an awful
	name.) Make cursor_position read-only to avoid sticky questions
	of interaction with selection_bound. (#62636, reported by
	Padraig O'Briain)

Mon Oct 22 16:25:12 2001  Owen Taylor  <otaylor@redhat.com>

	Fixing popup menus to have "Paste" sensitized correctly. Original
	patches from Damian Ivereigh, much mangled.

	* gtk/gtkselection.c: Add functions gtk_selection_data_get_targets(),
	gtk_selection_data_targets_include_text(). (#60854)

	* gtk/gtkclipboard.c: Add a simple do-it-all non-async "check if
	the clipboard has text" function gtk_clipboard_wait_is_text_available.
	(#60854)

	* gtk/gtkentry.c: Only enable the paste item if the clipboard
	contains text. (#60973)

	* gtk/gtktextview.c: Only enable the paste item if the clipboard
	contains text. (#60975)

2001-10-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_class_init): rip out
	"height_lines" and "width_columns" properties, it doesn't make
	sense to set the size request on a text view really. #62103

Mon Oct 22 15:17:05 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreestore.c (gtk_tree_store_iter_depth): Realized
	g_node_depth is broken, and that it's not worth being consistent
	with it.

2001-10-22  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextiter.c (gtk_text_iter_set_line): Clarify behavior in
	docs, #61777
	(gtk_text_iter_forward_search) (gtk_text_iter_backward_search):
	change the two boolean args to a flags field, so we can extend 
	to add case insensitive, regexp searches later. #61852

Mon Oct 22 15:07:17 2001  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreestore.c (gtk_tree_store_iter_depth): update docs to
	reflect reality, #62810

Mon Oct 22 14:08:26 2001  Jonathan Blandford  <jrb@redhat.com>

	* demos/gtk-demo/appwindow.c: Remove handle_box from App demo.

	* gtk/gtktreeview.c (size_allocate): Move to a different drawing
	system.  Instead of having a window the size of the tree, we have
	a window the size of widget->allocation, and simply draw with the
	offset.
	(coords_are_over_arrow): ditto.  Move to window coordinates.
	(do_prelight): ditto
	(do_unprelight): ditto

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_rows_reordered):
	Minor fix from Kristian Rietveld to fix unsorted case.

2001-10-22  jacob berkman  <jacob@ximian.com>

	* gtk/gtkclist.c (cell_size_request): don't cast a PIXTEXT cell to
	a PIXMAP cell (fixes crash when using PIXTEXT cells)

Sat Oct 20 18:58:25 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.h: Deprecate gtk_entry_set_editable.
	(#58768, Vitaly Tishkov)
	
	* gtk/gtkobject.h: Deprecate with abandon. 
	(#61942, Vitaly Tishkov, Matthias Clasen)

	* gtk/gtksignal.h: Deprecate everything.

	* gtk/gtkmain.h (GTK_PRIORITY_INTERNAL): Deprecate
	all GTK_PRIORITY_* defines other than GKT_PRIORITY_RESIZE>
	(#61942, Matthias Clasen)

	* gtk/gtkstyle.h: Deprecate gtk_draw_*. (#61140,
	Havoc Pennington)

	* gtk/gtkitemfactory.h: Deprecate compat functions
	for GtkMenuFactory code. (#62071)

	* gdk/gdkdrawable.h: Deprecate gdk_draw_string,
	gdk_draw_text,gdk_draw_text_wc. (#62071)

Mon Oct 22 10:12:08 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c docs/Changes-2.0.txt (gdk_threads_init): Don't call
	g_thread_init(), we don't want to link to -lgthread if we don't
	have to.

Mon Oct 22 08:51:02 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.[ch] (gdk_threads_init) docs/Changes-2.0.txt: 
	Add a function, gdk_threads_init() that must be explicitely 
	called to enable the GDK thread mutex.

2001-10-22  Jakub Steiner <jimmac@ximian.com>

	* gtk/stock-icons/stock_stop.png: no body parts
	
Sun Oct 21 23:27:00 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_translate_coordinates): Fix
	problem with g_return_if_fail return value.

 	* gdk/x11/gdkproperty-x11.c docs/Changes-2.0.txt: Move over the 
	virtual atom code from the gdk-multihead branch, removing the per-display
	part. Virtualizing atoms needs to be done now to prevent compat
	breakage in direct Xlib accessing code in the future. (#62208)
 
 	* gdk/x11/gdkx.h: gdk/gdk/x11/gdkproperty-x11.c: Export
 	gdk_x11_xatom_to_atom, gdk_x11_atom_to_xatom().
 
	* gdk/gdktypes.h docs/Changes-2.0.txt: Make GdkAtom
	an opaque pointer type so the compiler catches attempts
	to mingle it with X atoms.

	* gdk/x11/{gdkdnd-x11.c,gdkevents-x11.c,gdkglobals-x11.c,
	  gdkkeys-x11.c, gdkmain-x11.c, gdkprivate-x11.c, 
	  gdkproperty-x11.c, gdkselection-x11.c, gdkwindow-x11.c}
	  gtk/{gtkclist.c,gtkctree.c,gtkdnd.c,gtkplug.c,gtksocket.c}
	  tests/testdnd.c,tests/testselection.c: 
	Fix up for above atom changes.

	* gdk/gdkselection.h (GDK_SELECTION_CLIPBOARD): Add, since we
	now have the ability to add custom predefines.

	* gtk/{gtkentry.c,gtklabel.c,gtkoldeditable.c,gtktextview.c}:
	Use GDK_SELECTION_CLIPBOARD instead of GDK_NONE in calls
	to gtk_clipboard_get().

	* gdk/win32/gdkproperty-win32.c: Add CLIPBOARD, fix up
	for GdkAtom => pointer change.

	* gdk/linux-fb/gdkproperty-fb.c: Fix handling of predefined
	atoms, fix for GdkAtom => pointer change.

Mon Oct 22 00:26:46 2001  Kristian Rietveld  <kristian@planet.nl>

	* gtk/gtkspinbutton.c: remove ARROW_SIZE constant, use
	new function spin_button_get_arrow_size() instead.

